Package: TBSignatureProfiler
Title: Profile RNA-Seq Data Using TB Pathway Signatures
Version: 1.24.0
Authors@R: c(
    person("Kiloni", "Quiles", , "kiloni.quiles@rutgers.edu", role = c("cre"), 
            comment = c(ORCID = "0000-0002-7521-5255")),
    person("Aubrey R.", "Odom", , "aodom@bu.edu", role = c("aut", "dtm"),
           comment = c(ORCID = "0000-0001-7113-7598")),
    person("David", "Jenkins", , "dfj@bu.edu", role = c("aut", "org"),
           comment = c(ORCID = "0000-0002-7451-4288")),
    person("Xutao", "Wang", , "xutaow@bu.edu", role = "aut"),
    person("Yue", "Zhao", , "yuezh@bu.edu", role = "ctb",
           comment = c(ORCID = "0000-0001-5257-5103")),
    person("Christian", "Love", , "clove@bu.edu", role = "ctb"),
    person("W. Evan", "Johnson", , "wej@bu.edu", role = "aut")
  )
Description: Gene signatures of TB progression, TB disease, and other TB
    disease states have been validated and published previously. This
    package aggregates known signatures and provides computational tools
    to enlist their usage on other datasets. The TBSignatureProfiler makes
    it easy to profile RNA-Seq data using these signatures and includes
    common signature profiling tools including ASSIGN, GSVA, and ssGSEA.
    Original models for some gene signatures are also available.  A shiny
    app provides some functionality alongside for detailed command line
    accessibility.
License: MIT + file LICENSE
URL: https://github.com/wejlab/TBSignatureProfiler,
        https://wejlab.github.io/TBSignatureProfiler-docs/
BugReports: https://github.com/wejlab/TBSignatureProfiler/issues
Depends: R (>= 4.4.0)
Imports: ASSIGN (>= 1.23.1), BiocParallel, ComplexHeatmap, DESeq2, DT,
        edgeR, gdata, ggplot2, glmnet, GSVA (>= 1.51.3), HGNChelper,
        magrittr, methods, pROC, RColorBrewer, reshape2, ROCit,
        S4Vectors, singscore, stats, SummarizedExperiment, tibble
Suggests: BiocStyle, caret, circlize, class, covr, dplyr, e1071,
        impute, knitr, lintr, MASS, plyr, randomForest, rmarkdown,
        shiny, spelling, sva, testthat
VignetteBuilder: knitr
biocViews: GeneExpression, DifferentialExpression
Encoding: UTF-8
Language: en-US
LazyData: TRUE
Roxygen: list(markdown = TRUE)
RoxygenNote: 7.3.2
git_url: https://git.bioconductor.org/packages/TBSignatureProfiler
git_branch: RELEASE_3_23
git_last_commit: 4755e55
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-29 01:06:58 UTC; biocbuild
Author: Kiloni Quiles [cre] (ORCID: <https://orcid.org/0000-0002-7521-5255>),
  Aubrey R. Odom [aut, dtm] (ORCID:
    <https://orcid.org/0000-0001-7113-7598>),
  David Jenkins [aut, org] (ORCID:
    <https://orcid.org/0000-0002-7451-4288>),
  Xutao Wang [aut],
  Yue Zhao [ctb] (ORCID: <https://orcid.org/0000-0001-5257-5103>),
  Christian Love [ctb],
  W. Evan Johnson [aut]
Maintainer: Kiloni Quiles <kiloni.quiles@rutgers.edu>

## TBSignatureProfiler <img src="https://github.com/wejlab/TBSignatureProfiler-docs/blob/master/lungs1.png?raw=true" align="right" width="170" />

[![](https://img.shields.io/badge/bioconductor-3.21-blue)](http://www.bioconductor.org/packages/release/bioc/html/TBSignatureProfiler.html)
[![codecov](https://codecov.io/gh/wejlab/TBSignatureProfiler/branch/master/graph/badge.svg)](https://codecov.io/gh/wejlab/TBSignatureProfiler)
[![build](http://www.bioconductor.org/shields/build/devel/bioc/TBSignatureProfiler.svg)](http://bioconductor.org/checkResults/devel/bioc-LATEST/TBSignatureProfiler/)

## What is the TBSignatureProfiler?
The TBSignatureProfiler (TBSP) is an easy-to-use R package for analysis of RNA-seq data using gene signatures for tuberculosis disease presence, risk, progression, treatment failure, and other states. In-package signature profiling is available using common gene set enrichment tools that include GSVA, singscore, and ssGSEA.

Users can analyze RNA-seq data across 70+ published gene signatures to compare signature performance with clear visualizations (e.g., heatmaps and ROC plots), specificity/sensitivity estimates for predicting binary variables, and cross-validated logistic regression.

The TBSP can be used as a standalone software package. Data exploration is also available with the accompanying interactive R Shiny application. The R Shiny app is currently functional but more limited in its capabilities than the command line form of the package.

## Documentation

Please check our website at https://wejlab.github.io/TBSignatureProfiler-docs/.

## Citation

We used the TBSP to compare 45 gene signatures and differentiate active TB from LTBI in malnourished individuals from India. You can read our paper here: [“Comparing tuberculosis gene signatures in malnourished individuals using the TBSignatureProfiler”](
https://bmcinfectdis.biomedcentral.com/articles/10.1186/s12879-020-05598-z)

Please cite:

**Johnson, W.E., Odom, A., Cintron, C. et al. Comparing tuberculosis gene signatures in malnourished individuals using the TBSignatureProfiler. BMC Infect Dis 21, 106 (2021).**

## Installation

The TBSignatureProfiler requires R Version 4.2.

* Install the development version of the package from Github:

``` r
if (!requireNamespace("devtools", quietly = TRUE))
  install.packages("devtools")
devtools::install_github("wejlab/TBSignatureProfiler")
```

* Install the release version of the package from Bioconductor:

``` r
if (!requireNamespace("BiocManager", quietly = TRUE))
  install.packages("BiocManager")
BiocManager::install("TBSignatureProfiler")

```

* Run the TBSP R Shiny app!
``` r
library(TBSignatureProfiler)
TBSPapp()
```

#' Introduce a new signature into the TBSignatureProfiler.
#'
#' This function allows users to integrate new signatures into the TBSP
#' with a function that updates the TBsignatures, TBcommon,
#' sigAnnotData and common_sigAnnotData objects. Users that wish to use this
#' function should do so with the downloaded package as a working directory,
#' and not as a casual package function. This function does not complete all
#' required updates to the package for a signature to be full added; users
#' should check the vignette "Submitting Signatures to the TBSP Package"
#' on the
#' [TBSP website](https://wejlab.github.io/TBSignatureProfiler-docs/.)
#' for a walkthrough of this complete process.
#' Also note that this function only adds one signature at a time,
#' and must me run multiple times to add subsequent signatures.
#'
#' @param sigsymbols a \code{character vector} of the gene symbols that compose
#' the signature to be added. Required.
#' @param authname a \code{character} string containing the last name of the primary
#' author of the publication where the signature was first identified.
#' If spaces are present, omit them, and use proper capitalization. Required.
#' @param signame_common a \code{character} string of the alternate name of the
#' signature given by the publication, if it exists. If \code{NULL}, no
#' assigned name is assumed to exist. Default is \code{null}.
#' @param sigtype a \code{character} string that gives the context that the
#' signature was developed under. Most commonly,
#' it will distinguish TB from LTBI ("Disease"),
#' TB from some combination of other diseases and possibly LTBI
#' ("Disease/Other Diseases"), TB from Human Immunodeficiency Virus
#' ("Disease/HIV"), TB from pneumonia ("Disease/Pneumonia"),
#' or identify risk of progression to TB ("risk"), risk of TB treatment
#' failure ("failure"), or classify treatment responses
#' (i.e., failures from cures, "response"). Required.
#' @param tissuetype a \code{character} string that denotes whether the
#' signature was developed using samples of either whole blood/paxgene
#' ("whole blood") or peripheral blood mononuclear cells ("PBMC").
#' Due to the manipulation of cells inherently required to obtain PBMCs,
#' many scientists prefer to use only whole blood samples for analysis.
#' Accepts "whole blood", "PBMC" or "mixed". Required.
#' @param saveobjs \code{logical}. If \code{TRUE}, the contents of the data
#' file (\code{TBsignatures}, \code{TBcommon}, \code{sigAnnotData},
#' \code{common_sigAnnotData}) will be overwritten and updated to include
#' the new signature. If \code{FALSE}, no files will be overwritten, but
#' you can check function output for errors before writing RDS objects
#' by setting \code{views = TRUE}. Default is \code{saveobjs = FALSE}.
#' @param views logical. If \code{TRUE}, all objects will be sent to a
#' data view in a new window to check for errors. Default is \code{TRUE}.
#'
#' @return Either data objects \code{TBsignatures}, \code{TBcommon},
#' \code{sigAnnotData}, and \code{common_sigAnnotData} will be updated with the
#' new signature and overwritten if \code{saveobjs = FALSE}, or no output will
#' be produced except errors and messages for checking that the function
#' runs correctly given the inputs.
#'
#' @examples
#' # Mock example signature
#' TBSignatureProfiler:::addTBsignature(sigsymbols = c("GBP5", "BATF2", "GZMA"),
#'                             authname = "Odom",
#'                             signame_common = NULL,
#'                             sigtype = "Disease/HIV",
#'                             tissuetype = "PBMC",
#'                             saveobjs = FALSE,
#'                             views = FALSE)

addTBsignature <- function(sigsymbols, authname,
                         signame_common = NULL, sigtype, tissuetype,
                         saveobjs = FALSE, views = TRUE) {
  # Checks and renaming
  if (!is.character(sigsymbols)) {
    stop("'sigsymbols' must be a character vector.")
  } else if (!is.character(authname)) {
    stop("'authname' must be a character string.")
  } else if (length(sigsymbols) <= 1) {
    stop("Currently the TBSP only accepts gene signatures with 2 or more ",
               "gene symbols.")
  } else if (!is.logical(saveobjs)) {
    stop("'saveobjs' must be logical.")
  }

  diseasetypes <- c("Disease", "Disease/HIV", "Disease/Other Diseases",
                    "Disease/Pneumonia", "failure", "response", "risk")
  replacetypes <- c("Disease", "HIV", "OD", "PNA", "FAIL", "RES", "RISK")
  if (!(sigtype %in% diseasetypes)) {
    stop("Input string for 'sigtype' not recognized. You must denote ",
    "'sigtype' as one of the following: 'Disease', 'Disease/HIV', ",
    "'Disease/Other Diseases', 'Disease/Pneumonia', 'failure', ",
    "'response', 'risk'")
  } else {
    sigtype <- replacetypes[which(sigtype == diseasetypes)]
  }

  alltissues <- c("mixed", "PBMC", "whole blood")
  if (!(tissuetype %in% alltissues)) {
    stop("'tissuetype' must be one of the following: ",
         "'mixed', 'PBMC', 'whole blood'")
  } else if (tissuetype == "whole blood") tissuetype <- "whole"

  # Create signature name
  ngenes <- length(sigsymbols)
  if (sigtype == "Disease") {
    signame_TBSP <- paste(authname, ngenes, sep = "_")
  } else signame_TBSP <- paste(authname, sigtype, ngenes, sep = "_")

  if (nchar(signame_TBSP) > 17) {
    howmanyletters <- 17 - (2 + nchar(as.character(ngenes)) + length(sigtype))
    stop("Resulting signature name is too long. ",
         "Please shorten or abbreviate authname to ", howmanyletters,
         " characters.")
  } else if (signame_TBSP %in% names(TBsignatures)) {
    stop("There is already a signature with that name. ",
         "Please alter the authname to distinguish it from the previous ",
         "signature.")
  } else message("The assigned signature name is ", signame_TBSP)

  if (is.null(signame_common)) {
    message("No alternative signature name was provided")
    signame_common <- signame_TBSP
  } else message("Note: 'signame_common' differs from 'signame_TBSP'")

  # Add signature to TBsignatures
  TBsignatures$`NEWSIG` <-  sigsymbols
  names(TBsignatures)[names(TBsignatures) == "NEWSIG"] <- signame_TBSP
  # Alphabetize
  index <- order(names(TBsignatures))
  new_names <- names(TBsignatures)[index]
  TBsignatures <- TBsignatures[new_names]
  # Save new object
  if (saveobjs) save(TBsignatures, file = "data/TBsignatures.rda")
  if (views) print(names(TBsignatures))
  message("TBsignatures object updated")

  # Add signature to TBcommon
  TBcommon$`NEWSIG` <-  sigsymbols
  names(TBcommon)[names(TBcommon) == "NEWSIG"] <- signame_common
  # reorder names
  new_names <- names(TBcommon)[index]
  TBcommon <- TBcommon[new_names]
  if (saveobjs) save(TBcommon, file = "data/TBcommon.rda")
  if (views) print(names(TBcommon))
  message("TBcommon object updated")

  # Add to annotation to sigAnnotData
  newrow <- c("names" = signame_TBSP, "disease" = sigtype,
              "tissue_type" = tissuetype)
  sigAnnotData <- as.data.frame(rbind(sigAnnotData, newrow))[index, ]
  sigAnnotData$disease <- as.factor(sigAnnotData$disease)
  sigAnnotData$tissue_type <- as.factor(sigAnnotData$tissue_type)
  rownames(sigAnnotData) <- seq_len(nrow(sigAnnotData))
  if (all(sigAnnotData$names != names(TBsignatures))) {
    stop("The names in the sigAnnotData do not match the order ",
         "and/or names of the TBsignatures object.")
  } else if (saveobjs) save(sigAnnotData, file = "data/sigAnnotData.rda")
  if (views) print(sigAnnotData)
  message("sigAnnotData object updated")

  # Add annotation to sigAnnotData_common
  newrow <- c("names" = signame_common, "disease" = sigtype,
              "tissue_type" = tissuetype)
  common_sigAnnotData <- as.data.frame(rbind(common_sigAnnotData,
                                             newrow))[index, ]
  common_sigAnnotData$disease <- as.factor(common_sigAnnotData$disease)
  common_sigAnnotData$tissue_type <- as.factor(
    common_sigAnnotData$tissue_type)
  rownames(common_sigAnnotData) <- seq_len(nrow(common_sigAnnotData))
  if (all(common_sigAnnotData$names != names(TBcommon))) {
    stop("The names in the common_sigAnnotData table do not match ",
         "the order and/or names of the TBcommon object.")
  } else if (saveobjs) save(common_sigAnnotData,
                            file = "data/common_sigAnnotData.rda")
  if (views) print(common_sigAnnotData)
  message("common_sigAnnotData updated")

  if (saveobjs) message("All objects updated and saved to data folder.")
}

context("test-addTBsignature")


test_that("Run addTBsignature", {
  expect_message(
    addTBsignature(sigsymbols = c("APOL1", "BATF2", "ETV7"),
                   authname = "Katarvi", signame_common = NULL,
                   sigtype = "Disease", tissuetype = "PBMC",
                   saveobjs = FALSE, views = FALSE)
  )
  expect_message(
    addTBsignature(sigsymbols = c("APOL1", "BATF2", "ETV7"),
                   authname = "Katarvi", signame_common = "KAT3",
                   sigtype = "Disease/HIV", tissuetype = "whole blood",
                   saveobjs = FALSE, views = FALSE)
  )
})

test_that("Warnings", {
  expect_error(addTBsignature(sigsymbols = c(1, 2, 3),
                              authname = "Katarvi", signame_common = "KAT3",
                              sigtype = "Disease/HIV", tissuetype = "PBMC",
                              saveobjs = FALSE, views = FALSE),
               paste("'sigsymbols' must be a character vector.")
  )
  expect_error(addTBsignature(sigsymbols = c("APOL1", "BATF2", "ETV7"),
                              authname = 1, signame_common = "KAT3",
                              sigtype = "Disease/HIV", tissuetype = "PBMC",
                              saveobjs = FALSE, views = FALSE),
               paste("'authname' must be a character string.")
  )
  expect_error(addTBsignature(sigsymbols = c("APOL1"),
                              authname = "Katarvi", signame_common = "KAT3",
                              sigtype = "Disease/HIV", tissuetype = "PBMC",
                              saveobjs = FALSE, views = FALSE),
               paste("Currently the TBSP only accepts gene signatures with 2",
                     "or more gene symbols.")
  )
  expect_error(addTBsignature(sigsymbols = c("APOL1", "BATF2", "ETV7"),
                              authname = "Katarvi", signame_common = "KAT3",
                              sigtype = "Disease/HIV", tissuetype = "PBMC",
                              saveobjs = NULL, views = FALSE),
               paste("'saveobjs' must be logical.")
  )
  expect_error(addTBsignature(sigsymbols = c("APOL1", "BATF2", "ETV7"),
                              authname = "Katarvi", signame_common = "KAT3",
                              sigtype = "Response", tissuetype = "PBMC",
                              saveobjs = FALSE, views = FALSE),
               paste("Input string for 'sigtype' not recognized.",
                     "You must denote 'sigtype' as one of the following:",
                     "'Disease', 'Disease/HIV', 'Disease/Other Diseases',",
                     "'Disease/Pneumonia', 'failure', 'response', 'risk'")
  )
  expect_error(addTBsignature(sigsymbols = c("APOL1", "BATF2", "ETV7"),
                              authname = "Katarvi", signame_common = "KAT3",
                              sigtype = "Disease/HIV", tissuetype = "Not",
                              saveobjs = FALSE, views = FALSE),
               paste("'tissuetype' must be one of the following:",
                     "'mixed', 'PBMC', 'whole blood'")
  )
  expect_error(addTBsignature(sigsymbols = c("APOL1", "BATF2", "ETV7"),
                              authname = "Thisisareallylongnamesok",
                              signame_common = "KAT3",
                              sigtype = "Disease/HIV", tissuetype = "PBMC",
                              saveobjs = FALSE, views = FALSE),
               paste("Resulting signature name is too long.",
                     "Please shorten or abbreviate authname to", 13,
                     "characters.")
  )
  expect_error(addTBsignature(sigsymbols = rep(c("APOL1", "BATF2"), 8),
                              authname = "Zak",
                              signame_common = "KAT3",
                              sigtype = "risk", tissuetype = "PBMC",
                              saveobjs = FALSE, views = FALSE),
               paste("There is already a signature with that name.",
                     "Please alter the authname to distinguish it from the previous",
                     "signature.")
  )
})

globalVariables(c("BS_AUC", "FPR", "LowerTPR", "Signatures",
                  "TBsignatures", "TPR", "UpperTPR", "sigAnnotData"))

#' Normalize gene expression count data.
#'
#' @param inputData a \code{data.frame} or \code{matrix} of gene expression
#' count data. Required.
#'
#' @return A \code{data.frame} or \code{matrix} of normalized count data.
#'
#' @export
#'
#' @examples
#' ## Example using the counts assay from a SummarizedExperiment
#' data_in <- SummarizedExperiment::assay(TB_indian, "counts")
#' res <- deseq2_norm_rle(data_in)
deseq2_norm_rle <- function(inputData) {
    scalingFac <- DESeq2::estimateSizeFactorsForMatrix(inputData)
    inputDataScaled <- inputData
    for (i in seq_len(ncol(inputData))) {
        inputDataScaled[, i] <- inputData[, i] / scalingFac[i]
    }
    return(inputDataScaled)
}

#' Perform Leave-one-out CV with Logistic Regression.
#'
#' @param df a \code{data.frame} of gene expression count data. Required.
#' @param targetVec a binary vector of the response variable. Should be
#' the same number of samples as in \code{df}. Required.
#'
#' @return A list of length 3 with elements
#' \item{auc}{The AUC from the LOOCV procedure.}
#' \item{byClass}{A vector containing the sensitivity, specificity, positive
#' predictive value, negative predictive value, precision, recall, F1,
#' prevalence, detection rate, detection prevalence and balanced accuracy.}
#' \item{prob}{A vector of the test prediction probabilities.}
#'
LOOAUC_simple_multiple_noplot_one_df <- function(df, targetVec) {
  nSample <- ncol(df)
  testPredictionClassVec <- testPredictionProbVec <- numeric(nSample)
  for (j in seq_len(nSample)) {
    train <- t(as.matrix(df[, -j]))
    test <- t(as.matrix(df[, j]))
    fit <- suppressWarnings(glmnet::glmnet(train, targetVec[-j],
                                           family = "binomial"))
    testPredictionClassVec[j] <- suppressWarnings(
      stats::predict(fit, type = "class", newx = test, s = 0))
    testPredictionProbVec[j] <- suppressWarnings(
      stats::predict(fit, type = "response", newx = test, s = 0))
  }
  loo.pred <- ROCit::rocit(testPredictionProbVec, targetVec)
  testPredictionClassVec <- as.numeric(testPredictionClassVec)
  conf.mat <- suppressWarnings(
    caret::confusionMatrix(as.factor(testPredictionClassVec),
                                         as.factor(targetVec)))
  output.list <- list()
  output.list[[1]] <- round(loo.pred$AUC, 4)
  output.list[[2]] <- conf.mat$byClass
  output.list[[3]] <- testPredictionProbVec
  names(output.list) <- c("auc", "byClass", "prob")
  return(output.list)
}

#' Bootstrap on Leave-one-out CV with Logistic Regression.
#'
#' @param df a \code{data.frame} of gene expression count data. Required.
#' @param targetVec a binary vector of the response variable. Should be
#' the same number of rows as \code{df}. Required.
#' @param nboot an integer specifying the number of bootstrap iterations.
#'
#' @return A list of length 2 with elements \item{auc}{A vector the length of
#' \code{nboot} with the AUC from each bootstrap iteration.}
#' \item{byClass}{A dataframe with number of rows equal to \code{nboot}. Each
#' row contains the sensitivity, specificity, positive predictive
#' value, negative predictive value, precision, recall, F1, prevalence,
#' detection rate, detection prevalence and balanced accuracy for that
#' bootstrap iteration.}
#'
Bootstrap_LOOCV_LR_AUC <- function(df, targetVec, nboot) {
  output.auc.vec <- numeric(nboot)
  output.byClass.df <- as.data.frame(matrix(0, ncol = 11, nrow = nboot))
  for (i in seq_len(nboot)) {
    index.boot <- sample(seq_len(ncol(df)), ncol(df), replace = TRUE)
    df.tmp <- df[, index.boot]
    loo.output.list <- suppressWarnings(
      LOOAUC_simple_multiple_noplot_one_df(df.tmp, targetVec[index.boot])
    )
    output.auc.vec[i] <- loo.output.list[[1]]
    output.byClass.df[i, ] <- loo.output.list[[2]]
  }
  colnames(output.byClass.df) <- names(loo.output.list[[2]])
  output.list <- list()
  output.list[[1]] <- output.auc.vec
  output.list[[2]] <- output.byClass.df
  names(output.list) <- c("auc", "byClass")
  return(output.list)
}

#' Use logistic regression and bootstrap LOOCV to evaluate signatures.
#'
#' This function takes as input a \code{data.frame} with genetic expression
#' count data, and uses a bootstrapped leave-one-out cross validation procedure
#' with logistic regression to allow for numeric and graphical comparison
#' across any number of genetic signatures.
#'
#' @param df.input a \code{data.frame} of gene expression count data. Required.
#' @param targetVec.num a numeric binary vector of the response variable.
#' The vector should be the same number of rows as \code{df}. Required.
#' @param signature.list a \code{list} of signatures to run with their
#' associated genes. This list should be in the same format as \code{TBsignatures},
#' included in the TBSignatureProfiler package. If \code{signature.list = NULL},
#' the default set of signatures \code{TBsignatures} list is used. For details,
#' run \code{?TBsignatures}.
#' @param signature.name.vec A vector specifying the names of the signatures
#' to be compared. This should be the same length as \code{signature.list}.
#' If \code{signature.name.vec = NULL}, the default set of signatures
#' \code{TBsignatures} list is used.
#' @param num.boot an integer specifying the number of bootstrap iterations.
#' @param pb.show logical. If \code{TRUE} then a progress bar for the
#' bootstrapping procedure will be displayed as output. The default is
#' \code{TRUE}.
#' @param name a character string giving a name for the outputted boxplot of
#' bootstrapped AUCs. The default is \code{"Quantitative Evaluation of
#' Signatures via Bootstrapped AUCs"}.
#'
#' @return the AUC, sensitivity and specificity
#'
#' @export
#'
#' @examples
#' inputTest <- matrix(rnorm(1000), 100, 20,
#'                     dimnames = list(paste0("gene", seq.int(1, 100)),
#'                                     paste0("sample", seq.int(1, 20))))
#' inputTest <- as.data.frame(inputTest)
#' targetVec <- sample(c(0,1), replace = TRUE, size = 20)
#' signature.list <- list(sig1 = c("gene1", "gene2", "gene3"),
#'                        sig2 = c("gene4", "gene5", "gene6"))
#' signature.name.vec <- c("sig1", "sig2")
#' num.boot <- 2
#' SignatureQuantitative(inputTest, targetVec.num = targetVec,
#'                       signature.list = signature.list,
#'                       signature.name.vec = signature.name.vec,
#'                       num.boot = num.boot)
#'
SignatureQuantitative <- function(df.input, targetVec.num, signature.list = NULL,
                                  signature.name.vec = NULL, num.boot = 100,
                                  pb.show = TRUE) {

  if ((is.null(signature.name.vec) && !is.null(signature.list)
       || (!is.null(signature.name.vec) && is.null(signature.list)))) {
    stop("Please specify arguments for both signature.list and
         signature.name.vec, or leave them both empty to use
         TBsignatures as the list of signatures for profiling.")
  } else if (is.null(signature.list) && is.null(signature.name.vec)) {
    signatures <- check_sig_env(signatures)
  }

  if (length(signature.list) != length(signature.name.vec)) {
    stop("The inputs signature.list and signature.name.vec are not the same
         length.")
  }

  df.list <- list()
  # progress bar
  counter <- 0
  total <- length(signature.list)
  if (pb.show) pb <- utils::txtProgressBar(min = 0, max = total, style = 3)

  for (i in seq_along(signature.list)) {
    df.list[[i]] <- df.input[signature.list[[i]], ]
  }

  auc.result <- list()
  auc.result.ci <- list()
  sensitivity.ci <- list()
  specificity.ci <- list()

  for (i in seq_along(df.list)) {
    boot.output.list <- suppressWarnings(Bootstrap_LOOCV_LR_AUC(df.list[[i]],
                                                                targetVec.num,
                                                                nboot = num.boot))
    # AUC
    auc.result[[i]] <- boot.output.list[[1]]
    result <- LOOAUC_simple_multiple_noplot_one_df(df.list[[i]],
                                                   targetVec = targetVec.num)
    est <- result[[1]]
    ci.lower <- stats::quantile(auc.result[[i]], probs = 0.05)
    ci.upper <- stats::quantile(auc.result[[i]], probs = 0.95)
    st.error <- (1 / (num.boot - 1)) * sum(auc.result[[i]] -
                                             mean(auc.result[[i]]))
    auc.result.ci[[i]] <- c("Estimate" = est, "CI lower" = ci.lower,
                            "CI upper" = ci.upper, "Std. Error" = st.error)
    names(auc.result)[i] <- signature.name.vec[i]
    names(auc.result.ci)[i] <- signature.name.vec[i]
    # sensitivity
    est2 <- result$byClass["Sensitivity"]
    ci.lower2 <- stats::quantile(boot.output.list[[2]]$Sensitivity,
                                 probs = 0.05)
    ci.upper2 <- stats::quantile(boot.output.list[[2]]$Sensitivity,
                          probs = 0.95)
    st.error2 <- (1 / (num.boot - 1)) *
      sum(boot.output.list[[2]]$Sensitivity -
            mean(boot.output.list[[2]]$Sensitivity))
    sensitivity.ci[[i]] <- c("Estimate" = est2, "CI lower" = ci.lower2,
                             "CI upper" = ci.upper2, "Std. Error" = st.error2)
    names(sensitivity.ci)[i] <- signature.name.vec[i]
    est3 <- result$byClass["Specificity"]
    ci.lower3 <- stats::quantile(boot.output.list[[2]]$Specificity,
                                 probs = 0.05)
    ci.upper3 <- stats::quantile(boot.output.list[[2]]$Specificity,
                          probs = 0.95)
    st.error3 <- (1 / (num.boot - 1)) *
      sum(boot.output.list[[2]]$Specificity -
            mean(boot.output.list[[2]]$Specificity))
    specificity.ci[[i]] <- c("Estimate" = est3, "CI lower" = ci.lower3,
                             "CI upper" = ci.upper3, "Std. Error" = st.error3)

    counter <- counter + 1
    if (pb.show) utils::setTxtProgressBar(pb, counter)
  }

  # output data.frame instead of list
  df.auc.ci <- data.frame(matrix(unlist(auc.result.ci),
                                 nrow = length(auc.result.ci),
                                 byrow = TRUE))
  colnames(df.auc.ci) <- names(auc.result.ci[[1]])
  rownames(df.auc.ci) <- signature.name.vec

  df.sensitivity.ci <- data.frame(matrix(unlist(sensitivity.ci),
                                         nrow = length(sensitivity.ci),
                                         byrow = TRUE))
  colnames(df.sensitivity.ci) <- names(sensitivity.ci[[1]])
  rownames(df.sensitivity.ci) <- signature.name.vec

  df.specificity.ci <- data.frame(matrix(unlist(specificity.ci),
                                         nrow = length(specificity.ci),
                                         byrow = TRUE))
  colnames(df.specificity.ci) <- names(specificity.ci[[1]])
  rownames(df.specificity.ci) <- signature.name.vec

  if (pb.show) close(pb)

  return(list(df.auc.ci = df.auc.ci,
              df.sensitivity.ci = df.sensitivity.ci,
              df.specificity.ci = df.specificity.ci))
}

#' Create a boxplot using logistic regression and bootstrap LOOCV to evaluate signatures.
#'
#' This function takes as input a \code{data.frame} with genetic expression
#' count data, and uses a bootstrapped leave-one-out cross validation procedure
#' with logistic regression to allow for numeric and graphical comparison
#' across any number of genetic signatures. It creates a boxplot of bootstrapped
#' AUC values.
#'
#' @inheritParams signatureBoxplot
#' @inheritParams SignatureQuantitative
#' @inheritParams compareBoxplots
#' @param name a character string giving a name for the outputted boxplot of
#' bootstrapped AUCs. The default is \code{"Signature Evaluation:
#' Bootstrapped AUCs"}.
#'
#' @return a boxplot comparing the bootstrapped AUCs of inputted signatures
#'
#' @export
#'
#' @examples
#' inputTest <- matrix(rnorm(1000), 100, 20,
#'                     dimnames = list(paste0("gene", seq.int(1, 100)),
#'                                     paste0("sample", seq.int(1, 20))))
#' inputTest <- as.data.frame(inputTest)
#' targetVec <- sample(c(0,1), replace = TRUE, size = 20)
#' signature.list <- list(sig1 = c("gene1", "gene2", "gene3"),
#'                        sig2 = c("gene4", "gene5", "gene6"))
#' signature.name.vec <- c("sig1", "sig2")
#' num.boot <- 5
#' plotQuantitative(inputTest, targetVec.num = targetVec,
#'                  signature.list = signature.list,
#'                  signature.name.vec = signature.name.vec,
#'                  num.boot = num.boot, rotateLabels = FALSE)
#'

plotQuantitative <- function(df.input, targetVec.num, signature.list = NULL,
                             signature.name.vec = NULL, num.boot = 100,
                             pb.show = TRUE, name =
                               "Signature Evaluation: Bootstrapped AUCs",
                             fill.col = "white", outline.col = "black",
                             abline.col = "red", rotateLabels = FALSE) {
  if ((is.null(signature.name.vec) && !is.null(signature.list)
       || (!is.null(signature.name.vec) && is.null(signature.list)))) {
    stop("Please specify arguments for both signature.list and
         signature.name.vec, or leave them both empty to use
         TBsignatures as the list of signatures for profiling.")
  } else if (is.null(signature.list) && is.null(signature.name.vec)) {
    signatures <- check_sig_env(signatures)
  }
  if (length(signature.list) != length(signature.name.vec)) {
    stop("The inputs signature.list and signature.name.vec are not the same
         length.")
  }

  df.list <- list()
  # progress bar
  counter <- 0
  total <- length(signature.list)
  if (pb.show) pb <- utils::txtProgressBar(min = 0, max = total, style = 3)

  for (i in seq_along(signature.list)) {
    df.list[[i]] <- df.input[signature.list[[i]], ]
  }

  auc.result <- list()

  for (i in seq_along(df.list)) {
    boot.output.list <- suppressWarnings(Bootstrap_LOOCV_LR_AUC(df.list[[i]],
                                                                targetVec.num,
                                                                nboot = num.boot))
    # AUC
    auc.result[[i]] <- boot.output.list[[1]]
    counter <- counter + 1
    if (pb.show) utils::setTxtProgressBar(pb, counter)
  }

  # Boxplot
  auc.result <- data.frame(matrix(unlist(auc.result),
                                  ncol = length(signature.list),
                                  dimnames = list(c(), names(signature.list))))
  aucs <- apply(auc.result, 2, stats::median)

  melted_data <- reshape2::melt(auc.result,
                                measure.vars = names(signature.list),
                                variable.name = "Signatures",
                                value.name = "BS_AUC")
  melted_data$Signatures <- gdata::reorder.factor(
    x = melted_data$Signatures,
    new.order = names(sort(aucs)))
  melted_data <- melted_data[order(melted_data$Signatures), ]
  the_plot <- ggplot2::ggplot(data = melted_data, ggplot2::aes(Signatures,
                                                               BS_AUC)) +
    ggplot2::geom_boxplot(fill = fill.col, col = outline.col) +
    ggplot2::geom_abline(ggplot2::aes(intercept = 0.5, slope = 0,
                                      col = abline.col), size = 1,
                         linetype = "dashed", show.legend = FALSE) +
    ggplot2::ggtitle(label = name) +
    ggplot2::ylab(label = "Bootstrapped AUCs") +
    ggplot2::theme_classic() +
    ggplot2::theme(axis.title.x = ggplot2::element_blank(),
                   axis.title.y = ggplot2::element_text(
                     margin = ggplot2::margin(r = 10)))

  if (rotateLabels) {
    the_plot <- the_plot + ggplot2::theme(axis.text.x = ggplot2::
                                          element_text(angle = 90, hjust = 1))
  }

  if (pb.show) close(pb)

  return(the_plot)
}

context("test-evaluate")

num_sample <- 20
num_genes <- 100
inputTestmat <- matrix(rnorm(1000), num_genes, num_sample,
                    dimnames = list(paste0("gene", seq.int(1, num_genes)),
                                    paste0("sample", seq.int(1, num_sample))))
inputTest <- as.data.frame(inputTestmat)
target_Vec <- sample(c(0, 1), replace = TRUE, size = num_sample)

PQ_target_Vec <- c(rep(1, num_sample/2), rep(0, num_sample/2))
signaturelist <- list(sig1 = c("gene1", "gene2", "gene3"),
                       sig2 = c("gene4", "gene5", "gene6"))
signaturenamevec <- c("sig1", "sig2")
numboot <- 5

test_that("deseq2_norm_rle works", {
  expect_is(
    deseq2_norm_rle(abs(inputTest)),
    "data.frame"
  )
})

#test_that("plotQuantitative works", {
#  expect_is(
#    plotQuantitative(inputTest,
#                     targetVec.num = PQ_target_Vec,
#                     signature.list = signaturelist,
#                     signature.name.vec = signaturenamevec,
#                     num.boot = 5,
#                     pb.show = FALSE,
#                     rotateLabels = TRUE),
#    "gg"
#  )
#  expect_error(
#    plotQuantitative(inputTest,
#                     targetVec.num = PQ_target_Vec,
#                     signature.list = list(sig1 = c("gene1", "gene2", "gene3"),
#                                           sig2 = c("gene4", "gene5", "gene6")),
#                     signature.name.vec = NULL,
#                     num.boot = 3,
#                     pb.show = FALSE,
#                     rotateLabels = TRUE),
#    "Please specify arguments for both signature.list and
#         signature.name.vec, or leave them both empty to use
#         TBsignatures as the list of signatures for profiling."
#  )
#  expect_error(
#    plotQuantitative(inputTest,
#                     targetVec.num = PQ_target_Vec,
#                     signature.list = list(sig1 = c("gene1", "gene2", "gene3"),
#                                           sig2 = c("gene4", "gene5", "gene6")),
#                     signature.name.vec = c("sig2"),
#                     num.boot = 3,
#                     pb.show = FALSE,
#                     rotateLabels = TRUE),
#    "The inputs signature.list and signature.name.vec are not the same
#         length."
#  )
#})
#

globalVariables(c("BS_AUC", "FPR", "LowerTPR", "Signatures",
                  "TBsignatures", "TPR", "UpperTPR", "sigAnnotData"))
.myenv <- new.env(parent = emptyenv())

# Helper functions for runTBsigProfiler

# Check whether a new sig list is in the working environment
check_sig_env <- function(signatures) {
  # Override with global environment
  if ("TBsignatures" %in% ls(envir = .GlobalEnv)) {
    get("TBsignatures", envir = .GlobalEnv)
    return(TBsignatures)
  } else {
    utils::data("TBsignatures", package = "TBSignatureProfiler",
                envir = .myenv)
    return(.myenv$TBsignatures)
  }
}

# Update gene names that are mogrified or outdated
update_genenames <- function(siglist) {
  siglist <- iconv(siglist, from = "UTF-8", to = "ASCII//TRANSLIT")
  requireNamespace("ggplot2", quietly = TRUE)
  if (!requireNamespace("HGNChelper", quietly = TRUE)) {
    stop("Package 'HGNChelper' required to update gene names.",
         "Either install or set update_genes = FALSE.")
  }
  allgenes <- suppressMessages(suppressWarnings(
    HGNChelper::checkGeneSymbols(siglist,
                                 unmapped.as.na = FALSE))) |>
    dplyr::select("prior" = "x", "new" = "Suggested.Symbol")
  newgenes <- allgenes$new
  ind <- grep("//", newgenes)
  if (length(ind) != 0) allgenes$new[ind] <- strsplit(newgenes[ind],
                                                  " /// ")[[1]][1]
  return(allgenes)
}

# run scoring algorithms
score_algorithm <- function(runindata, signatures, alg, assignDir = NULL,
                            parallel.sz = 0,
                            ASSIGNiter = 100000, ASSIGNburnin = 50000,
                            ssgsea_norm = TRUE, combineSigAndAlgorithm,
                            one_alg) {
  runindata <- as.matrix(runindata)
  if (parallel.sz > 1) {
    utility_param <- BiocParallel::MulticoreParam(workers = parallel.sz)
  } else utility_param <- BiocParallel::SerialParam(progressbar = FALSE)
  if (alg == "GSVA") {
    message("Running GSVA")
    param_in <- GSVA::gsvaParam(exprData = runindata, geneSets = signatures)
    algout <- GSVA::gsva(param_in, verbose = FALSE, BPPARAM = utility_param)
  } else if (alg == "ssGSEA") {
    message("Running ssGSEA")
    param_in <- GSVA::ssgseaParam(exprData = runindata, geneSets = signatures,
                                  normalize = ssgsea_norm)
    algout <- GSVA::gsva(param_in, verbose = FALSE, BPPARAM = utility_param)
  } else if (alg == "PLAGE") {
    message("Running PLAGE")
    param_in <- GSVA::plageParam(exprData = runindata, geneSets = signatures)
    algout <- GSVA::gsva(param_in, verbose = FALSE, BPPARAM = utility_param)
  } else if (alg == "Zscore") {
    message("Running Zscore")
    param_in <- GSVA::zscoreParam(exprData = runindata, geneSets = signatures)
    algout <- GSVA::gsva(param_in, verbose = FALSE, BPPARAM = utility_param)
  } else if (alg == "singscore") {
    message("Running singscore")
    algout <- matrix(ncol = ncol(runindata), nrow = length(signatures),
                     dimnames = list(names(signatures), colnames(runindata)))
    rankDat <- singscore::rankGenes(runindata)
    for (sig in names(signatures)) {
      algout[sig, ] <- suppressWarnings(singscore::simpleScore(
        rankData = rankDat,
        upSet = signatures[[sig]],
        knownDirection = FALSE)$TotalScore)
    }
  } else if (alg == "ASSIGN") {
    delete_intermediate <- FALSE
    if (is.null(assignDir)) {
      assignDir <- tempfile("assign")
      dir.create(assignDir)
      delete_intermediate <- TRUE
    } else if (!dir.exists(assignDir)) dir.create(assignDir)
    for (i in names(signatures)) {
      message("Running ASSIGN: ", i)
      currlist <- signatures[i]
      currlist[[1]] <- currlist[[1]][currlist[[1]] %in% rownames(runindata)]
      if (length(currlist[[1]]) < 2) {
        message("Not enough signature genes in ", i, "; cannot run.")
      } else {
        if (!file.exists(i)) {
          ASSIGN::assign.wrapper(testData = runindata, trainingLabel = NULL,
                                 geneList = currlist, adaptive_S = TRUE,
                                 iter = ASSIGNiter, burn_in = ASSIGNburnin,
                                 outputDir = file.path(assignDir, i))
        } else message("Result already exists. Delete to re-run.")
      }
    }
    algout <- as.matrix(t(ASSIGN::gather_assign_results(assignDir)))
    if (nrow(algout) == 0) algout <- NULL
    if (delete_intermediate) {
      unlink(assignDir, recursive = TRUE)
    } else {
      message("Intermediate ASSIGN results available at ", assignDir)
    }
  }
  if (one_alg) return(algout)
  if (length(combineSigAndAlgorithm) == 0) {
    stop("You must choose whether or not to combine the ",
         "signature and algorithm name using combineSigAndAlgorithm.")
  } else if (combineSigAndAlgorithm && !is.null(algout)) {
    scoremat <- algout
    rownames(scoremat) <- paste(alg, rownames(algout), sep = "_")
  } else if (!combineSigAndAlgorithm) {
    alg_col <- algout[, 1, drop = FALSE]
    colnames(alg_col) <- "algorithm"
    alg_col[, 1] <- rep(alg, nrow(algout))
    pathcol <- alg_col
    pathcol[, 1] <- rownames(algout)
    colnames(pathcol) <- "pathway"
    scoremat <- cbind(pathcol, alg_col, algout)
    rownames(scoremat) <- NULL
  }
  return(scoremat)
}

# Create proper output class for runTBsigProfiler
output_function <- function(input, signatures, algorithm, outputFormat,
                            runindata, sig_result) {
  # if outputFormat is null, make output same as input class
  if (is.null(outputFormat)) {
    outputFormat <- class(input)[1]
  }
  
  # Obtain potential colData
  runindata <- as.matrix(runindata)
  attr(rownames(runindata), ".match.hash") <- NULL
  
  if (methods::is(input, "matrix")) {
    SE_coldat <- S4Vectors::DataFrame(t(sig_result))
    SE_assay <- S4Vectors::SimpleList(data = runindata)
  } else if (methods::is(input, "data.frame")) {
    SE_coldat <- S4Vectors::DataFrame(t(sig_result))
    SE_assay <- S4Vectors::SimpleList(data = runindata)
  } else if (methods::is(input, "SummarizedExperiment")) {
    SE_coldat <- S4Vectors::cbind(SummarizedExperiment::colData(input),
                                  S4Vectors::DataFrame(t(sig_result)))
    SE_assay <- SummarizedExperiment::assays(input)
  }
  
  # Then create appropriately formatted output
  if (outputFormat == "matrix") {
    return(sig_result)
  } else if (outputFormat == "data.frame") {
    dfres <- as.data.frame(sig_result)
    return(dfres)
  } else if (outputFormat == "SummarizedExperiment") {
    outdata <- SummarizedExperiment::SummarizedExperiment(
      assays = SE_assay,
      colData = SE_coldat)
    return(outdata)
  } else stop("'OutputFormat' should be one of 'SummarizedExperiment', ",
              "'matrix', or 'data.frame'")
}


#' Run TB gene signature profiling.
#'
#' Using some subset of the signatures listed in \code{TBsignatures} and
#' specified scoring algorithms, this function runs gene signature profiling
#' on an input gene expression dataset. It allows for scores to be computed for
#' these signatures which can be compared using various visualization tools also
#' provided in the TBSignatureProfiler package.
#'
#' @param input an input data object of the class \code{SummarizedExperiment},
#' \code{data.frame}, or \code{matrix} containing gene expression data. Required.
#' @param useAssay a character string specifying the assay to use for signature
#' profiling when \code{input} is a \code{SummarizedExperiment}. Required only for
#' input data of the class \code{SummarizedExperiment}. If null, the assay
#' used will be \code{"counts"}. The default is \code{NULL.}
#' @param signatures a \code{list} of signatures to run with their associated genes.
#' This list should be in the same format as \code{TBsignatures}, included in
#' the TBSignatureProfiler package. If \code{signatures = NULL}, the default set
#' of signatures \code{TBsignatures} list is used.
#' For details, run \code{?TBsignatures}.
#' If <2 genes in a signature are present in the sample, that signature will
#' not be evaluated and will not be present in the resulting SE object.
#' The default is \code{NULL}.
#' @param algorithm a vector of algorithms to run, or character string if only
#' one is desired. The default is \code{c("GSVA", "ssGSEA", "ASSIGN",
#' "PLAGE", "Zscore", "singscore")}. NOTE: ASSIGN takes a long time to run and
#' is not recommended for efficient use.
#' @param combineSigAndAlgorithm logical, if \code{TRUE}, output row names will
#' be of the form <algorithm>_<signature>. It must be set to \code{TRUE} if the
#' \code{ouputFormat} will be a SummarizedExperiment and
#' \code{length(algorithm) > 1}.
#' It will always be \code{FALSE} if only one algorithm is selected.
#' If \code{FALSE}, there will be a column named algorithm' that lists which
#' algorithm is used, and a column named 'pathway' that lists the signature
#' profiled. If \code{NULL}, and one algorithm was used, the algorithm will not
#' be listed. The default is \code{FALSE}.
#' @param assignDir a character string naming a directory to save intermediate
#' ASSIGN results if \code{algorithm} specifies \code{"ASSIGN"}. The default is
#' \code{NULL}, in which case intermediate results will not be saved.
#' @param outputFormat a character string specifying the output data format.
#' Possible values are \code{"SummarizedExperiment"}, \code{"matrix"}, or
#' \code{"data.frame"}. The default is to return the same type as the
#' \code{input} object.
#' @param parallel.sz an integer identifying the number of processors to use
#' when running the calculations in parallel for the GSVA and ssGSEA algorithms.
#' If \code{parallel.sz = 0}, all cores are used. The default is \code{0}.
#' @param ASSIGNiter an integer indicating the number of iterations to use in
#' the MCMC for the ASSIGN algorithm. The default is \code{100,000}.
#' @param ASSIGNburnin an integer indicating the number of burn-in iterations
#' to use in the MCMC for the ASSIGN algorithm. These iterations are discarded
#' when computing the posterior means of the model parameters. The default is
#' \code{50,000}.
#' @param ssgsea_norm logical, passed to \code{GSVA::gsva()}. When parameter
#' \code{algorithm = "ssgsea"},the profiler runs the SSGSEA method from
#' Barbie et al. (2009) normalizing the scores by the absolute difference
#' between the minimum and the maximum, as described in their paper.
#' When \code{ssgsea.norm = FALSE}, this last normalization step is skipped.
#' The default is \code{TRUE}.
#' @param update_genes logical, denotes whether gene names from \code{signatures}
#' and the rownames of \code{input} should be checked for accuracy using
#' \code{HGNChelper::checkGeneSymbols()}. The mapping assumes
#' genes are from humans and will keep unmapped genes as the original
#' input gene name. Default is \code{TRUE}.
#'
#' @return A \code{SummarizedExperiment} object, \code{data.frame}, or
#' \code{matrix} of signature profiling results. The returned object will be
#' of the format specified in \code{outputFormat}.
#' If \code{input} is a \code{SummarizedExperiment} and
#' \code{outputFormat = "SummarizedExperiment"}, then the output will retain
#' any input information stored in the input colData. In general, if
#' \code{outputFormat = "SummarizedExperiment"} then columns in the \code{colData}
#' will include the scores for each desired signature with samples on the rows.
#' If \code{input} is a \code{data.frame} or \code{matrix}, then the returned
#' object will have signatures on the rows and samples on the columns.
#'
#' @references
#' Barbie, D.A., Tamayo, P., Boehm, J.S., Kim, S.Y., Moody, S.E., Dunn, I.F., Schinzel, A.C.,
#' Sandy, P., Meylan, E., Scholl, C., et al. (2009). Systematic RNA interference reveals
#' that oncogenic KRAS-driven cancers require TBK1. \emph{Nature} \strong{462}, 108-112.
#' doi: \href{https://doi.org/10.1038/nature08460}{10.1038/nature08460}.
#'
#' Foroutan, M. et al. (2018). Single sample scoring of molecular phenotypes.
#' \emph{BMC Bioinformatics}, \bold{19}. doi:
#' \href{https://doi.org/10.1186/s12859-018-2435-4}{10.1186/s12859-018-2435-4}.
#'
#' Lee, E. et al. (2008). Inferring pathway activity toward precise disease
#' classification. \emph{PLoS Comp Biol}, 4(11):e1000217. doi:
#' \href{https://doi.org/10.1371/journal.pcbi.1000217}{10.1371/journal.pcbi.1000217}
#'
#' Shen, Y. et al. (2015). ASSIGN: context-specific genomic profiling of
#' multiple heterogeneous biological pathways. \emph{Bioinformatics}, \bold{31},
#' 1745-1753. doi:
#' \href{https://doi.org/10.1093/bioinformatics/btv031}{10.1093/bioinformatics/btv031}.
#'
#' Subramanian, A. et al. (2005). Gene set enrichment analysis: A knowledge-based
#' approach for interpreting genome-wide expression profiles. \emph{PNAS},
#' \strong{102}, 15545-15550. doi:
#' \href{https://doi.org/10.1073/pnas.0506580102}{10.1073/pnas.0506580102}.
#'
#' Tomfohr, J. et al. (2005). Pathway level analysis of gene expression using
#' singular value decomposition. \emph{BMC Bioinformatics}, 6:225. doi:
#' \href{https://doi.org/10.1186/1471-2105-6-225}{10.1186/1471-2105-6-225}
#'
#' @source Profiling for the Z-Score, PLAGE, GSVA, ssGSEA algorithms are all
#' conducted with the Bioconductor \code{GSVA} package. Profiling for the
#' singscore algorithm is conducted with the Bioconductor \code{singscore}
#' package.
#'
#' @export
#'
#' @examples
#' ## Using a data.frame input/output
#'  # Create some toy data to test Zak_RISK_16 signature, using 5 samples with low
#'  # expression & five samples with high expression of the signatures genes.
#' df_testdata <- as.data.frame(rbind(matrix(c(rnorm(80), rnorm(80) + 5), 16, 10,
#'                              dimnames = list(TBsignatures$Zak_RISK_16,
#'                              paste0("sample", seq_len(10)))),
#'                       matrix(rnorm(1000), 100, 10,
#'                              dimnames = list(paste0("gene", seq_len(100)),
#'                              paste0("sample", seq_len(10))))))
#' res <- runTBsigProfiler(input = df_testdata,
#'                         signatures = TBsignatures["Zak_RISK_16"],
#'                         algorithm = c("GSVA", "ssGSEA"),
#'                         combineSigAndAlgorithm = FALSE,
#'                         parallel.sz = 1)
#' subset(res, res$pathway == "Zak_RISK_16")
#'
#' ## Using a SummarizedExperiment input/output
#'  # The TB_indian SummarizedExperiment data is included in the package.
#' GSVA_res <- runTBsigProfiler(input = TB_indian,
#'                              useAssay = "logcounts",
#'                              signatures = TBsignatures["Zak_RISK_16"],
#'                              algorithm = c("GSVA"),
#'                              combineSigAndAlgorithm = FALSE,
#'                              parallel.sz = 1)
#' GSVA_res$Zak_RISK_16
runTBsigProfiler <- function(input, useAssay = NULL, signatures = NULL,
                             algorithm = c("GSVA", "ssGSEA", "ASSIGN",
                                           "PLAGE", "Zscore", "singscore"),
                             combineSigAndAlgorithm = FALSE, assignDir = NULL,
                             outputFormat = NULL, parallel.sz = 0,
                             ASSIGNiter = 100000, ASSIGNburnin = 50000,
                             ssgsea_norm = TRUE, update_genes = TRUE) {
  if (is.null(signatures)) signatures <- check_sig_env(signatures)
  acc_methods <- c("GSVA", "ssGSEA", "ASSIGN", "PLAGE", "Zscore", "singscore")
  if (!all(algorithm %in% acc_methods)) {
    stop("Invalid algorithm. Supported algorithms are: ",
         "GSVA, ssGSEA, PLAGE, Zscore, singscore, and ASSIGN")
  }
  runindata <- input
  if (methods::is(runindata, "SummarizedExperiment")) {
    if (is.null(useAssay)) {
      if ("counts" %in% names(SummarizedExperiment::assays(input))) {
        useAssay <- "counts"
      } else stop("useAssay required for SummarizedExperiment Input")
    }
    runindata <- SummarizedExperiment::assay(input, useAssay) |>
      as.data.frame()
    if (!combineSigAndAlgorithm && length(algorithm) > 1) {
      stop("SummarizedExperiment not supported when ",
           "combineSigAndAlgorithm FALSE.")
    }
  } else if (!is.null(useAssay)) {
    stop("useAssay only supported for SummarizedExperiment objects")
  } else if (methods::is(runindata, "matrix")) {
    runindata <- as.data.frame(runindata)
  } else if (methods::is(runindata, "data.frame")) {
    NULL
  } else if (!methods::is(runindata, "matrix")) {
    stop("Invalid input data type. Accepted input formats are matrix, ",
         "data.frame, or SummarizedExperiment. Your input: ",
         as.character(class(input)))
  }
  if (update_genes) {
    message("Parameter update_genes is TRUE. Gene names will be updated.")
    signatures <- lapply(signatures, update_genenames) |>
      lapply(function(x) unique(x$new))
    
    updated_genes <- update_genenames(rownames(runindata))
    runindata <- runindata |>
      tibble::rownames_to_column("prior") |>
      dplyr::inner_join(updated_genes, by = c("prior")) |>
      dplyr::relocate("new") |>
      dplyr::group_by(!!dplyr::sym("new")) |>
      dplyr::select(-"prior") |>
      dplyr::summarise(dplyr::across(dplyr::everything(), sum)) |>
      tibble::column_to_rownames("new")
  }
  # Remove signatures not present in the data
  sig_ind <- vapply(signatures,
                    function(x) sum(x %in% rownames(runindata)),
                    FUN.VALUE = numeric(1)) > 1
  if (any(!sig_ind)) message("The following signatures have <2 genes that",
                            " coincide with the genes in the given sample",
                            " and will not be scored: ",
                            paste0(names(signatures)[which(!sig_ind)],
                                   collapse = " "))
  signatures <- signatures[which(sig_ind)]
  if (length(algorithm) == 1) {
    sig_result <- score_algorithm(runindata, signatures, algorithm, assignDir,
                                  parallel.sz, ASSIGNiter, ASSIGNburnin,
                                  ssgsea_norm, combineSigAndAlgorithm,
                                  one_alg = TRUE)
    if (is.null(sig_result)) stop("All valid outputs are empty.")
  } else {
    combined <- lapply(algorithm, function(x) {
      score_algorithm(runindata, signatures, x, assignDir,
                      parallel.sz, ASSIGNiter, ASSIGNburnin,
                      ssgsea_norm, combineSigAndAlgorithm, one_alg = FALSE)
    })
    sig_result <- as.matrix(do.call(rbind, combined))
  }
  return(output_function(input, signatures, algorithm, outputFormat, runindata,
                         sig_result))
}

#' Compare scoring algorithms on a single signature via heatmap or boxplot.
#'
#' It may be useful to compare the results of scoring across several different
#' scoring algorithms via a method of visualization, such as a heatmap. The
#' \code{compareSigs} function allows the input of a SummarizedExperiment
#' data object and conducts
#' profiling on each signature desired, and outputting a heatmap or boxplot
#' for each signature.
#'
#' @inheritParams runTBsigProfiler
#' @inheritParams signatureHeatmap
#' @inheritParams compareBoxplots
#' @param input an input data object of the class \code{"SummarizedExperiment"}.
#' Required.
#' @param show.pb logical, whether warnings and other output
#' from the profiling should be suppressed (including progress bar output).
#' Default is \code{FALSE}.
#' @param output a character string specifying whether the outputted plot
#' should be a \code{"heatmap"} or \code{"boxplot"}. The default is
#' \code{"heatmap"}.
#'
#' @return A heatmap or boxplot for each signature specified comparing
#' the enumerated algorithms.
#'
#' @export
#'
#' @examples
#' compareAlgs(TB_indian,
#'             signatures = TBsignatures[c("Gliddon_OD_3")],
#'             annotationColName = "label",
#'             algorithm = c("ssGSEA", "PLAGE"),
#'             scale = TRUE, parallel.sz = 1, output = "heatmap")
#'
compareAlgs <- function(input, signatures = NULL, annotationColName,
                        useAssay = "counts",
                        algorithm = c("GSVA", "ssGSEA", "ASSIGN", "PLAGE",
                                      "Zscore", "singscore"),
                        showColumnNames = TRUE,
                        showRowNames = TRUE, scale = FALSE,
                        colorSets = c("Set1", "Set2", "Set3", "Pastel1",
                                      "Pastel2", "Accent", "Dark2",
                                      "Paired"),
                        choose_color = c("blue", "gray95", "red"),
                        colList = list(),
                        show.pb = FALSE, parallel.sz = 0, output = "heatmap",
                        num.boot = 100, column_order = NULL) {
  if (output != "heatmap" && output != "boxplot") {
    stop("Output parameter must specify either 'heatmap' or 'boxplot'")
  }
  if (is.null(signatures)) signatures <- check_sig_env(signatures)
  for (sig in names(signatures)) {
    new.name <- paste("Scoring Methods for", sig)
    if (!show.pb) {
      utils::capture.output(scored <- runTBsigProfiler(
        input, useAssay = useAssay, combineSigAndAlgorithm = TRUE,
        signatures = signatures[sig], algorithm = algorithm,
        parallel.sz = parallel.sz))
    } else if (show.pb) {
      scored <- runTBsigProfiler(
        input, useAssay = useAssay, combineSigAndAlgorithm = TRUE,
        signatures = signatures[sig], algorithm = algorithm,
        parallel.sz = parallel.sz)
    }
    if (methods::is(input, "SummarizedExperiment")) {
      already.there <- names(SummarizedExperiment::colData(input))
      col.names <- subset(names(SummarizedExperiment::colData(scored)),
                          !(names(SummarizedExperiment::colData(scored))
                            %in% already.there))
    } else stop("Input must be a SummarizedExperiment object.")
    if (output == "heatmap") {
      return(signatureHeatmap(scored,
                              name = new.name,
                              signatureColNames = col.names,
                              annotationColNames = annotationColName,
                              scale = scale,
                              showColumnNames = showColumnNames,
                              showRowNames = showRowNames,
                              colorSets = colorSets, choose_color = choose_color,
                              colList = colList, split_heatmap = "none",
                              column_order = column_order))
    } else if (output == "boxplot") {
      return(compareBoxplots(scored,
                             annotationColName = annotationColName,
                             signatureColNames = col.names,
                             num.boot = num.boot, name = new.name,
                             pb.show = show.pb, rotateLabels = TRUE))
    }
  }
}

context("test-profile")

mat_testdata <- rbind(matrix(c(rnorm(80), rnorm(80) + 5), 16, 10,
                             dimnames = list(TBsignatures$Zak_RISK_16,
                                             paste0("sample", 1:10))),
                      matrix(rnorm(1000), 100, 10,
                             dimnames = list(paste0("gene", 1:100),
                                             paste0("sample", 1:10))))
df_testdata <- data.frame(mat_testdata)
SEtestdata <- SummarizedExperiment::SummarizedExperiment(
  assays = S4Vectors::SimpleList(data = mat_testdata))

test_that("incorrect input", {
  expect_error(
    runTBsigProfiler(list(mat_testdata),
                     signatures = list(sig1 = paste0("gene", 1:10)),
                     algorithm = "GSVA", parallel.sz = 1),
    paste0("Invalid input data type. Accepted input formats are",
           " matrix, data.frame, or SummarizedExperiment. ",
           "Your input: list")
  )
  expect_error(
    runTBsigProfiler(mat_testdata,
                     signatures = list(sig1 = paste0("gene", 1:10)),
                     algorithm = "nothing", parallel.sz = 1),
    paste0("Invalid algorithm. Supported algorithms are: ",
           "GSVA, ssGSEA, PLAGE, Zscore, singscore, and ASSIGN")
  )
  expect_error(
    runTBsigProfiler(mat_testdata,
                     signatures = list(sig1 = paste0("fakegene", 1:10)),
                     algorithm = "ASSIGN", ASSIGNiter = 100, ASSIGNburnin = 50),
    paste0("All valid outputs are empty.")
  )
})

# Test matrix input
test_that("matrix input", {
  expect_error(
    runTBsigProfiler(mat_testdata, useAssay = "test",
                     signatures = list(sig1 = paste0("gene", 1:10)),
                     algorithm = "GSVA", parallel.sz = 1),
    "useAssay only supported for SummarizedExperiment objects"
  )
  expect_is(
    runTBsigProfiler(mat_testdata,
                     signatures = list(sig1 = paste0("gene", 1:10)),
                     algorithm = "GSVA", parallel.sz = 1),
    "matrix"
  )
  expect_is(
    runTBsigProfiler(mat_testdata,
                     signatures = list(sig1 = paste0("gene", 1:10)),
                     algorithm = "ssGSEA", parallel.sz = 1),
    "matrix"
  )
  expect_is(
    runTBsigProfiler(mat_testdata,
                     signatures = list(sig1 = paste0("gene", 1:10)),
                     algorithm = "ASSIGN", ASSIGNiter = 100, ASSIGNburnin = 50),
    "matrix"
  )
  expect_is(
    runTBsigProfiler(mat_testdata,
                     signatures = list(sig1 = paste0("gene", 1:10)),
                     algorithm = "PLAGE"),
    "matrix"
  )
  expect_is(
    runTBsigProfiler(mat_testdata,
                     signatures = list(sig1 = paste0("gene", 1:10)),
                     algorithm = "Zscore"),
    "matrix"
  )
  expect_is(
    runTBsigProfiler(mat_testdata,
                     signatures = TBsignatures["Zak_RISK_16"],
                     algorithm = "singscore"),
    "matrix"
  )
  expect_is(
    runTBsigProfiler(mat_testdata, outputFormat = "data.frame",
                     signatures = list(sig1 = paste0("gene", 1:10)),
                     algorithm = "GSVA", parallel.sz = 1),
    "data.frame"
  )
  expect_s4_class(
    runTBsigProfiler(mat_testdata, outputFormat = "SummarizedExperiment",
                     signatures = list(sig1 = paste0("gene", 1:10)),
                     algorithm = "GSVA", parallel.sz = 1),
    "SummarizedExperiment"
  )
  expect_is(
    runTBsigProfiler(mat_testdata,
                     signatures = list(sig1 = paste0("gene", 1:10)),
                     combineSigAndAlgorithm = TRUE,
                     algorithm = c("GSVA", "ssGSEA", "Zscore"),
                     parallel.sz = 1),
    "matrix"
  )
  expect_is(
    runTBsigProfiler(mat_testdata,
                     signatures = list(sig1 = paste0("gene", 1:10)),
                     combineSigAndAlgorithm = FALSE,
                     algorithm = c("GSVA", "ssGSEA", "Zscore"),
                     parallel.sz = 1),
    "matrix"
  )
  expect_error(
    runTBsigProfiler(mat_testdata,
                     signatures = list(sig1 = paste0("gene", 1:10)),
                     combineSigAndAlgorithm = NULL,
                     algorithm = c("GSVA", "ssGSEA", "Zscore"),
                     parallel.sz = 1),
    paste0("You must choose whether or not to combine the ",
           "signature and algorithm name using combineSigAndAlgorithm.")
  )
})

# Test data.frame input
test_that("data.frame input", {
  expect_is(
    runTBsigProfiler(df_testdata,
                     signatures = list(sig1 = paste0("gene", 1:10)),
                     algorithm = "GSVA", parallel.sz = 1),
    "data.frame"
  )
  expect_is(
    runTBsigProfiler(df_testdata,
                     signatures = list(sig1 = paste0("gene", 1:10)),
                     algorithm = "ssGSEA", parallel.sz = 1),
    "data.frame"
  )
  expect_is(
    runTBsigProfiler(df_testdata,
                     signatures = list(sig1 = paste0("gene", 1:10)),
                     algorithm = "ASSIGN", ASSIGNiter = 100, ASSIGNburnin = 50),
    "data.frame"
  )
  expect_is(
    runTBsigProfiler(df_testdata,
                     signatures = list(sig1 = paste0("gene", 1:10)),
                     algorithm = "PLAGE"),
    "data.frame"
  )
  expect_is(
    runTBsigProfiler(df_testdata,
                     signatures = list(sig1 = paste0("gene", 1:10)),
                     algorithm = "Zscore"),
    "data.frame"
  )
  expect_is(
    runTBsigProfiler(df_testdata,
                     signatures = TBsignatures["Zak_RISK_16"],
                     algorithm = "singscore"),
    "data.frame"
  )
  expect_is(
    runTBsigProfiler(df_testdata, outputFormat = "matrix",
                     signatures = list(sig1 = paste0("gene", 1:10)),
                     algorithm = "GSVA", parallel.sz = 1),
    "matrix"
  )
  expect_s4_class(
    runTBsigProfiler(df_testdata, outputFormat = "SummarizedExperiment",
                     signatures = list(sig1 = paste0("gene", 1:10)),
                     algorithm = "GSVA", parallel.sz = 1),
    "SummarizedExperiment"
  )
  expect_is(
    runTBsigProfiler(df_testdata, outputFormat = "matrix",
                     signatures = list(sig1 = paste0("gene", 1:10)),
                     combineSigAndAlgorithm = TRUE,
                     algorithm = c("GSVA", "ssGSEA"), parallel.sz = 1),
    "matrix"
  )
  expect_is(
    runTBsigProfiler(df_testdata,
                     signatures = list(sig1 = paste0("gene", 1:10)),
                     combineSigAndAlgorithm = FALSE,
                     algorithm = c("GSVA", "ssGSEA"), parallel.sz = 1),
    "data.frame"
  )
  assignDir <- tempfile("assign")
  dir.create(assignDir)
  expect_is(
    runTBsigProfiler(df_testdata, assignDir = assignDir,
                     signatures = list(sig1 = paste0("gene", 1:10)),
                     algorithm = "ASSIGN", ASSIGNiter = 100, ASSIGNburnin = 50),
    "data.frame"
  )
  unlink(assignDir)
})

#Test SummarizedExperiment input
test_that("SummarizedExperiment input", {
  expect_error(
    runTBsigProfiler(SEtestdata, signatures = list(sig1 = paste0("gene", 1:10)),
                     algorithm = "GSVA", parallel.sz = 1),
    "useAssay required for SummarizedExperiment Input"
  )
  expect_s4_class(
    runTBsigProfiler(SEtestdata, useAssay = "data",
                     signatures = TBsignatures["Zak_RISK_16"],
                     algorithm = "GSVA", parallel.sz = 1),
    "SummarizedExperiment"
  )
  expect_s4_class(
    runTBsigProfiler(SEtestdata, useAssay = "data",
                     signatures = list(sig1 = paste0("gene", 1:10)),
                     algorithm = "ssGSEA", parallel.sz = 1),
    "SummarizedExperiment"
  )
  expect_s4_class(
    runTBsigProfiler(SEtestdata, useAssay = "data",
                     signatures = list(sig1 = paste0("gene", 1:10)),
                     algorithm = "ASSIGN", ASSIGNiter = 100, ASSIGNburnin = 50),
    "SummarizedExperiment"
  )
  expect_s4_class(
    runTBsigProfiler(SEtestdata, useAssay = "data",
                     signatures = list(sig1 = paste0("gene", 1:10)),
                     algorithm = "PLAGE"),
    "SummarizedExperiment"
  )
  expect_s4_class(
    runTBsigProfiler(SEtestdata, useAssay = "data",
                     signatures = list(sig1 = paste0("gene", 1:10)),
                     algorithm = "Zscore"),
    "SummarizedExperiment"
  )
  expect_s4_class(
    runTBsigProfiler(SEtestdata, useAssay = "data",
                     signatures = list(sig1 = paste0("gene", 1:10)),
                     algorithm = c("GSVA", "Zscore"), parallel.sz = 1,
                     combineSigAndAlgorithm = TRUE),
    "SummarizedExperiment"
  )
  expect_error(
    runTBsigProfiler(SEtestdata, useAssay = "data",
                     signatures = list(sig1 = paste0("gene", 1:10)),
                     algorithm = c("GSVA", "Zscore"), parallel.sz = 1,
                     combineSigAndAlgorithm = FALSE),
    "SummarizedExperiment not supported when combineSigAndAlgorithm FALSE."
  )
  expect_error(
    runTBsigProfiler(SEtestdata, useAssay = "data",
                     outputFormat = "SummarizedExperiment",
                     signatures = list(sig1 = paste0("gene", 1:10)),
                     algorithm = c("GSVA", "Zscore"), parallel.sz = 1,
                     combineSigAndAlgorithm = FALSE),
    "SummarizedExperiment not supported when combineSigAndAlgorithm FALSE."
  )
})

# Test other things
SEtestdata <- SummarizedExperiment::SummarizedExperiment(
  assays = S4Vectors::SimpleList(data = mat_testdata,
                                 counts = mat_testdata))
test_that("Output error", {
  expect_error(
    runTBsigProfiler(SEtestdata, useAssay = "data",
                     outputFormat = "other",
                     signatures = list(sig1 = paste0("gene", 1:10)),
                     algorithm = c("GSVA"), parallel.sz = 1,
                     combineSigAndAlgorithm = TRUE),
    paste("'OutputFormat' should be one of 'SummarizedExperiment',",
          "'matrix', or 'data.frame'")
  )
  expect_is(
    update_genenames(c("FN1", "TP53", "UNKNOWNGENE", "7-Sep", "9/7", "1-Mar", "Oct4", "4-Oct",
                       "OCT4-PG4", "C19ORF71", "C19orf71")),
    "data.frame"
  )
  expect_s4_class(
    runTBsigProfiler(SEtestdata, useAssay = NULL,
                     signatures = TBsignatures["Zak_RISK_16"],
                     algorithm = "GSVA", parallel.sz = 1),
    "SummarizedExperiment"
  )
})

# Test compareAlgs function
SEtestdata$Disease <- factor(c(rep("yes", 5), rep("no", 5)))
test_that("CompareAlgs function", {
  expect_error(
    compareAlgs(SEtestdata,
                useAssay = "data",
                annotationColName = "Disease",
                algorithm = "GSVA",
                output = "None",
                signatures = list(sig1 = paste0("gene", 1:10))),
    "Output parameter must specify either 'heatmap' or 'boxplot'"
  )
  expect_is(
    compareAlgs(SEtestdata,
                useAssay = "data",
                annotationColName = "Disease",
                algorithm = "GSVA",
                output = "heatmap",
                signatures = list(sig1 = paste0("gene", 1:10))),
    "HeatmapList"
  )
  expect_output(
    compareAlgs(SEtestdata,
                useAssay = "data",
                annotationColName = "Disease",
                algorithm = "GSVA",
                output = "boxplot",
                show.pb = TRUE,
                signatures = list(sig1 = paste0("gene", 1:5),
                                  sig2 = paste0("gene", 5:10)))
  )
  expect_error(
    compareAlgs(df_testdata,
                useAssay = NULL,
                annotationColName = "Disease",
                algorithm = "GSVA",
                output = "boxplot",
                show.pb = TRUE,
                signatures = list(sig1 = paste0("gene", 1:10))),
    "Input must be a SummarizedExperiment object."
  )
})

globalVariables(c("TBsignaturesSplit", "OriginalTrainingData", "TBsignatures"))

#' A function that implements the original methods for multiple TB signatures.
#'
#' This function computes prediction for multiple TB signatures based on their training
#' models/methods. To avoid naming issues, the gene names for both training data and
#' input gene sets have been updated using the \code{\link[HGNChelper]{checkGeneSymbols}}.
#' TB signatures with available original models are: Anderson_42,
#' Anderson_OD_51, Kaforou_27, Kaforou_OD_44, Kaforou_OD_53, Sweeney_OD_3,
#' Maertzdorf_4, Verhagen_10, Jacobsen_3, Sambarey_HIV_10, Leong_24,
#' Berry_OD_86, Berry_393, Bloom_OD_144, Suliman_RISK_4, Zak_RISK_16,
#' Leong_RISK_29, and Zhao_NANO_6.
#' The predicted score for each signature has been stored in the column data
#' section of the input SummarizedExperiment study.
#'
#' @param input A SummarizedExperiment object with gene symbols as the assay row
#' names.
#' @param geneSignaturesName A character string/vector specifying the signature
#' of interest. If \code{any(geneSignaturesName == "") == TRUE}, it will run all
#' available gene signatures' original models.
#' @param useAssay A character string or an integer specifying the assay in the
#' \code{input}. Default is the first assay in the assay list.
#' Used for the test SummarizedExperiment object. Default is \code{1}, indicating the
#' first assay in the \code{input}.
#' @param adj A small positive real number used in \code{\link[sva]{ComBat}} to solve
#' for genes with 0 counts(rare cases). Default is \code{1e-3}.
#' @param BPPARAM An instance inherited from \code{\link[BiocParallel]{bplapply}}.
#'
#' @return A SummarizedExperiment object with predicted scores for each sample
#' obtained from the signature's original model.
#'
#' @export
#'
#' @examples
#' re <- evaluateOriginalModel(input = TB_indian,
#'                             geneSignaturesName = c("Anderson_42"),
#'                             useAssay = "counts")
#' re$Anderson_42_OriginalModel
#'

evaluateOriginalModel <- function(input, geneSignaturesName, useAssay = 1,
                                  adj = 1e-3,
                                  BPPARAM = BiocParallel::SerialParam(
                                      progressbar = TRUE)) {
    ## Check input class, should be SummarizedExperiment
    if (!methods::is(input, "SummarizedExperiment")) {
        base::stop("The \"input\" should be a SummarizedExperiment object.")
    }
    signature_NoRetraining <- c("Anderson_42", "Anderson_OD_51", "Kaforou_27",
                                "Kaforou_OD_44", "Kaforou_OD_53",
                                "Sweeney_OD_3")
    signature_Retraining <- c("Maertzdorf_4", "Maertzdorf_15",
                              "LauxdaCosta_OD_3", "Verhagen_10", "Jacobsen_3",
                              "Sambarey_HIV_10", "Leong_24", "Berry_OD_86",
                              "Berry_393", "Bloom_OD_144", "Suliman_RISK_4",
                              "Zak_RISK_16", "Leong_RISK_29", "Zhao_NANO_6")
    signature_all <- c(signature_NoRetraining, signature_Retraining)
    ## Check whether input geneSignaturesName is valid
    if (base::missing(geneSignaturesName)) {
        stop("Argument \"geneSignaturesName\" is missing, with no default.",
             "\nAvailable signatures are: ",
             base::paste0(signature_all, collapse = ", "))
    }
    if (base::any(geneSignaturesName == "")) {
        base::message("Evaluating all available signatures using",
                      " their original model.")
        ## Remove "" from geneSignaturesName
        geneSignaturesName <- geneSignaturesName[-base::which(
            geneSignaturesName == "")] %>%
            base::union(signature_all)
    }
    ## Intersect input geneSignaturesName with available gene signatures
    sig_sub <- base::intersect(geneSignaturesName, signature_all)
    if (base::identical(sig_sub, character(0))) {
        stop("Original model(s) for \"geneSignaturesName\": ",
             base::paste0(geneSignaturesName, collapse = ", "),
             " is/are not available.\nAvailable signatures are: ",
             base::paste0(signature_all, collapse = ", "))
    }
    ## Check geneSignaturesName that are not available
    sig_not_found <- geneSignaturesName[-base::which(
        geneSignaturesName %in% sig_sub)]
    if (!base::identical(sig_not_found, character(0))) {
        message("Original model(s) for \"geneSignaturesName\": ",
                paste0(sig_not_found, collapse = ", "),
                " are/is not available.")
    }
    sig_sub_NoRetraining <- base::intersect(sig_sub, signature_NoRetraining)
    if (!base::identical(sig_sub_NoRetraining, character(0))) {
        sample_score_NoRetraining <-
            .OriginalModel_NoRetraining(input, useAssay, sig_sub_NoRetraining,
                                        BPPARAM)
    } else {
        sample_score_NoRetraining <- NULL
    }
    sig_sub_Retraining <- base::intersect(sig_sub, signature_Retraining)
    if (!identical(sig_sub_Retraining, character(0))) {
        sample_score_Retraining <-
            .OriginalModel_Retraining(input, useAssay, sig_sub_Retraining,
                                      adj, BPPARAM)
    } else {
        sample_score_Retraining <- NULL
    }
    col_info <- SummarizedExperiment::colData(input)
    if (!base::is.null(sample_score_NoRetraining) &&
        !base::is.null(sample_score_Retraining)) {
        SummarizedExperiment::colData(input) <-
            S4Vectors::cbind(col_info, sample_score_NoRetraining,
                             sample_score_Retraining)
    } else if (!base::is.null(sample_score_NoRetraining) &&
               base::is.null(sample_score_Retraining)) {
        SummarizedExperiment::colData(input) <-
            S4Vectors::cbind(col_info, sample_score_NoRetraining)
    } else {
        SummarizedExperiment::colData(input) <-
            S4Vectors::cbind(col_info, sample_score_Retraining)
    }
    return(input)
}

# Helper function for .OriginalModel_NoRetraining()
noretrain_helper <- function(i, geneSignaturesName, input, useAssay) {
    TBsignaturesSplit <- TBsignaturesSplit
    sig <- geneSignaturesName[i]
    base::message(base::sprintf("Now Evaluating: %s", sig))
    up_set <- TBsignaturesSplit[[sig]][[base::paste0(sig, "_up")]]
    dn_set <- TBsignaturesSplit[[sig]][[base::paste0(sig, "_dn")]]
    dat_sig_up <- base::data.frame(subsetGeneSet(input, up_set, useAssay))
    dat_sig_dn <- base::data.frame(subsetGeneSet(input, dn_set, useAssay))
    if (base::ncol(dat_sig_up) == 0 || base::ncol(dat_sig_dn) == 0) {
        if (base::ncol(dat_sig_up) == 0) {
            base::warning(
                "All up-regulated genes are not found within the input.",
                " Prediction score is NA for signature: ", sig)
        } else {
            base::warning(
                "All down-regulated genes are not found within the input.",
                " Prediction score is NA for signature: ", sig)
        }
        sample_score <- NA
    } else { # Need number of column >=1
        if (sig == "Anderson_42" || sig == "Anderson_OD_51") {
            up_sample_score <- base::rowSums(dat_sig_up)
            dn_sample_score <- base::rowSums(dat_sig_dn)
        } else if (sig == "Kaforou_27" || sig == "Kaforou_OD_44"
                   || sig == "Kaforou_OD_53") {
            up_sample_score <- base::rowMeans(dat_sig_up)
            dn_sample_score <- base::rowMeans(dat_sig_dn)
        } else if (sig == "Sweeney_OD_3") {
            ## Only one gene in down set for Sweeney_OD_3.
            up_sample_score <- base::apply(dat_sig_up, 1, function(x) mean(x))
            dn_sample_score <- base::apply(dat_sig_dn, 1, function(x) mean(x))
        }
        sample_score <- up_sample_score - dn_sample_score
    }
    sample_score
}

#' TB gene signatures that do not require retraining.
#'
#' A function to obtain predicted score for TB gene signatures that do not need to be retrained.
#'
#' Anderson_42 and Anderson_OD_51 used difference of sums to calculate
#' prediction scores. Difference of sums is obtained by subtracting the sum of
#' the expression of genes within signatures that are down-regulated from the
#' sum of the expression of genes that are up-regulated within signatures.
#' Kaforou_27, Kaforou_OD_44, and Kaforou_OD_53 used difference of arithmetic
#' means to calculate prediction scores.
#' Sweeney_OD_3 used difference of arithmetic mean to calculate prediction score.
#'
#' @inheritParams evaluateOriginalModel
#' @return A SummarizedExperiment object with predicted scores for each sample
#' obtained from the signature's original model.

.OriginalModel_NoRetraining <- function(input, useAssay,
                                        geneSignaturesName, BPPARAM) {
    sample_score_list <- BiocParallel::bplapply(
        seq_len(length(geneSignaturesName)), noretrain_helper,
        geneSignaturesName, input, useAssay, BPPARAM = BPPARAM)
    sample_score_result <- base::do.call(base::cbind, sample_score_list)
    base::colnames(sample_score_result) <- base::paste0(geneSignaturesName,
                                                        "_OriginalModel")
    return(sample_score_result)
}

# Helper function for .OriginalModel_Retraining()
retrain_helper <- function(i, geneSignaturesName,
                           input, useAssay, adj) {
    ## Identify signature name
    sig <- geneSignaturesName[i]
    base::message(base::sprintf("Now Evaluating: %s", sig))
    if (sig == "Leong_RISK_29" || sig == "Zak_RISK_16") {
        theObject_train <- OriginalTrainingData[["GSE79362"]]
        if (sig == "Leong_RISK_29") {
            col_info <- SummarizedExperiment::colData(theObject_train)
            ## Only include baseline samples from GSE79362
            sample_baseline_GSE79362 <-
                col_info[, c("PatientID", "MeasurementTime")] %>%
                base::as.data.frame() %>%
                dplyr::mutate(sample_name = base::row.names(col_info)) %>%
                dplyr::arrange(!!dplyr::sym("MeasurementTime"), !!dplyr::sym("PatientID")) %>%
                dplyr::group_by(!!dplyr::sym("PatientID")) %>%
                dplyr::mutate(first = dplyr::first(!!dplyr::sym("sample_name")))
            theObject_train <-
                theObject_train[, base::unique(sample_baseline_GSE79362$first)]
            sample_score <-
                ObtainSampleScore_OriginalModel(
                    theObject_train, useAssay, gene_set = TBsignatures[[sig]],
                    input = input, SigName = sig, obtainDiagnosis = TRUE,
                    annotationColName = "TBStatus",
                    FUN = "cv_glmnet_OriginalModel", adj = adj)
            }
        if (sig == "Zak_RISK_16") {
            theObject_train <-
                theObject_train[, theObject_train$ACS_cohort %in% "Training"]
            sample_score <-
                ObtainSampleScore_OriginalModel(theObject_train, useAssay,
                                                gene_set = TBsignatures[[sig]],
                                                input = input, SigName = sig,
                                                obtainDiagnosis = TRUE,
                                                annotationColName = "TBStatus",
                                                FUN = "svm_OriginalModel",
                                                adj = adj)
        }
        return(sample_score)
    } else if (sig == "Leong_24") {
        theObject_train <- OriginalTrainingData[["GSE101705"]]
        sample_score <-
            ObtainSampleScore_OriginalModel(theObject_train, useAssay,
                                            gene_set = TBsignatures[[sig]],
                                            input = input, SigName = sig,
                                            obtainDiagnosis = TRUE,
                                            annotationColName = "TBStatus",
                                            FUN = "cv_glmnet_OriginalModel",
                                            adj = adj)
        return(sample_score)
    } else if (sig == "Maertzdorf_4" || sig == "Maertzdorf_15") {
        theObject_train <- OriginalTrainingData[["GSE74092"]]
        sample_score <-
            ObtainSampleScore_OriginalModel(theObject_train, useAssay,
                                            gene_set = TBsignatures[[sig]],
                                            input = input, SigName = sig,
                                            obtainDiagnosis = TRUE,
                                            annotationColName = "TBStatus",
                                            FUN = "randomForest_OriginalModel",
                                            adj = adj)
        return(sample_score)
    } else if (sig == "LauxdaCosta_OD_3" || sig == "Bloom_OD_144") {
        theObject_train <- OriginalTrainingData[["GSE42834"]]
        if (sig == "LauxdaCosta_OD_3") {
            sample_score <-
                ObtainSampleScore_OriginalModel(
                    theObject_train, useAssay, gene_set = TBsignatures[[sig]],
                    input = input, SigName = sig, obtainDiagnosis = TRUE,
                    annotationColName = "TBStatus",
                    FUN = "randomForest_OriginalModel", adj = adj)

        if (sig == "Bloom_OD_144")
            sample_score <-
                ObtainSampleScore_OriginalModel(theObject_train, useAssay,
                                                gene_set = TBsignatures[[sig]],
                                                input = input, SigName = sig,
                                                obtainDiagnosis = TRUE,
                                                annotationColName = "TBStatus",
                                                FUN = "svm_OriginalModel",
                                                adj = adj)

        return(sample_score)
    } else if (sig == "Jacobsen_3" || sig == "Berry_393" ||
               sig == "Berry_OD_86") {
        theObject_train <- OriginalTrainingData[["GSE19491"]]
        if (sig == "Jacobsen_3") {
            sample_score <-
                ObtainSampleScore_OriginalModel(theObject_train, useAssay,
                                                gene_set = TBsignatures[[sig]],
                                                input = input, SigName = sig,
                                                obtainDiagnosis = TRUE,
                                                annotationColName = "TBStatus",
                                                FUN = "lda_OriginalModel",
                                                adj = adj)
        }
        if (sig == "Berry_393" || sig == "Berry_OD_86") {
            sample_score <-
                ObtainSampleScore_OriginalModel(theObject_train, useAssay,
                                                gene_set = TBsignatures[[sig]],
                                                input = input, SigName = sig,
                                                obtainDiagnosis = TRUE,
                                                annotationColName = "TBStatus",
                                                FUN = "knn_OriginalModel",
                                                adj = adj)
        }
        return(sample_score)
    } else if (sig == "Sambarey_HIV_10") {
        theObject_train <- OriginalTrainingData[["GSE37250"]]
        sample_score <-
            ObtainSampleScore_OriginalModel(theObject_train, useAssay,
                                            gene_set = TBsignatures[[sig]],
                                            input = input, SigName = sig,
                                            obtainDiagnosis = TRUE,
                                            annotationColName = "TBStatus",
                                            FUN = "lda_OriginalModel",
                                            adj = adj)
        return(sample_score)
    } else if (sig == "Verhagen_10") {
        theObject_train <- OriginalTrainingData[["GSE41055"]]
        sample_score <-
            ObtainSampleScore_OriginalModel(theObject_train, useAssay,
                                            gene_set = TBsignatures[[sig]],
                                            input = input, SigName = sig,
                                            obtainDiagnosis = TRUE,
                                            annotationColName = "TBStatus",
                                            FUN = "randomForest_OriginalModel",
                                            adj = adj)
        return(sample_score)
    } else if (sig == "Suliman_RISK_4") {
        theObject_train <- OriginalTrainingData[["GSE94438"]]
        sample_score <-
            ObtainSampleScore_OriginalModel(theObject_train, useAssay,
                                            gene_set = TBsignatures[[sig]],
                                            input = input,
                                            SigName = sig,
                                            obtainDiagnosis = TRUE,
                                            annotationColName = "TBStatus",
                                            FUN = "SulimanOriginalModel",
                                            adj = adj)
        return(sample_score)
    } else if (sig == "Zhao_NANO_6") {
        theObject_train <- OriginalTrainingData[["Zhao_NANO_6"]]
        sample_score <-
            ObtainSampleScore_OriginalModel(theObject_train, useAssay,
                                            gene_set = TBsignatures[[sig]],
                                            input = input, SigName = sig,
                                            obtainDiagnosis = TRUE,
                                            annotationColName = "TBStatus",
                                            FUN = "cv_glmnet_OriginalModel",
                                            adj = adj)
        return(sample_score)
        }
    }
}

#' TB gene signatures that require retraining.
#'
#' A function to obtain predicted score for TB gene signatures that need retraining of original models.
#'
#' Maertzdorf_4 and Maertzdorf_15 were trained using a random forest to distinguish
#' patients with active TB from healthy controls.
#'
#' Verhagen_10 was also trained using a random forest to distinguish samples with active TB
#' from either latent infection or healthy controls.
#' The random forest model was build using \code{\link[randomForest]{randomForest}}.\cr
#'
#' Jacobsen_3 were trained using linear discriminant analysis (LDA)
#' to distinguish samples with active TB from latent infection status.
#'
#' Sambarey_HIV_10 were also trained using LDA to distinguish samples with active TB
#' from either latent infection, healthy control, or other disease (HIV).
#' The LDA model was built using \code{\link[MASS]{lda}}.\cr
#'
#' Berry_OD_86 and Berry_393 were trained using K-nearest neighbors (KNN) model to
#' differentiate samples with active TB from latent infection status.
#' The KNN model was built using \code{\link[class]{knn}}.\cr
#'
#' Suliman_RISK_4 and Zak_RISK_16 were trained using support vector machines (SVM)
#' to distinguish TB progressor from non-progressors. The input gene expression features
#' for Suliman_RISK_4 used the paired ratio of GAS6/CD1C, SEPTIN4/BLK, SEPTIN4/CD1C, GAS6/BLK.
#' The SVM model was built using \code{\link[e1071]{svm}}.
#'
#' @importFrom magrittr %>%
#' @inheritParams evaluateOriginalModel
#' @return A SummarizedExperiment object with predicted scores for each sample
#' obtained from the signature's original model.

.OriginalModel_Retraining <- function(input, useAssay, geneSignaturesName,
                                      adj, BPPARAM) {
    OriginalTrainingData <- OriginalTrainingData
    TBsignatures <- TBsignatures
    gene_set_length <- base::length(geneSignaturesName)
    sample_score_list <- BiocParallel::bplapply(base::seq_len(gene_set_length),
                                                retrain_helper,
                                                geneSignaturesName,
                                                input, useAssay, adj,
                                                BPPARAM = BPPARAM)
    sample_score_result <- base::do.call(base::cbind, sample_score_list)
    base::colnames(sample_score_result) <- base::paste0(geneSignaturesName,
                                                        "_OriginalModel")
    return(sample_score_result)
}

#' Obtain training data, testing data, and train signature's original model.
#'
#' @inheritParams ref_combat_impute
#' @param obtainDiagnosis Boolean. Used to create training data if TRUE. Default is FALSE
#' @param annotationColName A character string specifying the column name of disease status.
#' Only used when creating training data. Default is NULL.
#' @param FUN A character string specifying the function name of the corresponding signature's original model.
#' @return The predicted score for each sample in the test study using corresponding gene signature's original model.
ObtainSampleScore_OriginalModel <- function(theObject_train, useAssay,
                                            gene_set, input, SigName,
                                            obtainDiagnosis,
                                            annotationColName, FUN, adj) {
    dat_test_sig <- ref_combat_impute(theObject_train, useAssay, gene_set,
                                      input,
                                      SigName, adj)
    if (base::is.null(dat_test_sig)) {
        sample_score <- base::rep(NA, base::ncol(input))
        return(sample_score)
    }
    ## Specify the useAssay = 1 argument for training data explicitly. DO NOT DELETE!
    dat_list <- subsetGeneSet(theObject_train, gene_set, useAssay = 1,
                              obtainDiagnosis, annotationColName)
    FUN <- base::match.fun(FUN)
    sample_score <- FUN(dat_list, dat_test_sig)
    return(sample_score)
}

#' Filter gene expression value matrix based on certain gene sets.
#'
#' A function used to subset gene expression value matrix based on certain gene sets.
#'
#' @param theObject A SummarizedExperiment object that has been pre-stored in
#' OriginalTrainingData.RDA
#' @param gene_set A character vector that includes gene symbols for gene signatures.
#' @param useAssay A character string or an integer specifying the assay in the \code{theObject}
#' that will be selected.
#' @param obtainDiagnosis Boolean. Usually used to create training data if TRUE. Default is FALSE
#' @param annotationColName A character string specifying the column name of disease status.
#' Only used when creating training data. Default is NULL.
#' @return A \code{matrix} with selected gene expression value if \code{obtainDiagnosis == FALSE}.
#' If \code{obtainDiagnosis == TRUE}, return a \code{list} contains the selected
#' gene expression value and diagnosis results for each sample.
#' @importFrom stats median na.pass
subsetGeneSet <- function(theObject, gene_set, useAssay,
                          obtainDiagnosis = FALSE,
                          annotationColName = NULL) {
    dat_assay <- SummarizedExperiment::assays(theObject)[[useAssay]]
    ## Check assay names not found case
    if (base::is.null(dat_assay)) {
        stop(base::sprintf("Input object does not have assay with name: %s",
                           useAssay))
    }
    dat_assay <- dat_assay %>%
        base::as.data.frame()
    ## Update gene names for both gene_set and row names of the input data
    ## Function update_genenames() were found from profile.R
    gene_set <- gene_set %>%
      update_genenames() %>%
      dplyr::pull("new") %>%
      base::unique()
    update_rownames <- base::row.names(dat_assay) %>%
        update_genenames() %>%
        dplyr::pull("new")
    ## Check for duplicated names after updating
    index <- base::which(update_rownames %in% gene_set)
    dat_assay_sig <- dat_assay[index, , drop = FALSE]
    if (base::max(base::table(update_rownames[index])) > 1) {
        ## Collapse duplicated gene names based on median value
        dat_assay_sig$SYMBOL <- update_rownames[index]
        exprs2 <- stats::aggregate(stats::as.formula(". ~ SYMBOL"),
                                   data = dat_assay_sig, FUN = median,
                                   na.action = na.pass)
        base::row.names(exprs2) <- exprs2$SYMBOL
        dat_assay_sig <- exprs2[, -base::which(
            base::colnames(exprs2) == "SYMBOL"),
                                drop = FALSE]
    } else {
        base::row.names(dat_assay_sig) <- update_rownames[index]
    }
    dat_assay_sig <- base::t(dat_assay_sig)
    dat_assay_sig <- dat_assay_sig[, sort(colnames(dat_assay_sig)),
                                   drop = FALSE] %>%
        base::as.matrix()
    if (obtainDiagnosis == FALSE) {
        return(dat_assay_sig)
    } else {
        if (base::is.null(annotationColName)) {
            stop("\"annotationColName\" is not given. Need annotation column",
                 " name to obtain sample diagnosis results.")
        }
        diagnosis_train <- SummarizedExperiment::colData(
            theObject)[, annotationColName]
        dat_list <- base::list(dat_train_sig = dat_assay_sig,
                               diagnosis_train = diagnosis_train)
        return(dat_list)
    }
}

#' A function for reference batch correction and imputation.
#'
#' A function used to perform reference batch correction and imputation in the
#' testing data for gene signatures that require retraining of the model.
#' We used the k-nearest neighbors to impute the expression values for missing gene(s).
#' The imputation operation is achieved using \code{\link[impute]{impute.knn}}.
#' Since the computational time for the imputation step can be excessive for large
#' number of missing genes. We made some constrains to prevent the overflow of imputation
#' operation. The evaluation will not run if more than \code{geneMax}*100\% percent
#' of the genes are not found for the corresponding gene signature in the input study.
#' By default \code{geneMax} = 0.8, so the evaluation will not run if more than 80\%
#' of the genes are missing when matching the input study to the reference data.
#'
#' @param theObject_train A SummarizedExperiment object that has been pre-stored in the
#' data file: OriginalTrainingData.
#' @param useAssay A character string or an integer specifying the assay in the \code{input}.
#' Used for the test SummarizedExperiment object. Default is 1, indicating the first assay
#' in the test SummarizedExperiment object.
#' @param gene_set A character vector that includes gene symbols for selected gene signature.
#' @param input A SummarizedExperiment object with gene symbols as the assay row names.
#' @param SigName Optional. A character string that indicates the name for \code{gene_set}.
#' \code{SigName} is used to provide information when gene signatures were missing
#' in the test data.
#' @param adj A small real number used in combat to solve for genes with 0 counts in rare cases.
#' Not required for most of cases.
#' @param geneMax A real number between 0 and 1. This is used to detect the
#' maximum percent missing genes allowed in the evaluated signatures.
#' See \code{\link[impute]{impute.knn}} for details. The default value is 0.8.
#' @return Gene set subset

ref_combat_impute <- function(theObject_train, useAssay, gene_set, input,
                              SigName, adj, geneMax = 0.8) {
    object_list <- base::list(GSE_train = theObject_train, GSE_test = input)
    ## Specify the useAssay = 1 argument for training data explicitly. DO NOT DELETE!
    dat_train_assay_sig <- base::t(subsetGeneSet(theObject_train, gene_set, 1))
    dat_test_assay_sig <- base::t(subsetGeneSet(input, gene_set, useAssay))
    index_match <- base::match(base::row.names(dat_train_assay_sig),
                               base::row.names(dat_test_assay_sig))
    index_match_boolean <- base::is.na(index_match)
    if (base::all(index_match_boolean)) {
        warning("No genes are found in the input study within given gene",
        " signatures: ", SigName, ". The model will not run and signature ",
        "score will be NA.")
        return(NULL)
    }
    if (sum(index_match_boolean) > floor(geneMax * length(index_match))) {
        warning(sprintf("More than %1.2f%% of the genes are missing in the input study for gene signatures: %s.",
                                    100 * geneMax, SigName))
    }
    dat_exprs_match_sub <- list(
        GSE_train = base::data.frame(dat_train_assay_sig),
        GSE_test = base::data.frame(dat_test_assay_sig))
    dat_exprs_combine <- base::Reduce(
      function(x, y) base::merge(x, y, by = "id", all.x = TRUE),
        base::lapply(dat_exprs_match_sub, function(x) {
            x$id <- base::row.names(x)
            x
        }))
    row_names <- dat_exprs_combine$id
    dat_exprs_count <- dat_exprs_combine %>%
        dplyr::select(-"id") %>%
        base::as.data.frame()
    row.names(dat_exprs_count) <- row_names
    # Check for NA's in the dat_exprs_counts
    if (base::sum(base::is.na(dat_exprs_count)) == 0) {
        dat_exprs_count1 <- base::as.matrix(dat_exprs_count)
    } else {
        # Genes in the training data are not found in testing.
        # Use KNN imputation
        # DO some checks on the number of missing genes
        num_missing_gene <- sum(is.na(
            dat_exprs_count[, ncol(dat_exprs_count)]))
        # Calculate impute parameters for function: impute.knn
        colmax <- min(1, round(num_missing_gene / nrow(dat_exprs_count),
                               5) + 1e-5)
        rowmax <- min(1, round(
            ncol(dat_test_assay_sig) / ncol(dat_exprs_count), 5) + 1e-5)
        common_genes <- row.names(dat_test_assay_sig)[
            stats::na.omit(index_match)]
        missing_genes <- row.names(dat_train_assay_sig)[
            !row.names(dat_train_assay_sig) %in% common_genes]
        message("Gene(s): ", paste0(missing_genes, collapse = ", "),
                " is/are not found in the input study for gene signature: ",
                SigName, "\nImpute missing features using KNN")
        output <- impute::impute.knn(as.matrix(dat_exprs_count), k = 10,
                                     rowmax = rowmax, colmax = colmax)
        dat_exprs_count1 <- output$data
    }
    ## Obtain annotation data from the samples
    col_data <- lapply(base::seq_len(base::length(object_list)), function(x) {
        col_data <- SummarizedExperiment::colData(object_list[[x]])
        col_data$GSE <- base::names(object_list[x])
        col_data
    })
    col_info <- plyr::rbind.fill(base::lapply(col_data, function(x) {
        x$SampleName <- base::row.names(x)
        base::as.data.frame(x)
    }))
    mod1 <- stats::model.matrix(~ 1, data = col_info)
    # Use reference combat with tryCatch
    # +1e-3 to solve for genes with 0 counts in rare cases
    ref_combat_tryCatch <- function(dat_exprs_count1) {
        tryCatch(
            expr = {
                sva::ComBat(dat = dat_exprs_count1,
                            batch = col_info$GSE, mod = mod1,
                            ref.batch = "GSE_train")
            },
            error = function(e) {
                sva::ComBat(dat = dat_exprs_count1 + adj,
                            batch = col_info$GSE, mod = mod1,
                            ref.batch = "GSE_train")
            }
        )
    }
    combat_edata <- ref_combat_tryCatch(dat_exprs_count1)
    runindata_test <-
        combat_edata[, (ncol(theObject_train) + 1):ncol(combat_edata)]
    base::colnames(runindata_test) <- base::colnames(input)
    ## Specify useAssay = 1 explicitly as we are creating new Sobject
    dat_test_sig <- SummarizedExperiment::SummarizedExperiment(
        assay = as.matrix(runindata_test)) %>%
        subsetGeneSet(gene_set, useAssay = 1)
    return(dat_test_sig)
}

#' Train original model for gene signatures Leong_24, Leong_RISK_29, Zhao_NANO_6 using lasso logistic regression.
#'
#' @param dat_list A \code{list} contains training data and disease status
#' outcomes from the discovery data of corresponding gene signatures.
#' @param dat_test_sig A \code{data frame} contains corresponding gene sets
#' from the \code{input}.
#' @return The predicted score for each sample in the test study.

cv_glmnet_OriginalModel <- function(dat_list, dat_test_sig) {
    diagnosis_train <- dat_list$diagnosis_train
    diagnosis_train_new <- ifelse(diagnosis_train == "PTB", "PTB", "Others")
    diagnosis_train <- base::factor(diagnosis_train_new,
                                    levels = c("Others", "PTB")) %>%
        base::as.integer()
    sig_model <- glmnet::cv.glmnet(x = dat_list$dat_train_sig,
                                   y = diagnosis_train)
    sample_score <- stats::predict(sig_model$glmnet.fit,
                                   s = sig_model$lambda.min,
                                   newx = dat_test_sig, na.action = na.omit)
    pred_score <- base::as.vector(sample_score)
    return(pred_score)
}

#' Train original model for gene signatures Maertzdorf_4, Maertzdorf_15, Verhagen_10,
#' and LauxdaCosta_OD_3.
#'
#' @inheritParams cv_glmnet_OriginalModel
#' @importFrom stats na.omit
#' @return The predicted score for each sample in the test study.

randomForest_OriginalModel <- function(dat_list, dat_test_sig) {
    diagnosis_train <- dat_list$diagnosis_train
    diagnosis_train_new <- ifelse(diagnosis_train == "PTB", "PTB", "Others")
    diagnosis_train <- base::factor(diagnosis_train_new,
                                    levels = c("Others", "PTB"))
    sig_model <- randomForest::randomForest(x = dat_list$dat_train_sig,
                                            y = as.factor(diagnosis_train),
                                            ntree = 5000, importance = TRUE)
    sample_score <- stats::predict(object = sig_model, newdata = dat_test_sig,
                                   type = "prob")
    pred_score <- base::unlist(sample_score[, 2], use.names = FALSE)
    return(pred_score)
}

#' Train original model for gene signatures Jacobsen_3 and Sambarey_HIV_10.
#'
#' @inheritParams cv_glmnet_OriginalModel
#' @return The predicted score for each sample in the test study.

lda_OriginalModel <- function(dat_list, dat_test_sig) {
    diagnosis_train <- dat_list$diagnosis_train
    diagnosis_train_new <- ifelse(diagnosis_train == "PTB", "PTB", "Others")
    diagnosis_train <- base::factor(diagnosis_train_new,
                                    levels = c("Others", "PTB")) %>%
        base::as.integer()
    sig_model <- MASS::lda(diagnosis_train ~ .,
                           data.frame(dat_list$dat_train_sig, diagnosis_train))
    sample_score <- stats::predict(sig_model, data.frame(dat_test_sig))
    pred_score <- base::as.vector(sample_score$posterior[, 2])
    return(pred_score)
}

#' Train original model for gene signatures Berry_393 and Berry_OD_86.
#'
#' @inheritParams cv_glmnet_OriginalModel
#' @return The predicted score for each sample in the test study.

knn_OriginalModel <- function(dat_list, dat_test_sig) {
    diagnosis_train <- dat_list$diagnosis_train
    dat_train_sig <- dat_list$dat_train_sig
    diagnosis_train_new <- ifelse(diagnosis_train == "PTB", "PTB", "Others")
    diagnosis_train <- base::factor(diagnosis_train_new,
                                    levels = c("Others", "PTB")) %>%
        base::as.integer()
    sig_model <- class::knn(train = dat_train_sig, test = dat_test_sig,
                            cl = diagnosis_train, k = 10, prob = TRUE)
    sample_score_ori <- base::attributes(sig_model)$prob
    pred_result <- base::data.frame(sample_score_ori, sig_model)
    pred_result_nrow <- base::nrow(pred_result)
    pred_score <- rep(0, pred_result_nrow)
    for (i in base::seq_len(pred_result_nrow)) {
        pred_score[i] <- ifelse(pred_result$sig_model[i] == 2,
                                pred_result$sample_score_ori[i],
                                1 - pred_result$sample_score_ori[i])
    }
    return(pred_score)
}

#' Train original model for gene signatures Bloom_OD_144 and Zak_RISK_16.
#'
#' @inheritParams cv_glmnet_OriginalModel
#' @return The predicted score for each sample in the test study.

svm_OriginalModel <- function(dat_list, dat_test_sig) {
    diagnosis_train <- dat_list$diagnosis_train
    diagnosis_train_new <- ifelse(diagnosis_train == "PTB", "PTB", "Others")
    diagnosis_train <- factor(diagnosis_train_new,
                              levels = c("Others", "PTB")) %>%
        base::as.integer()
    sig_model <- suppressWarnings(e1071::svm(x = dat_list$dat_train_sig,
                                             y = diagnosis_train,
                                             type = "nu-regression",
                                             kernel = "linear",
                                             cost = 100, cachesize = 5000,
                                             tolerance = 0.01,
                                             shrinking = FALSE, cross = 3))
    pred_score <- stats::predict(sig_model, dat_test_sig)
    return(pred_score)
}

#' Train original model gene signature Suliman_RISK_4.
#'
#' @inheritParams cv_glmnet_OriginalModel
#' @return The predicted score for each sample in the test study.

SulimanOriginalModel <- function(dat_list, dat_test_sig) {
    diagnosis_train <- dat_list$diagnosis_train
    diagnosis_train_new <- ifelse(diagnosis_train == "PTB", "PTB", "Others")
    diagnosis_train <- base::factor(diagnosis_train_new,
                                    levels = c("Others", "PTB")) %>%
        base::as.integer()
    dat_train_sig <- dat_list$dat_train_sig
    dat_train_sig <- data.frame(
        GAS6_CD1C = dat_train_sig[, "GAS6"] / dat_train_sig[, "CD1C"],
        SEPTIN4_BLK = dat_train_sig[, "SEPTIN4"] / dat_train_sig[, "BLK"],
        SEPTIN4_CD1C = dat_train_sig[, "SEPTIN4"] / dat_train_sig[, "CD1C"],
        GAS6_BLK = dat_train_sig[, "GAS6"] / dat_train_sig[, "BLK"])
    dat_test_sig <- data.frame(
        GAS6_CD1C = dat_test_sig[, "GAS6"] / dat_test_sig[, "CD1C"],
        SEPTIN4_BLK = dat_test_sig[, "SEPTIN4"] / dat_test_sig[, "BLK"],
        SEPTIN4_CD1C = dat_test_sig[, "SEPTIN4"] / dat_test_sig[, "CD1C"],
        GAS6_BLK = dat_test_sig[, "GAS6"] / dat_test_sig[, "BLK"])
    sig_model <- suppressWarnings(e1071::svm(
        x = dat_train_sig, y = diagnosis_train, type = "nu-regression",
        kernel = "linear", cost = 100, cachesize = 5000, tolerance = 0.01,
        shrinking = FALSE, cross = 3))
    pred_score <- stats::predict(sig_model, dat_test_sig)
    return(pred_score)
}

context("test-OriginalModel")
## Use "TB_hiv" as example for the input
mat_testdata <- rbind(matrix(c(rnorm(80), rnorm(80) + 5), 16, 10,
                             dimnames = list(TBsignatures$Zak_RISK_16,
                                             paste0("sample", 1:10))),
                      matrix(rnorm(1000), 100, 10,
                             dimnames = list(paste0("gene", 1:100),
                                             paste0("sample", 1:10))))
col_info <- S4Vectors::DataFrame(condition = rep(c("Disease", "Control"), each = 5),
                                 row.names = colnames(mat_testdata))
sobject <- SummarizedExperiment::SummarizedExperiment(assays = list(counts = mat_testdata),
                                                      colData = col_info)

test_that("\"input\" should be a SummarizedExperiment object.", {
    expect_error(evaluateOriginalModel(input = mat_testdata,
                                       geneSignaturesName = "Zak_RISK_16"))
})

test_that("Argument \"geneSignaturesName\" cannot be missing.", {
    expect_error(evaluateOriginalModel(input = TB_hiv, useAssay = "counts"))
})

test_that("Gene sets not found from the \"input\"", {
    re <- suppressWarnings(evaluateOriginalModel(input = sobject,
                                geneSignaturesName = c("Anderson_42", "Leong_RISK_29"),
                                useAssay = "counts"))
    expect_identical(re$Leong_RISK_29_OriginalModel, rep(NA, dim(re)[2]))
    expect_identical(re$Anderson_42_OriginalModel, rep(NA, dim(re)[2]))
    expect_warning(evaluateOriginalModel(input = sobject,
                                       geneSignaturesName = "Leong_RISK_29",
                                       useAssay = "counts"))
    expect_warning(evaluateOriginalModel(input = sobject,
                                         geneSignaturesName = "Anderson_42",
                                         useAssay = "counts"))
})

test_that("Input signatures' original model not available.", {
    expect_error(evaluateOriginalModel(input = TB_hiv,
                                       geneSignaturesName = "EXAMPLE_NAME",
                                       useAssay = "counts"))
    expect_message(evaluateOriginalModel(input = TB_hiv,
                                         geneSignaturesName = c("EXAMPLE_NAME",
                                                                "Zak_RISK_16"),
                                         useAssay = "counts"))
})

test_that("Assay not found from the input.", {
    expect_error(evaluateOriginalModel(input = TB_hiv,
                                       geneSignaturesName = "Zak_RISK_16",
                                       useAssay = "EXAMPLE_ASSAY"))
})

test_that("Return type is a SummarizedExperiment object.", {
    re <- evaluateOriginalModel(input = TB_hiv,
                                geneSignaturesName = "Zak_RISK_16",
                                useAssay = "counts")
    expect_s4_class(re, "SummarizedExperiment")
})

shiny::navbarMenu(
  "AUCs Via Bootstrapping",
  shiny::tabPanel(
    "T-tests & AUC",
    DT::dataTableOutput("ttest") %>% shinycssloaders::withSpinner()
  ),
  shiny::tabPanel(
    "Boxplots for the bootstrapped AUCs",
    shiny::sidebarPanel(
      shinyWidgets::pickerInput(
        "bootsigs", "Select Signatures", choices = siglist,
        options = list("actions-box" = TRUE), multiple = TRUE, selected = NULL),
      shiny::actionButton("bootplot", "Plot Bootstrapped AUCs")
    ),
    shiny::mainPanel(plotOutput("bootbox", height = 600))
  ),
  shiny::tabPanel(
    "Separate ROC plots, 95% CI Bands",
    shiny::sidebarPanel(
      shinyWidgets::pickerInput(
        "singroc", "Select Signature(s)", choices = siglist,
        options = list("actions-box" = TRUE), multiple = TRUE, selected = NULL),
      shiny::actionButton("rocplot", "Plot ROC Curve")
    ),
    shiny::mainPanel(
      shiny::plotOutput("rocsep", height = 450)
    )
  )
)

shiny::tabPanel(
  "Run TB Signature Profiler",
  shiny::sidebarPanel(
    shinyWidgets::pickerInput(
      "newassay", label = "Make Assay",
      choices = c("Log Counts" = "log", "CPM" = "cpm", "Log CPM" = "logcpm")),
    shiny::actionButton("mkassay", "Make Assay"),
    shiny::hr(),
    shiny::selectInput("profassay", "Select Assay for Profiler",
                       choices = NULL),
    shiny::selectInput("profalg", "Select Algorithm for Profiler",
                       choices = c("GSVA", "ssGSEA", "ASSIGN", "PLAGE",
                                   "Zscore", "singscore")),
    shiny::actionButton("runprofiler", "Run Profiler")
  ),
  shiny::mainPanel(
    shiny::h4("Covariates"),
    shiny::tableOutput("covars"),
    shiny::h4("Assays"),
    shiny::tableOutput("assays"),
    shiny::h4("TBSignatureProfiler Data"),
    shiny::hr(),
    DT::dataTableOutput("visdat", width = 700)
  )
)

output$covars <- shiny::renderTable({
  vals$covars
}, colnames = FALSE)

output$assays <- shiny::renderTable({
  vals$datassays
}, colnames = FALSE)

shiny::observeEvent(input$runprofiler, {
  output$visdat <- DT::renderDataTable(
    head(as.data.frame(SummarizedExperiment::colData(vals$profilerdat))),
    options = list(scrollX = TRUE)
  )
})

shiny::observeEvent(input$mkassay, {
  if (input$newassay == "log") {
    vals$tbdat <- mkAssay(vals$tbdat, input_name = "counts",
                          log = TRUE, counts_to_CPM = FALSE)
    vals$datassays <- names(SummarizedExperiment::assays(vals$tbdat))
  } else if (input$newassay == "cpm") {
    vals$tbdat <- mkAssay(vals$tbdat, input_name = "counts")
    vals$datassays <- names(SummarizedExperiment::assays(vals$tbdat))
  } else if (input$newassay == "logcpm") {
    vals$tbdat <- mkAssay(vals$tbdat, input_name = "counts", log = TRUE)
    vals$datassays <- names(SummarizedExperiment::assays(vals$tbdat))
  }
})

shiny::observe({
  updateSelectInput(session, "profassay", choices = vals$datassays)
})

shiny::observeEvent(input$runprofiler, {
  vals$profilerdat <- shiny::isolate(
    runTBsigProfiler(vals$tbdat,
                     useAssay = input$profassay,
                     signatures = TBsignatures,
                     algorithm = input$profalg,
                     combineSigAndAlgorithm = TRUE,
                     parallel.sz = 4,
                     update_genes = FALSE))
})

shiny::observeEvent(input$runprofiler, {
  output$allheat <- NULL
  output$indheat <- NULL
  output$boxplotind <- NULL
  output$heatcomp <- NULL
  output$bootbox <- NULL
  output$rocsep <- NULL
})

shiny::observe({
  if (is.null(vals$profilerdat)) {
    shinyWidgets::updatePickerInput(session, "selectsigs", choices = NULL)
  } else {
    shiny::isolate(
      shinyWidgets::updatePickerInput(
        session, "selectsigs", choices = subset(
          siglist,
          siglist %in% colnames(
            SummarizedExperiment::colData(vals$profilerdat))),
        selected = subset(
          siglist, siglist %in% colnames(
            SummarizedExperiment::colData(vals$profilerdat)))))
  }
})

shiny::observe({
  shiny::updateSelectInput(session, "allheatcovar", choices = vals$covars)
})

shiny::observeEvent(input$allheatplot, {
  output$allheat <- shiny::renderPlot({
    colors <- RColorBrewer::brewer.pal(6, "Spectral")
    col_me <- circlize::colorRamp2(base::seq(from = -2, to = 2,
                                             length.out = 6), colors)
    shiny::isolate({
      signatureHeatmap(
        vals$profilerdat, name = "Heatmap of Signatures",
        signatureColNames = names(TBsignatures[input$selectsigs]),
        annotationColNames = input$allheatcovar, scale = TRUE,
        showColumnNames = TRUE, choose_color = col_me)
    })
  })
})

shiny::observe({
  shiny::updateSelectInput(session, "singheatcovar", choices = vals$covars)
})

shiny::observe({
  if (is.null(vals$profilerdat)) {
    shinyWidgets::updatePickerInput(session, "singheat", choices = NULL)
  } else {
    shinyWidgets::updatePickerInput(
      session, "singheat", choices = subset(
        siglist, siglist %in% colnames(
          SummarizedExperiment::colData(vals$profilerdat))))
  }
})

shiny::observe({
  shinyWidgets::updatePickerInput(session, "genes",
                                  choices = TBsignatures[input$singheat],
                                  selected = TBsignatures[[input$singheat]])
  })

shiny::observeEvent(input$singheatplot, {
  output$indheat <- shiny::renderPlot({
    shiny::isolate({
      print(signatureGeneHeatmap(inputData = vals$profilerdat,
                                 useAssay = input$profassay,
                                 input$genes,
                                 signatureColNames = input$singheat,
                                 annotationColNames = input$singheatcovar,
                                 showColumnNames = TRUE))
      })
    })
  })

shiny::observe({
  if (is.null(vals$profilerdat)) {
    shinyWidgets::updatePickerInput(session, "singbox", choices = NULL)
  } else {
    shinyWidgets::updatePickerInput(
      session, "singbox", choices = subset(
        siglist, siglist %in% colnames(colData(vals$profilerdat))))
  }
})

shiny::observe({
  shiny::updateSelectInput(session, "singboxcovar",
                                  choices = vals$covars)
})

shiny::observeEvent(input$singboxplot, {
  output$boxplotind <- shiny::renderPlot({
    shiny::isolate({
      print(signatureBoxplot(vals$profilerdat,
                             signatureColNames = input$singbox,
                             annotationColName = input$singboxcovar))
    })
  })
})

shiny::observe({
  if (is.null(vals$profilerdat)) {
    shiny::updateSelectInput(session, "singcomp", choices = NULL)
  } else {
    shiny::updateSelectInput(
      session, "singcomp", choices = subset(
        siglist, siglist %in% colnames(
          SummarizedExperiment::colData(vals$profilerdat))))
  }
})

shiny::observe({
  shiny::updateSelectInput(session, "compassay", choices = vals$datassays)
})

shiny::observe({
  shiny::updateSelectInput(session, "compcovar", choices = vals$covars)
})

shiny::observeEvent(input$compplot, {
  output$heatcomp <- shiny::renderPlot({
    shiny::isolate({
      suppressWarnings(compareAlgs(vals$profilerdat,
                                   annotationColName = input$compcovar,
                                   scale = TRUE,
                                   algorithm = input$compalg,
                                   useAssay = input$compassay,
                                   signatures = TBsignatures[input$singcomp],
                                   show.pb = TRUE))
    })
  })
})

#' Run the TBSignatureProfiler Shiny application.
#'
#' Use this function to run the TBSignatureProfiler application.
#'
#'
#' @return The Shiny application will open.
#'
#' @export
#'
#' @examples
#' # Upload data through the app
#' if (interactive()) {
#'   TBSPapp()
#' }
#'
TBSPapp <- function() {
  appDir <- system.file("shiny", package = "TBSignatureProfiler")
  shiny::runApp(appDir, display.mode = "normal")
}

## ----load_profiler, eval = FALSE----------------------------------------------
# if (!requireNamespace("BiocManager", quietly = TRUE))
#   install.packages("BiocManager")
# BiocManager::install("TBSignatureProfiler")

## ----setup--------------------------------------------------------------------
suppressPackageStartupMessages({
  library(TBSignatureProfiler)
  library(SummarizedExperiment)
})

## ----Run_shiny_app, eval = FALSE----------------------------------------------
# TBSPapp()

## ----loading_data-------------------------------------------------------------
## HIV/TB gene expression data, included in the package
hivtb_data <- get0("TB_hiv", envir = asNamespace("TBSignatureProfiler"))

### Note that we have 25,369 genes, 33 samples, and 1 assay of counts
dim(hivtb_data)

# We start with only one assay
assays(hivtb_data)

## ----add_assays---------------------------------------------------------------
## Make a log counts, CPM and log CPM assay
hivtb_data <- mkAssay(hivtb_data, log = TRUE, counts_to_CPM = TRUE)

### Check to see that we now have 4 assays
assays(hivtb_data)

## ----run_data-----------------------------------------------------------------
## List all signatures in the profiler
data("TBsignatures")
names(TBsignatures)

## We can use all of these signatures for further analysis
siglist_hivtb <- names(TBsignatures)

## ----session info-------------------------------------------------------------
sessionInfo()

# Coverage Script
# Run tests and generate Code Coverage Report

# Look at a specific script ---------------------------------------------------
#test_for_me <- function(codefile, testfile) {
#  test_file(testfile)
#  res <- covr::file_coverage(codefile, testfile)
#  print(res)
#  covr::report(res)
#}

#test_for_me("R/evaluate.R", "tests/testthat/test-evaluate.R")
# Look at whole package -------------------------------------------------------
# Gets percent coverage for entire package, by script
#covr::package_coverage()
#
# Report with gui (probably the best here)
#covr::report()

shiny::tabPanel(
  "Upload Data",
  tags$div(
    class = "jumbotron", style = "background-color:#ededed",
    tags$div(
      class = "container",
      shiny::h1("TB Signature Profiler"),
      shiny::p("Score, compare and visualize gene signatures"),
    )
  ),
  shiny::sidebarPanel(
    shiny::radioButtons(
      "dat", "Select Data", choices = c("Sample Data" = "samp",
                                        "Upload Data" = "updat")),
    shiny::conditionalPanel(
      condition = "input.dat == 'samp'",
      shiny::radioButtons(
        "sampdat", "Sample Datasets",
        choices = c("TB HIV" = "tbhiv", "TB Indian" = "tbind"),
        selected = NULL)
    ),
    shiny::conditionalPanel(
      condition = "input.dat == 'updat'",
      shiny::radioButtons(
        "updattype", "Choose File Type",
        choices = c(
          "Tab Separated Text Files" = "rawdat",
          "Summarized Experiment" = "sumexp"),
        selected = NULL)
    ),
    shiny::hr(),
    shiny::actionButton("upload", "Upload")),
  shiny::mainPanel(
    shiny::conditionalPanel(
      condition = "input.dat == 'updat'",
      shiny::conditionalPanel(
        condition = "input.updattype == 'rawdat'",
        shiny::column(
          width = 4,
          shiny::wellPanel(
            shiny::h4("Upload Count File"),
            shiny::fileInput(
              "countsfile",
              shiny::HTML(
                base::paste(
                  "Input assay (eg. counts, required):",
                  tags$span(style = "color:red", "*", sep = ""))
              ),
              accept = c(
                "text/csv",
                "text/comma-separated-values",
                "text/tab-separated-values",
                "text/plain", ".csv", ".tsv"
              )
            )
          )
        ),
        shiny::column(
          width = 4,
          shiny::wellPanel(
            shiny::h4("Upload Meta Data File"),
            shiny::fileInput(
              "metdatfile",
              shiny::HTML(
                base::paste(
                  "Meta Data (eg. disease, required):",
                  tags$span(style = "color:red", "*", sep = ""))
              ),
              accept = c(
                "text/csv",
                "text/comma-separated-values",
                "text/tab-separated-values",
                "text/plain", ".csv", ".tsv"
              )
            )
          )
        ),
        shiny::selectInput(
          "datassay",
          label = "Input Assay Type:",
          choices = c("Counts" = "counts", "Log Counts" = "log",
                      "CPM" = "cpm", "Log CPM" = "logcpm")
        )
      ),
      shiny::conditionalPanel(
        condition = "input.updattype == 'sumexp'",
        shiny::h3(paste("Choose an RDS Summarized Experiment file",
                        "that contains a TBSignature Object:")),
        shiny::fileInput("rdsFile", "TBSignature RDS file:",
                         accept = c(".rds", ".RDS"))
      )
    ),
    DT::dataTableOutput("counttable", width = 700)
  )
)

globalVariables(c("BS_AUC", "FPR", "LowerTPR", "Signatures",
                  "TBsignatures", "TPR", "UpperTPR", "sigAnnotData"))

#' Bootstrap the AUC and conduct T-Tests for a collection of signatures.
#'
#' Run bootstrapping of the AUC and derive the p-value for a 2-sample t-test
#' for all signatures tested on a given dataset.
#'
#' @param SE_scored a \code{SummarizedExperiment} object with genes as the
#' row features and signature scores in the \code{colData}. There should also
#' be a column of annotation data. Required.
#' @param annotationColName a character string giving the column name in
#' \code{colData} that contains the annotation data. Required.
#' @param signatureColNames a vector of column names in the
#' \code{colData} that contain the signature score data. Required.
#' @param num.boot integer. The number of times to bootstrap the data. The
#' default is \code{100}.
#' @param pb.show logical for whether to show a progress bar while running code.
#' The default is \code{TRUE}.
#'
#' @return A list of length 5 returning a vector of p-values for a 2-sample
#' t-test, bootstrapped AUC values, an AUC value for using all scored values
#' for all signatures specified in \code{signatureColNames},
#' and values for the lower and upper bounds of a bootstrapped AUC confidence
#' interval using \code{pROC::roc()}.
#'
#' @export
#'
#' @examples
#'  # Run signature profiling
#'  choose_sigs <- list("madeupsig" = c("FCRL3", "OAS2", "IFITM3"))
#'  prof_indian <- runTBsigProfiler(TB_indian, useAssay = "logcounts",
#'                                  algorithm = "ssGSEA",
#'                                  combineSigAndAlgorithm = TRUE,
#'                                  signatures = choose_sigs,
#'                                  parallel.sz = 1)
#'  # Bootstrapping
#'  booted <- bootstrapAUC(SE_scored = prof_indian, annotationColName = "label",
#'                         signatureColNames = names(choose_sigs), num.boot = 2)
#'  booted
#'
bootstrapAUC <- function(SE_scored, annotationColName, signatureColNames,
                         num.boot = 100, pb.show = TRUE) {
  annotationData <- SummarizedExperiment::colData(SE_scored)[annotationColName][, 1]
  if (!is.factor(annotationData)) annotationData <- as.factor(annotationData)

  # Create progress bar
  total <- length(signatureColNames)
  counter <- 0
  if (pb.show)  pb <- utils::txtProgressBar(min = 0, max = total, style = 3)

  # Initialize containers
  pvals <- aucs <- pROC_lower <- pROC_upper <- numeric(total)
  aucs_boot <- matrix(nrow = num.boot,
                      ncol = total,
                      dimnames = list(seq(num.boot),
                                      signatureColNames))

  for (i in signatureColNames) {
    which.sig <- which(signatureColNames == i)
    score <- SummarizedExperiment::colData(SE_scored)[i][, 1]
    # Conduct a 2-sample t-test on the scores and their
    # corresponding Tuberculosis group status
    pvals[which.sig] <- stats::t.test(score ~ annotationData)$p.value

    # Obtain AUC based on entire dataset
    auc <- ROCit::rocit(score, annotationData)$AUC
    aucs[which.sig] <- max(auc, 1 - auc)

    # Proceed with bootstrapping
    for (j in seq_len(num.boot)) {
      index <- sample(seq_along(score), replace = TRUE)
      tmp_score <- score[index]
      tmp_annotationData <- annotationData[index]
      if (length(unique(tmp_annotationData)) == 2) {
        pred <- ROCit::rocit(tmp_score, tmp_annotationData)
      } else {
        # If there's only one value to be predicted, resample
        index <- sample(seq_along(score), replace = TRUE)
        tmp_score <- score[index]
        tmp_annotationData <- annotationData[index]
        pred <- ROCit::rocit(tmp_score, tmp_annotationData)
      }
      tmp_auc <- max(pred$AUC, 1 - pred$AUC)
      aucs_boot[j, which.sig] <- tmp_auc
    }

    # pROC
    roc1 <- suppressMessages(pROC::roc(predictor = score,
                                       response = annotationData))
    conf <- pROC::ci.auc(roc1, method = "delong", progress = "none")
    pROC_lower[which.sig] <- round(conf[1], 4)
    pROC_upper[which.sig] <- round(conf[3], 4)

    # Update the progress bar
    counter <- counter + 1
    if (pb.show) utils::setTxtProgressBar(pb, counter)
  }

  if (pb.show) close(pb)
  return(list("P-values" = pvals, "Boot AUC Values" = aucs_boot,
              "Non-Boot AUC Values" = aucs,
              "pROC Lower" = pROC_lower, "pROC Upper" = pROC_upper))
}

#' Create a table of results for t-tests and bootstrapped AUCs for multiple scored signatures.
#'
#' This function collects the results of bootstrapping and t-tests for a scored
#' gene expression dataset and presents them using a JavaScript table with an
#' R interface, or as a \code{data.frame}.
#'
#' @inheritParams bootstrapAUC
#' @param output a character string indicating the table output format. Possible
#' values are \code{DataTable} and \code{data.frame}. The default is
#' \code{DataTable}.
#'
#' @export
#'
#' @return A JavaScript table with an R interface using the \code{DT} package.
#'
#' @examples
#' # Run signature profiling
#'  choose_sigs <- TBsignatures[c(1, 2)]
#'  prof_indian <- runTBsigProfiler(TB_indian, useAssay = "logcounts",
#'                                  algorithm = "ssGSEA",
#'                                  signatures = choose_sigs,
#'                                  parallel.sz = 1,
#'                                  update_genes = FALSE)
#'  # Create table
#'  tableAUC(SE_scored = prof_indian, annotationColName = "label",
#'           signatureColNames = names(choose_sigs))
#'
#'  # Create data.frame object
#' h <-  tableAUC(SE_scored = prof_indian, annotationColName = "label",
#'                signatureColNames = names(choose_sigs),
#'                output = "data.frame",
#'                num.boot = 5)
#' head(h)
#'
tableAUC <- function(SE_scored, annotationColName, signatureColNames,
                     num.boot = 100, pb.show = TRUE, output = "DataTable") {
  BS.Results <- bootstrapAUC(SE_scored, annotationColName, signatureColNames,
                             num.boot, pb.show)
  pvals <- BS.Results[["P-values"]]
  aucs_boot <- BS.Results[["Boot AUC Values"]]
  aucs <- BS.Results[["Non-Boot AUC Values"]]
  lowerAUC <- round(apply(aucs_boot, 2, stats::quantile,
                          probs = .025), 4)
  upperAUC <- round(apply(aucs_boot, 2, stats::quantile,
                          probs = .975), 4)
  return_table <- data.frame("Signature" = signatureColNames,
                             "P.value" = round(pvals, 4),
                             "neg10xLog(P.value)" =
                               round(-10 * log(pvals), 4),
                             "LowerAUC" = lowerAUC,
                             "AUC" = round(aucs, 4),
                             "UpperAUC" = upperAUC)
  return_table$Signature <- paste(return_table$Signature)
  rownames(return_table) <- c(seq(1, nrow(return_table)))
  
  # Create interactive table
  if (output == "DataTable") {
    return(DT::datatable(return_table[order(aucs, decreasing = TRUE), ],
                         options = list(scrollX = TRUE, pageLength = 10),
                         rownames = FALSE))
  } else if (output == "data.frame") {
    return(return_table)
  }
  
}

#' Create a comparison plot of boxplots for bootstrapped AUC values.
#'
#' Present the results of AUC bootstrapping for a collection of scored
#' signatures via boxplots.
#'
#' @inheritParams bootstrapAUC
#' @param num.boot an integer indicating the number of times to bootstrap the
#' data.
#' @param name a character string giving the overall title for the plot.
#' The default is \code{"Boxplot Comparison of Signature AUCs"}.
#' @param pb.show logical for whether to show a progress bar while running code.
#' Default is \code{TRUE}.
#' @param abline.col the color to be used for the dotted line at AUC = 0.5
#' (the chance line). The default is \code{"red"}.
#' @param fill.col the color to be used to fill the boxplots.
#' The default is \code{"white"}.
#' @param outline.col the color to be used for the boxplot outlines.
#' The default is \code{"black"}.
#' @param rotateLabels If \code{TRUE}, rotate labels. Default is \code{FALSE}.
#' @param violinPlot logical. Setting \code{violinPlot = TRUE} creates violin
#' plots in place of boxplots. The mean and +/- 1 standard deviation are added
#' to the violin plot interior for each signature.
#' The default is \code{FALSE}.
#'
#' @export
#'
#' @return A plot with side-by-side boxplots of bootstrapped AUC values for
#' each specified signature.
#'
#' @examples
#' # Run signature profiling
#'  choose_sigs <- TBsignatures[c("Zak_RISK_16", "Zhao_NANO_6")]
#'  prof_indian <- runTBsigProfiler(TB_indian[seq_len(25), ],
#'                                  useAssay = "logcounts",
#'                                  algorithm = "ssGSEA",
#'                                  signatures = choose_sigs,
#'                                  parallel.sz = 1)
#'  # Create boxplots
#'  compareBoxplots(prof_indian, annotationColName = "label",
#'                  signatureColNames = names(choose_sigs), rotateLabels = TRUE)
#'
compareBoxplots <- function(SE_scored, annotationColName, signatureColNames,
                            num.boot = 100,
                            name = "Boxplot Comparison of Signature AUCs",
                            pb.show = TRUE, abline.col = "red",
                            fill.col = "gray79", outline.col = "black",
                            rotateLabels = FALSE, violinPlot = FALSE) {
  # Obtain AUCs
  BS.Results <- bootstrapAUC(SE_scored, annotationColName, signatureColNames,
                             num.boot, pb.show)
  aucs_boot <- data.frame(BS.Results[["Boot AUC Values"]])
  colnames(aucs_boot) <- signatureColNames
  aucs <- apply(aucs_boot, 2, stats::median)

  # Create boxplots with ggplot2
  melted_data <- reshape2::melt(aucs_boot, measure.vars = signatureColNames,
                                variable.name = "Signatures",
                                value.name = "BS_AUC")
  melted_data$Signatures <- gdata::reorder.factor(
    x = melted_data$Signatures,
    new.order = names(sort(aucs)))
  melted_data <- melted_data[order(melted_data$Signatures), ]
  the_plot <- ggplot2::ggplot(data = melted_data, ggplot2::aes(Signatures,
                                                               BS_AUC))
  if (violinPlot) {
    the_plot <- the_plot +
      ggplot2::geom_violin(fill = fill.col, col = outline.col) +
      ggplot2::stat_summary(fun.data = function(x) {
        m <- mean(x)
        ymin <- m - stats::sd(x)
        ymax <- m + stats::sd(x)
        return(c(y = m, ymin = ymin, ymax = ymax))
      }, geom = "pointrange", color = outline.col)
  } else {
    the_plot <- the_plot +
      ggplot2::geom_boxplot(fill = fill.col, col = outline.col)
  }

  the_plot <- the_plot +
    ggplot2::geom_abline(ggplot2::aes(intercept = 0.5, slope = 0,
                                      col = abline.col), linewidth = 1,
                         linetype = "dashed", show.legend = FALSE) +
    ggplot2::theme_classic() +
    ggplot2::theme(axis.title.x = ggplot2::element_blank(),
                   axis.title.y = ggplot2::element_text(
                     margin = ggplot2::margin(r = 10))) +
    ggplot2::ggtitle(label = name) +
    ggplot2::ylab(label = "Bootstrapped AUCs")

  if (rotateLabels) the_plot <- the_plot +
    ggplot2::theme(axis.text.x = ggplot2::element_text(angle = 90,
                                                       hjust = 1))

  return(the_plot)
}

#' Create an array of ROC plots to compare signatures.
#'
#' @inheritParams signatureBoxplot
#' @param choose_colors a \code{vector} of length 2 defining the colors to be used
#' in the ROC plots. The default is \code{c("cornflowerblue", "gray24")}.
#' @param signatureColNames a \code{vector} of the column names of \code{inputData}
#' that contain the signature data. If \code{inputData} is a
#' \code{SummarizedExperiment} object, these are the column names of the
#' object \code{colData}.
#'
#' @return An array of ROC plots.
#'
#' @export
#'
#' @examples
#' # Run signature profiling
#'  choose_sigs <- subset(TBsignatures,
#'                        !(names(TBsignatures) %in% c("Lee_4", "Roe_OD_4")))[c(1,2)]
#'  prof_indian <- runTBsigProfiler(TB_indian, useAssay = "logcounts",
#'                                  algorithm = "ssGSEA",
#'                                  signatures = choose_sigs,
#'                                  parallel.sz = 1)
#'
#' # Create ROC plots
#' signatureROCplot(prof_indian, signatureColNames = names(choose_sigs),
#'                  annotationColName = "label")
#'
signatureROCplot <- function(inputData, annotationData,
                             signatureColNames,
                             annotationColName, scale = FALSE,
                             choose_colors = c("cornflowerblue", "gray24"),
                             name = "Signatures", nrow = NULL, ncol = NULL) {
  if (methods::is(inputData, "SummarizedExperiment")) {
    if (any(duplicated(signatureColNames))) {
      signatureColNames <- unique(signatureColNames)
    }
    if (!all(signatureColNames %in% colnames(SummarizedExperiment::colData(
      inputData)))) {
      stop("Signature column name not found in inputData.")
    }
    if (!all(annotationColName %in% colnames(SummarizedExperiment::colData(
      inputData)))) {
      stop("Annotation column name not found in inputData.")
    }
    annotationData <- data.frame(SummarizedExperiment::colData(
      inputData)[, annotationColName, drop = FALSE])
    inputData <-  data.frame(SummarizedExperiment::colData(
      inputData)[, signatureColNames, drop = FALSE])
  } else {
    if (ncol(annotationData) != 1) {
      stop("annotationData must have only one column.")
    }
    annotationColName <- colnames(annotationData)
  }
  if (length(annotationColName) != 1) {
    stop("You must specify a single annotation column name with which
    to create plots.")
  }
  if (!is.factor(annotationData[, 1])) {
    annotationData[, 1] <- as.factor(annotationData[, 1])
  }
  # The number of rows of annotation data should equal the
  # number of rows of the input data.
  if (nrow(annotationData) == nrow(inputData)) {
    if (!all(rownames(annotationData) == rownames(inputData))) {
      stop("Annotation data and signature data does not match.")
    }
  } else if (nrow(annotationData) == ncol(inputData)) {
    if (!all(rownames(annotationData) == colnames(inputData))) {
      stop("Annotation data and signature data does not match.")
    }
    inputData <- t(inputData)
  } else {
    stop("Annotation data and signature data does not match.")
  }

  # Begin plot creation
  pathwaydata <- t(inputData)
  if (scale) {
    pathwaydata <- t(scale(t(pathwaydata)))
  }
  inputdf <- data.frame(t(pathwaydata),
                        Group = annotationData[, 1])

  # If there are multiple annotationColNames, we will produce
  # an array of AUC plots as output.
  plot_dat <- NULL
  for (k in signatureColNames) {
    pred <- ROCit::rocit(inputdf[, k], inputdf$Group)
    plot_n <- as.data.frame(cbind("FPR" = round(pred$FPR, 4),
                                  "TPR" = round(pred$TPR, 4), Signature = k))
    plot_dat <- rbind(plot_dat, plot_n)
  }
  plot_dat$Signature <- paste(plot_dat$Signature)
  plot_dat$FPR <- as.numeric(paste(plot_dat$FPR))
  plot_dat$TPR <- as.numeric(paste(plot_dat$TPR))

  theplot <- ggplot2::ggplot(data = plot_dat, ggplot2::aes(x = FPR, y = TPR)) +
    ggplot2::geom_line(ggplot2::aes(x = FPR, y = TPR, col = paste(
      "Empirical ROC curve")), linewidth = 1) +
    ggplot2::facet_wrap(~Signature, scales = "free",
                        nrow = nrow, ncol = ncol) +
    ggplot2::geom_abline(ggplot2::aes(intercept = 0, slope = 1,
                                      col = choose_colors[2]), linewidth = 1,
                         linetype = "dashed", show.legend = FALSE) +
    ggplot2::labs(x = "1-Specificity (FPR)", y = "Sensitivity (TPR)",
                  title = name) +
    ggplot2::scale_color_manual("",
                                labels = c("Empirical ROC curve", "Chance line"),
                                values = c(choose_colors[1], choose_colors[2])) +
    ggplot2::theme_classic() +
    ggplot2::theme(axis.text.x = ggplot2::element_text(angle = 90, hjust = 1))

  return(theplot)
}

#' Create an array of ROC plots with confidence interval bands to compare signatures.
#'
#' @inheritParams signatureROCplot
#' @param choose_colors a vector of length 3 defining the colors to be used
#' in the ROC plots. The default is \code{c("cornflowerblue",
#' "gray50", "gray79")}.
#' @param signatureColNames a \code{vector} of the column names of \code{inputData}
#' that contain the signature data. If \code{inputData} is a
#' \code{SummarizedExperiment} object, these are the column names of the
#' object \code{colData}.
#' @param name a character string giving the title of the ROC plot. If
#' \code{NULL}, the plot title will be
#' \code{"ROC Plots for Gene Signatures, <ci.lev>\% Confidence"}.
#' The default is \code{NULL}.
#' @param ci.lev a number between 0 and 1 giving the desired level of
#' confidence for computing ROC curve estimations.
#' @param pb.show logical for whether to show a progress bar while running code.
#' The default is \code{TRUE}.
#'
#' @return An array of ROC plots.
#'
#' @export
#'
#' @examples
#' # Run signature profiling
#'
#'  choose_sigs <- TBsignatures[c(1, 2)]
#'  prof_indian <- runTBsigProfiler(TB_indian, useAssay = "logcounts",
#'                                  algorithm = "Zscore",
#'                                  signatures = choose_sigs,
#'                                  parallel.sz = 1)
#'
#' # Create ROC plots with confidence intervals
#' signatureROCplot_CI(prof_indian, signatureColNames = names(choose_sigs),
#'                     annotationColName = "label")
#'
signatureROCplot_CI <- function(inputData, annotationData, signatureColNames,
                                annotationColName, scale = FALSE,
                                choose_colors = c("cornflowerblue",
                                                  "gray50", "gray79"),
                                name = NULL, nrow = NULL, ncol = NULL,
                                ci.lev = 0.95, pb.show = TRUE) {

  if (methods::is(inputData, "SummarizedExperiment")) {
    if (any(duplicated(signatureColNames))) {
      signatureColNames <- unique(signatureColNames)
    }
    if (!all(signatureColNames %in% colnames(SummarizedExperiment::colData(
      inputData)))) {
      stop("Signature column name not found in inputData.")
    }
    if (!all(annotationColName %in% colnames(SummarizedExperiment::colData(
      inputData)))) {
      stop("Annotation column name not found in inputData.")
    }
    annotationData <- data.frame(SummarizedExperiment::colData(
      inputData)[, annotationColName, drop = FALSE])
    inputData <-  data.frame(SummarizedExperiment::colData(
      inputData)[, signatureColNames, drop = FALSE])
  } else {
    if (ncol(annotationData) != 1) {
      stop("annotationData must have only one column.")
    }
    annotationColName <- colnames(annotationData)
  }
  if (length(annotationColName) != 1) {
    stop("You must specify a single annotation column name with which
    to create plots.")
  }
  if (!is.factor(annotationData[, 1])) {
    annotationData[, 1] <- as.factor(annotationData[, 1])
  }
  # The number of rows of annotation data should equal the
  # number of rows of the input data.
  if (nrow(annotationData) == nrow(inputData)) {
    if (!all(rownames(annotationData) == rownames(inputData))) {
      stop("Annotation data and signature data does not match.")
    }
  } else if (nrow(annotationData) == ncol(inputData)) {
    if (!all(rownames(annotationData) == colnames(inputData))) {
      stop("Annotation data and signature data does not match.")
    }
    inputData <- t(inputData)
  } else {
    stop("Annotation data and signature data does not match.")
  }

  # Begin plot creation
  pathwaydata <- t(inputData)
  if (scale) {
    pathwaydata <- t(scale(t(pathwaydata)))
  }
  inputdf <- data.frame(t(pathwaydata),
                        Group = annotationData[, 1])

  # If there are multiple annotationColNames, we will produce
  # an array of AUC plots as output.

  plot_dat <- NULL

  # Create progress bar
  total <- length(signatureColNames)
  counter <- 0
  if (pb.show)  pb <- utils::txtProgressBar(min = 0, max = total, style = 3)

  for (k in signatureColNames) {
    pred <- ROCit::rocit(inputdf[, k], inputdf$Group)
    this.conf <- suppressWarnings(ROCit::ciROC(pred, level = ci.lev))
    if (any(is.nan(this.conf$UpperTPR))) {
      this.conf$UpperTPR[which(is.nan(this.conf$UpperTPR))] <- 1
    }

    plot_n <- as.data.frame(cbind("FPR" = round(this.conf$FPR, 4),
                                  "TPR" = round(this.conf$TPR, 4),
                                  "LowerTPR" = round(this.conf$LowerTPR, 4),
                                  "UpperTPR" = round(this.conf$UpperTPR, 4),
                                  "Signature" = k))
    plot_dat <- rbind(plot_dat, plot_n)

    # Update the progress bar
    counter <- counter + 1
    if (pb.show) utils::setTxtProgressBar(pb, counter)
  }

  plot_dat <- as.data.frame(apply(plot_dat, 2, paste))
  plot_dat[, seq(1, 4)] <- as.data.frame(apply(plot_dat[, seq(1, 4)], 2, as.numeric))

  if (is.null(name)) name <- paste("ROC Plots for Gene Signatures, ",
                                   ci.lev * 100,
                                  "% Confidence", sep = "")
  if (pb.show) close(pb)

  theplot <- ggplot2::ggplot(data = plot_dat, ggplot2::aes(x = FPR, y = TPR)) +
    ggplot2::geom_ribbon(ggplot2::aes(ymin = LowerTPR, ymax = UpperTPR,
                                      fill = "Confidence Interval"),
                         show.legend = FALSE) +
    ggplot2::geom_line(ggplot2::aes(x = FPR, y = TPR, col =
                                      "Empirical ROC curve"), linewidth = 1) +
    ggplot2::facet_wrap(~Signature, scales = "free",
                        nrow = nrow, ncol = ncol) +
    ggplot2::geom_abline(ggplot2::aes(intercept = 0, slope = 1,
                                      col = choose_colors[2]), linewidth = 1,
                         linetype = "dashed", show.legend = FALSE) +
    ggplot2::scale_color_manual("",
                                labels = c("Empirical ROC curve", "Chance line"),
                                values = c(choose_colors[1], choose_colors[2])) +
    ggplot2::scale_fill_manual("",
                               labels = c("Confidence Interval"),
                               values = c(choose_colors[3])) +
    ggplot2::labs(x = "1-Specificity (FPR)", y = "Sensitivity (TPR)",
                  title = name) +
    ggplot2::theme_classic() +
    ggplot2::theme(axis.text.x = ggplot2::element_text(angle = 90, hjust = 1))

  return(theplot)
}

#' Add SummarizedExperiment assays to the data structure.
#'
#' Given a \code{SummarizedExperiment} input with a counts or CPM assay, this
#' function creates additional assays for by computing the CPM, log, or both
#' of the input assay to be used in further analysis.
#'
#' @param SE_obj a \code{SummarizedExperiment} object containing count or CPM
#' data. Required.
#' @param input_name a character string specifying the name of the assay to
#' be referenced for creating additional assays. Default is \code{"counts"}.
#' @param output_name a character string to use in place of the \code{input_name}.
#' If \code{NULL}, then \code{input_name} will be substituted.
#' Default is \code{NULL}. See Return details for how names are altered.
#' @param log logical. Indicate whether an assay returned should be the log
#' of whichever assay is specified in \code{"output_name"}. If
#' \code{counts_to_CPM = TRUE} as well, then a log CPM assay will also
#' be created. Default is \code{FALSE}.
#' @param counts_to_CPM logical. This argument only applies if the
#' \code{input_type} is a counts assay. If \code{TRUE}, then the output assays
#' will include a normalized CPM assay. If \code{log = TRUE} as well,
#' then a log CPM assay will also be created. Default is \code{TRUE}.
#' @param  prior_counts a small integer specifying the average count to be added to
#' each observation to avoid taking the log of zero. Used only if
#' \code{log = TRUE}. The default is \code{3}.
#'
#' @return This function returns a \code{SummarizedExperiment} object with up
#' to 3 additional assay types attached to the original inputted object.
#' \item{\code{output_name}_cpm}{Counts per million}
#' \item{log_\code{output_name}_cpm}{Log counts per million}
#' \item{log_\code{output_name}}{Log of original input assay.}
#'
#' @author Aubrey Odom-Mabey
#'
#' @export
#'
#' @examples
#' # Create a log assay of the original assay input
#' # TB_hiv dataset already has counts data
#' log_only <- mkAssay(TB_hiv, log = TRUE, counts_to_CPM = FALSE)
#' log_only
#'
#' # Create a CPM assay
#' CPM_only <- mkAssay(TB_hiv)
#' CPM_only
#'
#' # Create a logCPM, logcounts, and CPM assay
#' all_assays <- mkAssay(TB_hiv, log = TRUE)
#' all_assays
#'
mkAssay <- function(SE_obj, input_name = "counts", output_name = NULL,
                    log = FALSE, counts_to_CPM = TRUE,
                    prior_counts = 3) {
  if (!(log || counts_to_CPM)) {
    stop("At least counts_to_CPM or log must be TRUE.")
  } else if (!(input_name %in% names(SummarizedExperiment::assays(SE_obj)))) {
    stop("input_name must be an assay in the SE_obj")
  }
  # Identify the main assay to be referenced
  assay_main <- SummarizedExperiment::assay(SE_obj, input_name)
  if (is.null(output_name)) output_name <- input_name
  if (log) { # if no CPM, but yes log
    SummarizedExperiment::assay(
      SE_obj, paste("log", output_name, sep = "_")) <- log(assay_main + prior_counts)
  }
  if (counts_to_CPM) {
    data.norm <- edgeR::DGEList(counts = assay_main)
    dge_data.norm <- edgeR::calcNormFactors(data.norm)
    CPM_data.norm <- edgeR::cpm(dge_data.norm, log = FALSE)
    SummarizedExperiment::assay(
      SE_obj, paste(output_name, "cpm", sep = "_")) <- CPM_data.norm
    if (log) { # if log and counts_to_CPM
      # log of CPM
      logCPM_data.norm <- edgeR::cpm(
        dge_data.norm, log = TRUE, prior.counts = prior_counts)
      SummarizedExperiment::assay(
        SE_obj, paste("log", output_name, "cpm", sep = "_")) <- logCPM_data.norm
    }
  }
  return(SE_obj)
}

context("test-bootstrap")

mat_testdata <- rbind(matrix(c(rnorm(80), rnorm(80) + 5), 16, 10,
                             dimnames = list(TBsignatures$Zak_RISK_16,
                                             paste0("sample", 1:10))),
                      matrix(rnorm(1000), 100, 10,
                             dimnames = list(paste0("gene", 1:100),
                                             paste0("sample", 1:10))))
df_testdata <- data.frame(mat_testdata)
SEtestdata <- SummarizedExperiment::SummarizedExperiment(
  assays = S4Vectors::SimpleList(data = mat_testdata))
SummarizedExperiment::colData(SEtestdata)[, 1] <- factor(c(rep("yes", 5),
                                                           rep("no", 5)))
SummarizedExperiment::colData(SEtestdata)[, 2] <- c(rep("yes", 5),
                                                    rep("no", 5))
names(SummarizedExperiment::colData(SEtestdata)) <- c("Disease", "Notfac")
scored_testdata <- runTBsigProfiler(SEtestdata, useAssay = "data",
                                    signatures = list(sig1 = paste0("gene", 1:10)),
                                    algorithm = "ssGSEA", parallel.sz = 1)
# For data.frame inputs
annot_data <- data.frame(factor(c(rep("yes", 5), rep("no", 5))))
annot_data_nf <- data.frame(c(rep(1, 5), rep(0, 5)))
colnames(annot_data) <- colnames(annot_data_nf) <- "Disease"
rownames(annot_data) <- rownames(annot_data_nf) <- paste0("sample", 1:10)
scored_df <- runTBsigProfiler(df_testdata, output = "data.frame",
                              signatures = list(sig1 = paste0("gene", 1:10)),
                              algorithm = "ssGSEA", parallel.sz = 1)
# Create incorrect annotation data
annot_data_wrong <- annot_data
rownames(annot_data_wrong) <- seq_len(nrow(annot_data_wrong))

test_that("Run bootstrapAUC", {
  expect_output(
    bootstrapAUC(SE_scored = scored_testdata,
                 signatureColNames = "sig1",
                 annotationColName = "Disease",
                 num.boot = 5)
  )
  expect_output(
    bootstrapAUC(SE_scored = scored_testdata,
                 signatureColNames = "sig1",
                 annotationColName = "Notfac",
                 num.boot = 5)
  )
})

test_that("Run tableAUC", {
  expect_output(
    tableAUC(SE_scored = scored_testdata,
                 signatureColNames = "sig1",
                 annotationColName = "Disease",
                 num.boot = 5)
  )
  expect_is(
    tableAUC(SE_scored = scored_testdata,
                 signatureColNames = "sig1",
                 annotationColName = "Disease",
                 num.boot = 5,
                 output = "DataTable"),
    "datatables"
  )
  expect_is(
    tableAUC(SE_scored = scored_testdata,
             signatureColNames = "sig1",
             annotationColName = "Disease",
             num.boot = 5,
             output = "data.frame"),
    "data.frame"
  )
})

test_that("compareBoxplots", {
  expect_output(
    compareBoxplots(SE_scored = scored_testdata,
                                signatureColNames = "sig1",
                                annotationColName = "Disease",
                                num.boot = 5)
    )
  expect_output(
    compareBoxplots(SE_scored = scored_testdata,
                    signatureColNames = "sig1",
                    annotationColName = "Disease",
                    num.boot = 5,
                    violinPlot = TRUE,
                    rotateLabels = TRUE)
  )
})

test_that("Run signatureROCplot", {
  expect_is(
    signatureROCplot(inputData = scored_testdata,
                     signatureColNames = "sig1",
                     annotationColName = "Disease"),
    "gg"
  )
  expect_is(
    signatureROCplot(inputData = scored_testdata,
                     signatureColNames = "sig1",
                     annotationColName = "Disease",
                     scale = TRUE),
    "gg"
  )
  expect_is(
    signatureROCplot(inputData = scored_testdata,
                     signatureColNames = c("sig1", "sig1"),
                     annotationColName = "Disease"),
    "gg"
  )
  expect_error(
    signatureROCplot(inputData = scored_testdata,
                     signatureColNames = "sig2",
                     annotationColName = "Disease"),
    "Signature column name not found in inputData."
  )
  expect_error(
    signatureROCplot(inputData = scored_testdata,
                     signatureColNames = "sig1",
                     annotationColName = "Not_here"),
    "Annotation column name not found in inputData."
  )
  expect_error(
    signatureROCplot(inputData = scored_testdata,
                     signatureColNames = "sig1",
                     annotationColName = c("Disease", "Notfac")),
    "You must specify a single annotation column name with which
    to create plots."
  )
  expect_is(signatureROCplot(scored_df, annotationData = annot_data,
                             signatureColNames = "sig1",
                             scale = TRUE),
            "gg"
  )
  expect_error(
    signatureROCplot(inputData = scored_df,
                     annotationData = cbind(annot_data, annot_data),
                     signatureColNames = "sig1",
                     scale = TRUE),
    "annotationData must have only one column."
  )
  expect_is(signatureROCplot(inputData = scored_df,
                             annotationData = annot_data_nf,
                             signatureColNames = "sig1",
                             scale = TRUE),
            "gg"
  )
  expect_error(signatureROCplot(inputData = scored_df,
                                annotationData = annot_data_wrong,
                                signatureColNames = "sig1",
                                scale = TRUE),
               "Annotation data and signature data does not match."
  )
})

test_that("Run signatureROCplot_CI", {
  expect_is(
    signatureROCplot_CI(inputData = scored_testdata,
                     signatureColNames = "sig1",
                     annotationColName = "Disease"),
    "gg"
  )
  expect_is(
    signatureROCplot_CI(inputData = scored_testdata,
                     signatureColNames = "sig1",
                     annotationColName = "Disease",
                     scale = TRUE),
    "gg"
  )
  expect_is(
    signatureROCplot_CI(inputData = scored_testdata,
                     signatureColNames = c("sig1", "sig1"),
                     annotationColName = "Disease"),
    "gg"
  )
  expect_error(
    signatureROCplot_CI(inputData = scored_testdata,
                     signatureColNames = "sig2",
                     annotationColName = "Disease"),
    "Signature column name not found in inputData."
  )
  expect_error(
    signatureROCplot_CI(inputData = scored_testdata,
                     signatureColNames = "sig1",
                     annotationColName = "Not_here"),
    "Annotation column name not found in inputData."
  )
  expect_error(
    signatureROCplot_CI(inputData = scored_testdata,
                     signatureColNames = "sig1",
                     annotationColName = c("Disease", "Notfac")),
    "You must specify a single annotation column name with which
    to create plots."
  )
  expect_is(signatureROCplot_CI(inputData = scored_df,
                                annotationData = annot_data,
                                signatureColNames = "sig1",
                                scale = TRUE),
            "gg"
  )
  expect_error(
    signatureROCplot_CI(inputData = scored_df,
                        annotationData = cbind(annot_data, annot_data),
                        signatureColNames = "sig1",
                        scale = TRUE),
    "annotationData must have only one column."
  )
  expect_is(signatureROCplot_CI(inputData = scored_df,
                                annotationData = annot_data_nf,
                                signatureColNames = "sig1",
                                scale = TRUE),
            "gg"
  )
  expect_is(signatureROCplot_CI(inputData = scored_df,
                                annotationData = annot_data_nf,
                                signatureColNames = "sig1",
                                scale = TRUE),
            "gg"
  )
  expect_error(signatureROCplot_CI(inputData = scored_df,
                                   annotationData = annot_data_wrong,
                                   signatureColNames = "sig1",
                                   scale = TRUE),
            "Annotation data and signature data does not match."
  )
})

Mat_testdata <- rbind(matrix(c(rpois(80, lambda = 50),
                               rpois(80, lambda = 50) + 5), 16, 10,
                             dimnames = list(TBsignatures$Zak_RISK_16,
                                             paste0("sample", 1:10))),
                      matrix(rpois(1000, lambda = 50), 100, 10,
                             dimnames = list(paste0("gene", 1:100),
                                             paste0("sample", 1:10))))
SEtestdata2 <- SummarizedExperiment::SummarizedExperiment(
  assays = S4Vectors::SimpleList(data = Mat_testdata))

test_that("Run mk_Assay", {
  expect_is(
    mkAssay(SEtestdata2, input_name = "data", log = TRUE,
            counts_to_CPM = TRUE),
    "SummarizedExperiment"
  )
  expect_error(
    mkAssay(SEtestdata2, input_name = "data", log = FALSE,
            counts_to_CPM = FALSE),
    "At least counts_to_CPM or log must be TRUE."
  )
  expect_error(
    mkAssay(SEtestdata2, input_name = "not_here"),
    "input_name must be an assay in the SE_obj"
  )

})

globalVariables(c("BS_AUC", "FPR", "LowerTPR", "Signatures",
                  "TBsignatures", "TPR", "UpperTPR", "sigAnnotData"))

#' A list of published TB signatures.
#'
#' A set of Tuberculosis gene signatures compiled from various publications. This set
#' of signatures uses gene symbols. Attempts have been made to use updated gene
#' symbols and remove symbols that did not match the most recent annotation.
#' Additional sets for Entrez IDs and Ensembl IDs are forthcoming.
#'
#' Signature names are composed of the last name of the primary author,
#' followed by
#' a possible context for the signature, and ending with either the number of
#' gene transcripts or genes in the signature, with respect to however
#' it was described in the signature's original publication.
#'
#' Possible signature contexts:
#' * \code{<blank>}: TB vs LTBI or Healthy Controls
#' * OD: Other diseases
#' * HIV: Human Immunodeficiency Virus
#' * PNA: Pneumonia
#' * RISK: Risk of developing active TB
#' * RES: Response to TB treatment
#' * FAIL: Failure of TB treatment
#'
#' Note that in some cases signatures will be positive identifiers of TB
#' whereas others are negative identifiers; this should be taken into account
#' when creating ROC curves and computing any AUC estimates.
#'
#' @name TBsignatures
#' @docType data
#' @format list
#' @source
#'  * \strong{Anderson_42}: Anderson, Suzanne T., Myrsini Kaforou, Andrew J. Brent, Victoria J. Wright, Claire M. Banwell, George Chagaluka, Amelia C. Crampin, et al. 2014. "Diagnosis of Childhood Tuberculosis and Host RNA Expression in Africa." The New England Journal of Medicine 370 (18): 1712-23. \url{https://dx.doi.org/10.1056/NEJMoa130365710.1056/NEJMoa1303657}
#'  * \strong{Anderson_OD_51}: Anderson, Suzanne T., Myrsini Kaforou, Andrew J. Brent, Victoria J. Wright, Claire M. Banwell, George Chagaluka, Amelia C. Crampin, et al. 2014. "Diagnosis of Childhood Tuberculosis and Host RNA Expression in Africa." The New England Journal of Medicine 370 (18): 1712-23. \url{https://dx.doi.org/10.1056/NEJMoa130365710.1056/NEJMoa1303657}
#'  * \strong{Berry_393}: Berry, Matthew P. R., Christine M. Graham, Finlay W. McNab, Zhaohui Xu, Susannah A. A. Bloch, Tolu Oni, Katalin A. Wilkinson, et al. 2010. "An Interferon-Inducible Neutrophil-Driven Blood Transcriptional Signature in Human Tuberculosis." Nature 466 (7309): 973-77. \url{https://dx.doi.org/10.1038/nature0924710.1038/nature09247}
#'  * \strong{Berry_OD_86}: Berry, Matthew P. R., Christine M. Graham, Finlay W. McNab, Zhaohui Xu, Susannah A. A. Bloch, Tolu Oni, Katalin A. Wilkinson, et al. 2010. "An Interferon-Inducible Neutrophil-Driven Blood Transcriptional Signature in Human Tuberculosis." Nature 466 (7309): 973-77. \url{https://dx.doi.org/10.1038/nature0924710.1038/nature09247}
#'  * \strong{Blankley_380}: Blankley, Simon, Christine M. Graham, Joe Levin, Jacob Turner, Matthew P. R. Berry, Chloe I. Bloom, Zhaohui Xu, et al. 2016. "A 380-Gene Meta-Signature of Active Tuberculosis Compared with Healthy Controls." The European Respiratory Journal: Official Journal of the European Society for Clinical Respiratory Physiology 47 (6): 1873-76. \url{https://dx.doi.org/10.1183/13993003.02121-201510.1183/13993003.02121-2015}
#'  * \strong{Blankley_5}: Blankley, Simon, Christine M. Graham, Joe Levin, Jacob Turner, Matthew P. R. Berry, Chloe I. Bloom, Zhaohui Xu, et al. 2016. "A 380-Gene Meta-Signature of Active Tuberculosis Compared with Healthy Controls." The European Respiratory Journal: Official Journal of the European Society for Clinical Respiratory Physiology 47 (6): 1873-76. \url{https://dx.doi.org/10.1183/13993003.02121-201510.1183/13993003.02121-2015}
#'  * \strong{Bloom_OD_144}: Bloom, Chloe I., Christine M. Graham, Matthew P. R. Berry, Fotini Rozakeas, Paul S. Redford, Yuanyuan Wang, Zhaohui Xu, et al. 2013. "Transcriptional Blood Signatures Distinguish Pulmonary Tuberculosis, Pulmonary Sarcoidosis, Pneumonias and Lung Cancers." PloS One 8 (8): e70630. \url{https://dx.doi.org/10.1371/journal.pone.007063010.1371/journal.pone.0070630}
#'  * \strong{Bloom_RES_268}: Bloom CI, Graham CM, Berry MP, et al. Detectable changes in the blood transcriptome are present after two weeks of antituberculosis therapy. PLoS One. 2012;7(10):e46191. \url{https://dx.doi.org/10.3389/fmicb.2021.65056710.3389/fmicb.2021.650567}
#'  * \strong{Bloom_RES_558}: Bloom CI, Graham CM, Berry MP, et al. Detectable changes in the blood transcriptome are present after two weeks of antituberculosis therapy. PLoS One. 2012;7(10):e46191. \url{https://dx.doi.org/10.3389/fmicb.2021.65056710.3389/fmicb.2021.650567}
#'  * \strong{Chen_5}: Chen L, Hua J, He X. Coexpression Network Analysis-Based Identification of Critical Genes Differentiating between Latent and Active Tuberculosis. Dis Markers. 2022;2022:2090560. \url{http://dx.doi.org/10.1155/2022/209056010.1155/2022/2090560}
#'  * \strong{Chen_HIV_4}: Chen Y, Wang Q, Lin S, et al. Meta-Analysis of Peripheral Blood Transcriptome Datasets Reveals a Biomarker Panel for Tuberculosis in Patients Infected With HIV. Front Cell Infect Microbiol. 2021;11:585919. Published 2021 Mar 19. \url{https://dx.doi.org/10.3389/fcimb.2021.58591910.3389/fcimb.2021.585919}
#'  * \strong{Chendi_HIV_2}: Chendi BH, Tveiten H, Snyders CI, et al. CCL1 and IL-2Ra differentiate Tuberculosis disease from latent infection Irrespective of HIV infection in low TB burden countries. J Infect. 2021;S0163-4453(21)00379-0. \url{https://dx.doi.org/10.1016/j.jinf.2021.07.03610.1016/j.jinf.2021.07.036}
#'  * \strong{Darboe_RISK_11}: Darboe, F. et al. Diagnostic performance of an optimized transcriptomic signature of risk of tuberculosis in cryopreserved peripheral blood mononuclear cells. Tuberculosis 108, 124-126 (2018). \url{https://dx.doi.org/ 10.1016/j.tube.2017.11.001 10.1016/j.tube.2017.11.001}
#'  * \strong{Dawany_HIV_251}: Dawany, N. et al. Identification of a 251 gene expression signature that can accurately detect M. tuberculosis in patients with and without HIV co-infection. PLoS One 9, (2014). \url{https://dx.doi.org/10.1371/journal.pone.008992510.1371/journal.pone.0089925}
#'  * \strong{Duffy_23}: Duffy FJ, Olson GS, Gold ES, Jahn A, Aderem A, Aitchison J, Rothchild AC, Diercks AH, Nemeth J. A contained Mycobacterium tuberculosis mouse infection model predicts active disease and containment in humans. The Journal of Infectious Diseases. 2021 Mar 10. \url{https://dx.doi.org/10.1093/infdis/jiab13010.1093/infdis/jiab130}
#'  * \strong{Esmail_203}: Esmail, Hanif, Rachel P. Lai, Maia Lesosky, Katalin A. Wilkinson, Christine M. Graham, Stuart Horswell, Anna K. Coussens, Clifton E. Barry 3rd, Anne O'Garra, and Robert J. Wilkinson. 2018. "Complement Pathway Gene Activation and Rising Circulating Immune Complexes Characterize Early Disease in HIV-Associated Tuberculosis." Proceedings of the National Academy of Sciences of the United States of America 115 (5): E964-73. \url{https://dx.doi.org/10.1073/pnas.171185311510.1073/pnas.1711853115}
#'  * \strong{Esmail_82}: Esmail, Hanif, Rachel P. Lai, Maia Lesosky, Katalin A. Wilkinson, Christine M. Graham, Stuart Horswell, Anna K. Coussens, Clifton E. Barry 3rd, Anne O'Garra, and Robert J. Wilkinson. 2018. "Complement Pathway Gene Activation and Rising Circulating Immune Complexes Characterize Early Disease in HIV-Associated Tuberculosis." Proceedings of the National Academy of Sciences of the United States of America 115 (5): E964-73. \url{https://dx.doi.org/10.1073/pnas.171185311510.1073/pnas.1711853115}
#'  * \strong{Esmail_893}: Esmail, Hanif, Rachel P. Lai, Maia Lesosky, Katalin A. Wilkinson, Christine M. Graham, Stuart Horswell, Anna K. Coussens, Clifton E. Barry 3rd, Anne O'Garra, and Robert J. Wilkinson. 2018. "Complement Pathway Gene Activation and Rising Circulating Immune Complexes Characterize Early Disease in HIV-Associated Tuberculosis." Proceedings of the National Academy of Sciences of the United States of America 115 (5): E964-73. \url{https://dx.doi.org/10.1073/pnas.171185311510.1073/pnas.1711853115}
#'  * \strong{Estevez_133}: Estévez O, Anibarro L, Garet E, et al. An RNA-seq Based Machine Learning Approach Identifies Latent Tuberculosis Patients With an Active Tuberculosis Profile. Front Immunol. 2020;11:1470. Published 2020 Jul 14. \url{https://dx.doi.org/10.3389/fimmu.2020.0147010.3389/fimmu.2020.01470}
#'  * \strong{Estevez_259}: Estévez O, Anibarro L, Garet E, et al. An RNA-seq Based Machine Learning Approach Identifies Latent Tuberculosis Patients With an Active Tuberculosis Profile. Front Immunol. 2020;11:1470. Published 2020 Jul 14. \url{https://dx.doi.org/10.3389/fimmu.2020.0147010.3389/fimmu.2020.01470}
#'  * \strong{Francisco_OD_2}: Francisco NM, Fang YM, Ding L, et al. Diagnostic accuracy of a selected signature gene set that discriminates active pulmonary tuberculosis and other pulmonary diseases. J Infect. 2017;75(6):499-510. \url{http://dx.doi.org/10.1016/j.jinf.2017.09.01210.1016/j.jinf.2017.09.012}
#'  * \strong{Gjoen_10}: Gjøen, J.E., Jenum, S., Sivakumaran, D. et al. 'Novel transcriptional signatures for sputum-independent diagnostics of tuberculosis in children.' Sci Rep 7, 5839 (2017). \url{https://doi.org/10.1038/s41598-017-05057-x10.1038/s41598-017-05057-x}
#'  * \strong{Gjoen_7}: Gjøen, J.E., Jenum, S., Sivakumaran, D. et al. 'Novel transcriptional signatures for sputum-independent diagnostics of tuberculosis in children.' Sci Rep 7, 5839 (2017). \url{https://doi.org/10.1038/s41598-017-05057-x10.1038/s41598-017-05057-x}
#'  * \strong{Gliddon_2_OD_4}: Gliddon HD, Kaforou M, Alikian M, et al. Identification of Reduced Host Transcriptomic Signatures for Tuberculosis Disease and Digital PCR-Based Validation and Quantification. Front Immunol. 2021;12:637164. Published 2021 Mar 2. \url{https://dx.doi.org/10.3389/fimmu.2021.63716410.3389/fimmu.2021.637164}
#'  * \strong{Gliddon_HIV_3}: Gliddon HD, Kaforou M, Alikian M, et al. Identification of Reduced Host Transcriptomic Signatures for Tuberculosis Disease and Digital PCR-Based Validation and Quantification. Front Immunol. 2021;12:637164. Published 2021 Mar 2. \url{https://dx.doi.org/10.3389/fimmu.2021.63716410.3389/fimmu.2021.637164}
#'  * \strong{Gliddon_OD_3}: Gliddon, Harriet D., Kaforou, Myrsini, Alikian, Mary, Habgood-Coote, Dominic, Zhou, Chenxi, Oni, Tolu, Anderson, Suzanne T., Brent, Andrew J., Crampin, Amelia C., Eley, Brian, Kern, Florian, Langford, Paul R., Ottenhoff, Tom H. M., Hibberd, Martin L., French, Neil, Wright, Victoria J., Dockrell, Hazel M., Coin, Lachlan J., Wilkinson, Robert J., Levin, Michael. 2019 "Identification of reduced host transcriptomic signatures for tuberculosis and digital PCR-based validation and quantification" biorxiv.org:\url{https://dx.doi.org/10.1101/58367410.1101/583674}
#'  * \strong{Gliddon_OD_4}: Gliddon, Harriet D., Kaforou, Myrsini, Alikian, Mary, Habgood-Coote, Dominic, Zhou, Chenxi, Oni, Tolu, Anderson, Suzanne T., Brent, Andrew J., Crampin, Amelia C., Eley, Brian, Kern, Florian, Langford, Paul R., Ottenhoff, Tom H. M., Hibberd, Martin L., French, Neil, Wright, Victoria J., Dockrell, Hazel M., Coin, Lachlan J., Wilkinson, Robert J., Levin, Michael. 2019 "Identification of reduced host transcriptomic signatures for tuberculosis and digital PCR-based validation and quantification" biorxiv.org:\url{https://dx.doi.org/10.1101/58367410.1101/583674}
#'  * \strong{Gong_OD_4}: Gong Z, Gu Y, Xiong K, Niu J, Zheng R, Su B, Fan L and Xie J (2021) The Evaluation and Validation of Blood-Derived Novel Biomarkers for Precise and Rapid Diagnosis of Tuberculosis in Areas With High-TB Burden. Front. Microbiol. 12:650567. \url{https://dx.doi.org/10.3389/fmicb.2021.65056710.3389/fmicb.2021.650567}
#'  * \strong{Heycken_FAIL_22}: Heyckendorf J, Marwitz S, Reimann M, et al. Prediction of anti-tuberculosis treatment duration based on a 22-gene transcriptomic model. Eur Respir J. 2021;2003492. \url{https://dx.doi.org/10.1183/13993003.03492-202010.1183/13993003.03492-2020}
#'  * \strong{Hoang_OD_13}: Hoang, Long & Jain, Pooja & Pillay, Timesh & Tolosa-Wright, Mica & Niazi, Umar & Takwoingi, Yemisi & Halliday, Alice & Berrocal-Almanza, Luis & Deeks, Jonathan & Beverley, Peter & Kon, Onn & Lalvani, Ajit. (2021). Transcriptomic signatures for diagnosing tuberculosis in clinical practice: a prospective, multicentre cohort study. The Lancet Infectious Diseases. \url{https://dx.doi.org/10.1016/S1473-3099(20)30928-210.1016/S1473-3099(20)30928-2}
#'  * \strong{Hoang_OD_20}: Hoang, Long & Jain, Pooja & Pillay, Timesh & Tolosa-Wright, Mica & Niazi, Umar & Takwoingi, Yemisi & Halliday, Alice & Berrocal-Almanza, Luis & Deeks, Jonathan & Beverley, Peter & Kon, Onn & Lalvani, Ajit. (2021). Transcriptomic signatures for diagnosing tuberculosis in clinical practice: a prospective, multicentre cohort study. The Lancet Infectious Diseases. \url{https://dx.doi.org/10.1016/S1473-3099(20)30928-210.1016/S1473-3099(20)30928-2}
#'  * \strong{Hoang_OD_3}: Hoang, Long & Jain, Pooja & Pillay, Timesh & Tolosa-Wright, Mica & Niazi, Umar & Takwoingi, Yemisi & Halliday, Alice & Berrocal-Almanza, Luis & Deeks, Jonathan & Beverley, Peter & Kon, Onn & Lalvani, Ajit. (2021). Transcriptomic signatures for diagnosing tuberculosis in clinical practice: a prospective, multicentre cohort study. The Lancet Infectious Diseases. \url{https://dx.doi.org/10.1016/S1473-3099(20)30928-210.1016/S1473-3099(20)30928-2}
#'  * \strong{Huang_13}: Huang, Hai-Hui et al. 'Identification of 13 Blood-based Gene Expression Signatures to Accurately Distinguish Tuberculosis from Other Pulmonary Diseases and Healthy Controls'. 1 Jan. 2015 : S1837 - S1843.\url{https://doi.org/10.3233/BME-15148610.3233/BME-151486}
#'  * \strong{Jacobsen_3}: Jacobsen, Marc, Dirk Repsilber, Andrea Gutschmidt, Albert Neher, Knut Feldmann, Hans J. Mollenkopf, Andreas Ziegler, and Stefan H. E. Kaufmann. 2007. "Candidate Biomarkers for Discrimination between Infection and Disease Caused by Mycobacterium Tuberculosis." Journal of Molecular Medicine  85 (6): 613-21. \url{https://dx.doi.org/10.1007/s00109-007-0157-610.1007/s00109-007-0157-6}
#'  * \strong{Jenum_8}: Jenum, S., Dhanasekaran, S., Lodha, R. et al. Approaching a diagnostic point-of-care test for pediatric tuberculosis through evaluation of immune biomarkers across the clinical disease spectrum. Sci Rep 6, 18520 (2016). \url{https://doi.org/10.1038/srep1852010.1038/srep18520}
#'  * \strong{Kaforou_27}: Kaforou, Myrsini, Victoria J. Wright, Tolu Oni, Neil French, Suzanne T. Anderson, Nonzwakazi Bangani, Claire M. Banwell, et al. 2013. "Detection of Tuberculosis in HIV-Infected and -Uninfected African Adults Using Whole Blood RNA Expression Signatures: A Case-Control Study." PLoS Medicine 10 (10): e1001538. \url{https://dx.doi.org/10.1371/journal.pmed.100153810.1371/journal.pmed.1001538}
#'  * \strong{Kaforou_OD_44}: Kaforou, Myrsini, Victoria J. Wright, Tolu Oni, Neil French, Suzanne T. Anderson, Nonzwakazi Bangani, Claire M. Banwell, et al. 2013. "Detection of Tuberculosis in HIV-Infected and -Uninfected African Adults Using Whole Blood RNA Expression Signatures: A Case-Control Study." PLoS Medicine 10 (10): e1001538. \url{https://dx.doi.org/10.1371/journal.pmed.100153810.1371/journal.pmed.1001538}
#'  * \strong{Kaforou_OD_53}: Kaforou, Myrsini, Victoria J. Wright, Tolu Oni, Neil French, Suzanne T. Anderson, Nonzwakazi Bangani, Claire M. Banwell, et al. 2013. "Detection of Tuberculosis in HIV-Infected and -Uninfected African Adults Using Whole Blood RNA Expression Signatures: A Case-Control Study." PLoS Medicine 10 (10): e1001538. \url{https://dx.doi.org/10.1371/journal.pmed.100153810.1371/journal.pmed.1001538}
#'  * \strong{Kaul_3}: Kaul S, Nair V, Birla S, et al. Latent Tuberculosis Infection Diagnosis among Household Contacts in a High Tuberculosis-Burden Area: a Comparison between Transcript Signature and Interferon Gamma Release Assay. Microbiol Spectr. 2022;10(2):e0244521. \url{http://dx.doi.org/10.1128/spectrum.02445-2110.1128/spectrum.02445-21}
#'  * \strong{Kulkarni_HIV_2}: Kulkarni V, Queiroz ATL, Sangle S, et al. A Two-Gene Signature for Tuberculosis Diagnosis in Persons With Advanced HIV. Front Immunol. 2021;12:631165. Published 2021 Feb 22. \url{https://dx.doi.org/10.3389/fimmu.2021.63116510.3389/fimmu.2021.631165}
#'  * \strong{Kwan_186}: Kwan PKW, Periaswamy B, De Sessions PF, et al. A blood RNA transcript signature for TB exposure in household contacts. BMC Infect Dis. 2020;20(1):403. \url{http://dx.doi.org/10.1186/s12879-020-05116-110.1186/s12879-020-05116-1}
#'  * \strong{LauxdaCosta_OD_3}: Laux da Costa L, Delcroix M, Dalla Costa ER, et al. A real-time PCR signature to discriminate between tuberculosis and other pulmonary diseases. Tuberculosis (Edinb). 2015;95(4):421-425. \url{https://dx.doi.org/10.1016/j.tube.2015.04.00810.1016/j.tube.2015.04.008}
#'  * \strong{Lee_4}: Lee, Shih-Wei, Lawrence Shih-Hsin Wu, Guan-Mau Huang, Kai-Yao Huang, Tzong-Yi Lee, and Julia Tzu-Ya Weng. 2016. "Gene Expression Profiling Identifies Candidate Biomarkers for Active and Latent Tuberculosis." BMC Bioinformatics 17 Suppl 1 (January): 3. \url{https://dx.doi.org/10.1186/s12859-015-0848-x10.1186/s12859-015-0848-x}
#'  * \strong{Leong_24}: Leong, Samantha, Yue Zhao, Noyal M. Joseph, Natasha S. Hochberg, Sonali Sarkar, Jane Pleskunas, David Hom, et al. 2018. "Existing blood transcriptional classifiers accurately discriminate active tuberculosis from latent infection in individuals from south India." Tuberculosis (109): 41-51. \url{https://doi.org/10.1016/j.tube.2018.01.00210.1016/j.tube.2018.01.002}
#'  * \strong{Leong_RISK_29}: Leong, S., Zhao, Y., Ribeiro-Rodrigues, R., Jones-López, E. C., Acuña-Villaorduña, C., Rodrigues, P. M., Palaci, M., Alland, D., Dietze, R., Ellner, J. J., Johnson, W. E., Salgame, P., Cross-validation of existing signatures and derivation of a novel 29-gene transcriptomic signature predictive of progression to TB in a Brazilian cohort of household contacts of pulmonary TB. Tuberculosis (Edinb). 2020 Jan;120:101898. \url{https://dx.doi.org/10.1016/j.tube.2020.10189810.1016/j.tube.2020.101898}
#'  * \strong{Li_3}: Li M, Qiu Y, Guo M, Qu R, Tian F, Wang G, Wang Y, Ma J, Liu S, Takiff H, Tang Y, Gao Q.2023.Evaluation of the Cepheid 3-gene host response blood test for tuberculosis diagnosis and treatment response monitoring in a primary-level clinic in rural China. J Clin Microbiol61:e00911-23. \url{http://dx.doi.org/10.1128/jcm.00911-23}
#'  * \strong{Long_RES_10}: Long NP, Phat NK, Yen NTH, et al. A 10-gene biosignature of tuberculosis treatment monitoring and treatment outcome prediction. Tuberculosis (Edinb). 2021;131:102138. \url{http://dx.doi.org/10.1016/j.tube.2021.10213810.1016/j.tube.2021.102138}
#'  * \strong{Maertzdorf_15}: Maertzdorf J, McEwen G, Weiner J 3rd, et al. Concise gene signature for point-of-care classification of tuberculosis. EMBO Mol Med. 2016;8(2):86-95. \url{https://dx.doi.org/10.15252/emmm.20150579010.15252/emmm.201505790}
#'  * \strong{Maertzdorf_4}: Maertzdorf, Jeroen, Gayle McEwen, January Weiner 3rd, Song Tian, Eric Lader, Ulrich Schriek, Harriet Mayanja-Kizza, Martin Ota, John Kenneth, and Stefan He Kaufmann. 2016. "Concise Gene Signature for Point-of-Care Classification of Tuberculosis." EMBO Molecular Medicine 8 (2): 86-95. \url{https://dx.doi.org/10.15252/emmm.20150579010.15252/emmm.201505790}
#'  * \strong{Maertzdorf_OD_100}: Maertzdorf, Jeroen, January Weiner 3rd, Hans-Joachim Mollenkopf, TBornot TB Network, Torsten Bauer, Antje Prasse, Joachim Müller-Quernheim, and Stefan H. E. Kaufmann. 2012. "Common Patterns and Disease-Related Signatures in Tuberculosis and Sarcoidosis." Proceedings of the National Academy of Sciences of the United States of America 109 (20): 7853-58. \url{https://dx.doi.org/10.1073/pnas.112107210910.1073/pnas.1121072109}
#'  * \strong{Natarajan_7}: Natarajan S, Ranganathan M, Hanna LE, Tripathy S. Transcriptional Profiling and Deriving a Seven-Gene Signature That Discriminates Active and Latent Tuberculosis: An Integrative Bioinformatics Approach. Genes (Basel). 2022;13(4):616. Published 2022 Mar 29. \url{http://dx.doi.org/10.3390/genes1304061610.3390/genes13040616}
#'  * \strong{PennNich_RISK_6}: Penn-Nicholson, A. et al. RISK6, a 6-gene transcriptomic signature of TB disease risk, diagnosis and treatment response. Sci. Rep. 10, (2020). \url{https://dx.doi.org/10.1038/s41598-020-65043-810.1038/s41598-020-65043-8}
#'  * \strong{Qian_OD_17}: Qian, Zhongqing et al. "Expression of nuclear factor, erythroid 2-like 2-mediated genes differentiates tuberculosis." Tuberculosis (Edinburgh, Scotland) vol. 99 (2016): 56-62. \url{https://doi.org/10.1016/j.tube.2016.04.00810.1016/j.tube.2016.04.008}
#'  * \strong{Rajan_HIV_5}: Rajan, Jayant V., Semitala, Fred C., Kamya, Moses R., Yoon, Christina., Mehta, Tejas., Cattamanchi, Adithya., Seielstad, Mark., Montalvo, Lani., Andama, Alfred., Katende, Jane., Asege, Lucy., Nakaye, Martha., Mwebe, Sandra. 2018 "A Novel, 5-Transcript, Whole-blood Gene-expression Signature for Tuberculosis Screening Among People Living With Human Immunodeficiency Virus" Clinical Infectious Diseases: 1-7. \url{https://doi.org/10.1093/cid/ciy83510.1093/cid/ciy835}
#'  * \strong{Roe_3}: Roe, Jennifer, Venturini, Cristina, Gupta, Rishi K., Gurry, Celine, Chain, Benjamin M., Sun, Yuxin, Southern, Jo, Jackson, Charlotte, Lipman, Marc, C., Miller, Robert F., Martineau, Adrian R., Abubakar, Ibrahim, Noursadeghi, Mahdad. 2019 "T1 Blood transcriptomic stratification of short-term risk in contacts of tuberculosis": . \url{https://doi.org/10.1093/cid/ciz25210.1093/cid/ciz252}
#'  * \strong{Roe_OD_4}: Roe, Jennifer K., Niclas Thomas, Eliza Gil, Katharine Best, Evdokia Tsaliki, Stephen Morris-Jones, Sian Stafford, et al. 2016. "Blood Transcriptomic Diagnosis of Pulmonary and Extrapulmonary Tuberculosis." JCI Insight 1 (16): e87238. \url{https://dx.doi.org/10.1172/jci.insight.8723810.1172/jci.insight.87238}
#'  * \strong{Sambarey_HIV_10}: Sambarey, Awanti, Abhinandan Devaprasad, Abhilash Mohan, Asma Ahmed, Soumya Nayak, Soumya Swaminathan, George D'Souza, et al. 2017. "Unbiased Identification of Blood-Based Biomarkers for Pulmonary Tuberculosis by Modeling and Mining Molecular Interaction Networks." EBioMedicine 15 (February): 112-26. \url{https://dx.doi.org/10.1016/j.ebiom.2016.12.00910.1016/j.ebiom.2016.12.009}
#'  * \strong{Singhania_OD_20}: Singhania, Akul, Raman Verma, Christine M. Graham, Jo Lee, Trang Tran, Matthew Richardson, Patrick Lecine, et al. 2018. "A Modular Transcriptional Signature Identifies Phenotypic Heterogeneity of Human Tuberculosis Infection." Nature Communications 9 (1): 2308. \url{https://dx.doi.org/10.1038/s41467-018-04579-w10.1038/s41467-018-04579-w}
#'  * \strong{Sivakumaran_11}: Sivakumaran D, Ritz C, Gjøen JE, et al. Host Blood RNA Transcript and Protein Signatures for Sputum-Independent Diagnostics of Tuberculosis in Adults. Front Immunol. 2021;11:626049. Published 2021 Feb 4. \url{https://dx.doi.org/10.3389/fimmu.2020.62604910.3389/fimmu.2020.626049}
#'  * \strong{Sloot_HIV_2}: Sloot, Rosa, Maarten F. Schim van der Loeff, Erik W. van Zwet, Mariëlle C. Haks, Sytze T. Keizer, Maarten Scholing, Tom H. M. Ottenhoff, Martien W. Borgdorff, and Simone A. Joosten. 2015. "Biomarkers Can Identify Pulmonary Tuberculosis in HIV-Infected Drug Users Months Prior to Clinical Diagnosis." EBioMedicine 2 (2): 172-79. \url{https://dx.doi.org/10.1016/j.ebiom.2014.12.00110.1016/j.ebiom.2014.12.001}
#'  * \strong{Suliman_4}: Suliman, Sara, Ethan Thompson, Jayne Sutherland, January Weiner Rd, Martin O. C. Ota, Smitha Shankar, Adam Penn-Nicholson, et al. 2018. "Four-Gene Pan-African Blood Signature Predicts Progression to Tuberculosis." American Journal of Respiratory and Critical Care Medicine, April. https://doi.org/10.1164/rccm.201711-2340OC. \url{https://dx.doi.org/10.1164/rccm.201711-2340OC10.1164/rccm.201711-2340OC}
#'  * \strong{Suliman_RISK_2}: Suliman, S. et al. Four-gene pan-African blood signature predicts progression to tuberculosis. Am. J. Respir. Crit. Care Med. 197, 1198-1208 (2018). \url{https://dx.doi.org/10.1164/rccm.201711-2340OC10.1164/rccm.201711-2340OC}
#'  * \strong{Suliman_RISK_4}: Suliman, Sara, Ethan Thompson, Jayne Sutherland, January Weiner Rd, Martin O. C. Ota, Smitha Shankar, Adam Penn-Nicholson, et al. 2018. "Four-Gene Pan-African Blood Signature Predicts Progression to Tuberculosis." American Journal of Respiratory and Critical Care Medicine, April. https://doi.org/10.1164/rccm.201711-2340OC. \url{https://dx.doi.org/10.1164/rccm.201711-2340OC10.1164/rccm.201711-2340OC}
#'  * \strong{Sweeney_OD_3}: Sweeney, Timothy E., Lindsay Braviak, Cristina M. Tato, and Purvesh Khatri. 2016. "Genome-Wide Expression for Diagnosis of Pulmonary Tuberculosis: A Multicohort Analysis." The Lancet. Respiratory Medicine 4 (3): 213-24. \url{https://dx.doi.org/10.1016/S2213-2600(16)00048-510.1016/S2213-2600(16)00048-5}
#'  * \strong{Tabone_OD_11}: Tabone O, Verma R, Singhania A, et al. Blood transcriptomics reveal the evolution and resolution of the immune response in tuberculosis. J Exp Med. 2021;218(10):e20210915. \url{http://dx.doi.org/10.1084/jem.2021091510.1084/jem.20210915}
#'  * \strong{Tabone_RES_25}: Tabone O, Verma R, Singhania A, et al. Blood transcriptomics reveal the evolution and resolution of the immune response in tuberculosis. J Exp Med. 2021;218(10):e20210915. \url{http://dx.doi.org/10.1084/jem.2021091510.1084/jem.20210915}
#'  * \strong{Tabone_RES_27}: Tabone O, Verma R, Singhania A, et al. Blood transcriptomics reveal the evolution and resolution of the immune response in tuberculosis. J Exp Med. 2021;218(10):e20210915. \url{http://dx.doi.org/10.1084/jem.2021091510.1084/jem.20210915}
#'  * \strong{Thompson_9}: Thompson, Ethan G., Ying Du, Stephanus T. Malherbe, Smitha Shankar, Jackie Braun, Joe Valvo, Katharina Ronacher, et al. 2017. "Host Blood RNA Signatures Predict the Outcome of Tuberculosis Treatment." Tuberculosis  107 (December): 48-58. \url{https://dx.doi.org/10.1016/j.tube.2017.08.00410.1016/j.tube.2017.08.004}
#'  * \strong{Thompson_FAIL_13}: Thompson, Ethan G., Ying Du, Stephanus T. Malherbe, Smitha Shankar, Jackie Braun, Joe Valvo, Katharina Ronacher, et al. 2017. "Host Blood RNA Signatures Predict the Outcome of Tuberculosis Treatment." Tuberculosis  107 (December): 48-58. \url{https://dx.doi.org/10.1016/j.tube.2017.08.00410.1016/j.tube.2017.08.004}
#'  * \strong{Thompson_RES_5}: Thompson, Ethan G., Ying Du, Stephanus T. Malherbe, Smitha Shankar, Jackie Braun, Joe Valvo, Katharina Ronacher, et al. 2017. "Host Blood RNA Signatures Predict the Outcome of Tuberculosis Treatment." Tuberculosis  107 (December): 48-58. \url{https://dx.doi.org/10.1016/j.tube.2017.08.00410.1016/j.tube.2017.08.004}
#'  * \strong{Tornheim_71}: Tornheim, Jeffrey A., Anil K. Madugundu, Mandar Paradkar, Kiyoshi F. Fukutani, Artur TL Queiroz, Nikhil Gupte, Akshay N. Gupte et al. 2020. "Transcriptomic Profiles of Confirmed Pediatric Tuberculosis Patients and Household Contacts Identifies Active Tuberculosis, Infection, and Treatment Response Among Indian Children." The Journal of Infectious Diseases 221(10): 1647-1658. \url{https://doi.org/10.1093/infdis/jiz63910.1093/infdis/jiz639}
#'  * \strong{Tornheim_RES_25}: Tornheim, Jeffrey A., Anil K. Madugundu, Mandar Paradkar, Kiyoshi F. Fukutani, Artur TL Queiroz, Nikhil Gupte, Akshay N. Gupte et al. 2020. "Transcriptomic Profiles of Confirmed Pediatric Tuberculosis Patients and Household Contacts Identifies Active Tuberculosis, Infection, and Treatment Response Among Indian Children." The Journal of Infectious Diseases 221(10): 1647-1658. \url{https://doi.org/10.1093/infdis/jiz63910.1093/infdis/jiz639}
#'  * \strong{Vargas_18}: Vargas R, Abbott L, Bower D, Frahm N, Shaffer M, Yu WH. Gene signature discovery and systematic validation across diverse clinical cohorts for TB prognosis and response to treatment. PLoS Comput Biol. 2023;19(7):e1010770. \url{http://dx.doi.org/10.1371/journal.pcbi.101077010.1371/journal.pcbi.1010770}
#'  * \strong{Vargas_42}: Vargas R, Abbott L, Bower D, Frahm N, Shaffer M, Yu WH. Gene signature discovery and systematic validation across diverse clinical cohorts for TB prognosis and response to treatment. PLoS Comput Biol. 2023;19(7):e1010770. \url{http://dx.doi.org/10.1371/journal.pcbi.101077010.1371/journal.pcbi.1010770}
#'  * \strong{Verhagen_10}: Verhagen, L.M., Zomer, A., Maes, M. et al. A predictive signature gene set for discriminating active from latent tuberculosis in Warao Amerindian children. BMC Genomics 14, 74 (2013). \url{https://doi.org/10.1186/1471-2164-14-7410.1186/1471-2164-14-74}
#'  * \strong{Walter_51}: Walter, Nicholas D., Mikaela A. Miller, Joshua Vasquez, Marc Weiner, Adam Chapman, Melissa Engle, Michael Higgins, et al. 2016. "Blood Transcriptional Biomarkers for Active Tuberculosis among Patients in the United States: A Case-Control Study with Systematic Cross-Classifier Evaluation." Journal of Clinical Microbiology 54 (2): 274-82. \url{https://dx.doi.org/10.1128/JCM.01990-1510.1128/JCM.01990-15}
#'  * \strong{Walter_PNA_119}: Walter, Nicholas D., Mikaela A. Miller, Joshua Vasquez, Marc Weiner, Adam Chapman, Melissa Engle, Michael Higgins, et al. 2016. "Blood Transcriptional Biomarkers for Active Tuberculosis among Patients in the United States: A Case-Control Study with Systematic Cross-Classifier Evaluation." Journal of Clinical Microbiology 54 (2): 274-82. \url{https://dx.doi.org/10.1128/JCM.01990-1510.1128/JCM.01990-15}
#'  * \strong{Walter_PNA_47}: Walter, Nicholas D., Mikaela A. Miller, Joshua Vasquez, Marc Weiner, Adam Chapman, Melissa Engle, Michael Higgins, et al. 2016. "Blood Transcriptional Biomarkers for Active Tuberculosis among Patients in the United States: A Case-Control Study with Systematic Cross-Classifier Evaluation." Journal of Clinical Microbiology 54 (2): 274-82. \url{https://dx.doi.org/10.1128/JCM.01990-1510.1128/JCM.01990-15}
#'  * \strong{Zak_RISK_16}: Zak, Daniel E., Adam Penn-Nicholson, Thomas J. Scriba, Ethan Thompson, Sara Suliman, Lynn M. Amon, Hassan Mahomed, et al. 2016. "A Blood RNA Signature for Tuberculosis Disease Risk: A Prospective Cohort Study." The Lancet 387 (10035): 231222. \url{https://dx.doi.org/10.1016/S0140-6736(15)01316-110.1016/S0140-6736(15)01316-1}
#'  * \strong{Zhao_NANO_6}: Kaipilyawar, Vaishnavi, et al. Development and Validation of a Parsimonious Tuberculosis Gene Signature Using the digital NanoString nCounter Platform. Clinical Infectious Diseases 75.6 (2022): 1022-1030. \url{http://dx.doi.org/10.1093/cid/ciac010}
#'
#' @keywords datasets
#' @examples
#' data("TBsignatures")
"TBsignatures"

#' A list of published TB signatures, using author-given names.
#'
#' A set of Tuberculosis gene signatures from various publications. This set
#' of signatures uses gene symbols. Attempts have been made to use updated gene
#' symbols and remove symbols that did not match the most recent annotation.
#' Additional sets for Entrez IDs and Ensembl IDs are forthcoming.
#'
#' This list differs from \code{TBsignatures} in that signatures with names
#' specified in their originating publication (or that of a peer)
#' are given that common name rather than using the \code{TBSignatureProfiler}
#' naming system. Otherwise, signature names are composed of the last name
#' of the primary author, followed by
#' a possible context for the signature, and ending with either the number of
#' gene transcripts or genes in the signature with respect to however
#' it was described in the original publication.
#'
#' Possible signature contexts:
#' * \code{<blank>}: TB vs LTBI or Healthy Controls
#' * OD: Other diseases
#' * HIV: Human Immunodeficiency Virus
#' * PNA: Pneumonia
#' * RISK: Risk of developing active TB
#' * RES: Response to TB treatment
#' * FAIL: Failure of TB treatment
#'
#' Note that in some cases signatures will be positive identifiers of TB
#' whereas others are negative identifiers; this should be taken into account
#' when creating ROC curves and computing any AUC estimates.
#'
#' @name TBcommon
#' @docType data
#' @format list
#' @source
#'  * \strong{Anderson_42}: Anderson, Suzanne T., Myrsini Kaforou, Andrew J. Brent, Victoria J. Wright, Claire M. Banwell, George Chagaluka, Amelia C. Crampin, et al. 2014. "Diagnosis of Childhood Tuberculosis and Host RNA Expression in Africa." The New England Journal of Medicine 370 (18): 1712-23. \url{https://dx.doi.org/10.1056/NEJMoa130365710.1056/NEJMoa1303657}
#'  * \strong{Anderson_OD_51}: Anderson, Suzanne T., Myrsini Kaforou, Andrew J. Brent, Victoria J. Wright, Claire M. Banwell, George Chagaluka, Amelia C. Crampin, et al. 2014. "Diagnosis of Childhood Tuberculosis and Host RNA Expression in Africa." The New England Journal of Medicine 370 (18): 1712-23. \url{https://dx.doi.org/10.1056/NEJMoa130365710.1056/NEJMoa1303657}
#'  * \strong{Berry_393}: Berry, Matthew P. R., Christine M. Graham, Finlay W. McNab, Zhaohui Xu, Susannah A. A. Bloch, Tolu Oni, Katalin A. Wilkinson, et al. 2010. "An Interferon-Inducible Neutrophil-Driven Blood Transcriptional Signature in Human Tuberculosis." Nature 466 (7309): 973-77. \url{https://dx.doi.org/10.1038/nature0924710.1038/nature09247}
#'  * \strong{Berry_OD_86}: Berry, Matthew P. R., Christine M. Graham, Finlay W. McNab, Zhaohui Xu, Susannah A. A. Bloch, Tolu Oni, Katalin A. Wilkinson, et al. 2010. "An Interferon-Inducible Neutrophil-Driven Blood Transcriptional Signature in Human Tuberculosis." Nature 466 (7309): 973-77. \url{https://dx.doi.org/10.1038/nature0924710.1038/nature09247}
#'  * \strong{Blankley_380}: Blankley, Simon, Christine M. Graham, Joe Levin, Jacob Turner, Matthew P. R. Berry, Chloe I. Bloom, Zhaohui Xu, et al. 2016. "A 380-Gene Meta-Signature of Active Tuberculosis Compared with Healthy Controls." The European Respiratory Journal: Official Journal of the European Society for Clinical Respiratory Physiology 47 (6): 1873-76. \url{https://dx.doi.org/10.1183/13993003.02121-201510.1183/13993003.02121-2015}
#'  * \strong{Blankley_5}: Blankley, Simon, Christine M. Graham, Joe Levin, Jacob Turner, Matthew P. R. Berry, Chloe I. Bloom, Zhaohui Xu, et al. 2016. "A 380-Gene Meta-Signature of Active Tuberculosis Compared with Healthy Controls." The European Respiratory Journal: Official Journal of the European Society for Clinical Respiratory Physiology 47 (6): 1873-76. \url{https://dx.doi.org/10.1183/13993003.02121-201510.1183/13993003.02121-2015}
#'  * \strong{Bloom_OD_144}: Bloom, Chloe I., Christine M. Graham, Matthew P. R. Berry, Fotini Rozakeas, Paul S. Redford, Yuanyuan Wang, Zhaohui Xu, et al. 2013. "Transcriptional Blood Signatures Distinguish Pulmonary Tuberculosis, Pulmonary Sarcoidosis, Pneumonias and Lung Cancers." PloS One 8 (8): e70630. \url{https://dx.doi.org/10.1371/journal.pone.007063010.1371/journal.pone.0070630}
#'  * \strong{Bloom_RES_268}: Bloom CI, Graham CM, Berry MP, et al. Detectable changes in the blood transcriptome are present after two weeks of antituberculosis therapy. PLoS One. 2012;7(10):e46191. \url{https://dx.doi.org/10.3389/fmicb.2021.65056710.3389/fmicb.2021.650567}
#'  * \strong{Bloom_RES_558}: Bloom CI, Graham CM, Berry MP, et al. Detectable changes in the blood transcriptome are present after two weeks of antituberculosis therapy. PLoS One. 2012;7(10):e46191. \url{https://dx.doi.org/10.3389/fmicb.2021.65056710.3389/fmicb.2021.650567}
#'  * \strong{Chen_5}: Chen L, Hua J, He X. Coexpression Network Analysis-Based Identification of Critical Genes Differentiating between Latent and Active Tuberculosis. Dis Markers. 2022;2022:2090560. \url{http://dx.doi.org/10.1155/2022/209056010.1155/2022/2090560}
#'  * \strong{Chen_HIV_4}: Chen Y, Wang Q, Lin S, et al. Meta-Analysis of Peripheral Blood Transcriptome Datasets Reveals a Biomarker Panel for Tuberculosis in Patients Infected With HIV. Front Cell Infect Microbiol. 2021;11:585919. Published 2021 Mar 19. \url{https://dx.doi.org/10.3389/fcimb.2021.58591910.3389/fcimb.2021.585919}
#'  * \strong{Chendi_HIV_2}: Chendi BH, Tveiten H, Snyders CI, et al. CCL1 and IL-2Ra differentiate Tuberculosis disease from latent infection Irrespective of HIV infection in low TB burden countries. J Infect. 2021;S0163-4453(21)00379-0. \url{https://dx.doi.org/10.1016/j.jinf.2021.07.03610.1016/j.jinf.2021.07.036}
#'  * \strong{RISK11}: Darboe, F. et al. Diagnostic performance of an optimized transcriptomic signature of risk of tuberculosis in cryopreserved peripheral blood mononuclear cells. Tuberculosis 108, 124-126 (2018). \url{https://dx.doi.org/ 10.1016/j.tube.2017.11.001 10.1016/j.tube.2017.11.001}
#'  * \strong{Dawany_HIV_251}: Dawany, N. et al. Identification of a 251 gene expression signature that can accurately detect M. tuberculosis in patients with and without HIV co-infection. PLoS One 9, (2014). \url{https://dx.doi.org/10.1371/journal.pone.008992510.1371/journal.pone.0089925}
#'  * \strong{CMTB_CT}: Duffy FJ, Olson GS, Gold ES, Jahn A, Aderem A, Aitchison J, Rothchild AC, Diercks AH, Nemeth J. A contained Mycobacterium tuberculosis mouse infection model predicts active disease and containment in humans. The Journal of Infectious Diseases. 2021 Mar 10. \url{https://dx.doi.org/10.1093/infdis/jiab13010.1093/infdis/jiab130}
#'  * \strong{Esmail_203}: Esmail, Hanif, Rachel P. Lai, Maia Lesosky, Katalin A. Wilkinson, Christine M. Graham, Stuart Horswell, Anna K. Coussens, Clifton E. Barry 3rd, Anne O'Garra, and Robert J. Wilkinson. 2018. "Complement Pathway Gene Activation and Rising Circulating Immune Complexes Characterize Early Disease in HIV-Associated Tuberculosis." Proceedings of the National Academy of Sciences of the United States of America 115 (5): E964-73. \url{https://dx.doi.org/10.1073/pnas.171185311510.1073/pnas.1711853115}
#'  * \strong{Esmail_82}: Esmail, Hanif, Rachel P. Lai, Maia Lesosky, Katalin A. Wilkinson, Christine M. Graham, Stuart Horswell, Anna K. Coussens, Clifton E. Barry 3rd, Anne O'Garra, and Robert J. Wilkinson. 2018. "Complement Pathway Gene Activation and Rising Circulating Immune Complexes Characterize Early Disease in HIV-Associated Tuberculosis." Proceedings of the National Academy of Sciences of the United States of America 115 (5): E964-73. \url{https://dx.doi.org/10.1073/pnas.171185311510.1073/pnas.1711853115}
#'  * \strong{Esmail_OD_893}: Esmail, Hanif, Rachel P. Lai, Maia Lesosky, Katalin A. Wilkinson, Christine M. Graham, Stuart Horswell, Anna K. Coussens, Clifton E. Barry 3rd, Anne O'Garra, and Robert J. Wilkinson. 2018. "Complement Pathway Gene Activation and Rising Circulating Immune Complexes Characterize Early Disease in HIV-Associated Tuberculosis." Proceedings of the National Academy of Sciences of the United States of America 115 (5): E964-73. \url{https://dx.doi.org/10.1073/pnas.171185311510.1073/pnas.1711853115}
#'  * \strong{Estevez_133}: Estévez O, Anibarro L, Garet E, et al. An RNA-seq Based Machine Learning Approach Identifies Latent Tuberculosis Patients With an Active Tuberculosis Profile. Front Immunol. 2020;11:1470. Published 2020 Jul 14. \url{https://dx.doi.org/10.3389/fimmu.2020.0147010.3389/fimmu.2020.01470}
#'  * \strong{Estevez_259}: Estévez O, Anibarro L, Garet E, et al. An RNA-seq Based Machine Learning Approach Identifies Latent Tuberculosis Patients With an Active Tuberculosis Profile. Front Immunol. 2020;11:1470. Published 2020 Jul 14. \url{https://dx.doi.org/10.3389/fimmu.2020.0147010.3389/fimmu.2020.01470}
#'  * \strong{Francisco_OD_2}: Francisco NM, Fang YM, Ding L, et al. Diagnostic accuracy of a selected signature gene set that discriminates active pulmonary tuberculosis and other pulmonary diseases. J Infect. 2017;75(6):499-510. \url{http://dx.doi.org/10.1016/j.jinf.2017.09.01210.1016/j.jinf.2017.09.012}
#'  * \strong{Gjoen_10}: Gjøen, J.E., Jenum, S., Sivakumaran, D. et al. 'Novel transcriptional signatures for sputum-independent diagnostics of tuberculosis in children.' Sci Rep 7, 5839 (2017). \url{https://doi.org/10.1038/s41598-017-05057-x10.1038/s41598-017-05057-x}
#'  * \strong{Gjoen_7}: Gjøen, J.E., Jenum, S., Sivakumaran, D. et al. 'Novel transcriptional signatures for sputum-independent diagnostics of tuberculosis in children.' Sci Rep 7, 5839 (2017). \url{https://doi.org/10.1038/s41598-017-05057-x10.1038/s41598-017-05057-x}
#'  * \strong{Gliddon_2_OD_4}: Gliddon HD, Kaforou M, Alikian M, et al. Identification of Reduced Host Transcriptomic Signatures for Tuberculosis Disease and Digital PCR-Based Validation and Quantification. Front Immunol. 2021;12:637164. Published 2021 Mar 2. \url{https://dx.doi.org/10.3389/fimmu.2021.63716410.3389/fimmu.2021.637164}
#'  * \strong{Gliddon_HIV_3}: Gliddon HD, Kaforou M, Alikian M, et al. Identification of Reduced Host Transcriptomic Signatures for Tuberculosis Disease and Digital PCR-Based Validation and Quantification. Front Immunol. 2021;12:637164. Published 2021 Mar 2. \url{https://dx.doi.org/10.3389/fimmu.2021.63716410.3389/fimmu.2021.637164}
#'  * \strong{Gliddon_OD_3}: Gliddon, Harriet D., Kaforou, Myrsini, Alikian, Mary, Habgood-Coote, Dominic, Zhou, Chenxi, Oni, Tolu, Anderson, Suzanne T., Brent, Andrew J., Crampin, Amelia C., Eley, Brian, Kern, Florian, Langford, Paul R., Ottenhoff, Tom H. M., Hibberd, Martin L., French, Neil, Wright, Victoria J., Dockrell, Hazel M., Coin, Lachlan J., Wilkinson, Robert J., Levin, Michael. 2019 "Identification of reduced host transcriptomic signatures for tuberculosis and digital PCR-based validation and quantification" biorxiv.org: . \url{https://dx.doi.org/10.1101/58367410.1101/583674}
#'  * \strong{Gliddon_OD_4}: Gliddon, Harriet D., Kaforou, Myrsini, Alikian, Mary, Habgood-Coote, Dominic, Zhou, Chenxi, Oni, Tolu, Anderson, Suzanne T., Brent, Andrew J., Crampin, Amelia C., Eley, Brian, Kern, Florian, Langford, Paul R., Ottenhoff, Tom H. M., Hibberd, Martin L., French, Neil, Wright, Victoria J., Dockrell, Hazel M., Coin, Lachlan J., Wilkinson, Robert J., Levin, Michael. 2019 "Identification of reduced host transcriptomic signatures for tuberculosis and digital PCR-based validation and quantification" biorxiv.org: . \url{https://dx.doi.org/10.1101/58367410.1101/583674}
#'  * \strong{Gong_OD_4}: Gong Z, Gu Y, Xiong K, Niu J, Zheng R, Su B, Fan L and Xie J (2021) The Evaluation and Validation of Blood-Derived Novel Biomarkers for Precise and Rapid Diagnosis of Tuberculosis in Areas With High-TB Burden. Front. Microbiol. 12:650567. \url{https://dx.doi.org/10.3389/fmicb.2021.65056710.3389/fmicb.2021.650567}
#'  * \strong{Heycken_FAIL_22}: Heyckendorf J, Marwitz S, Reimann M, et al. Prediction of anti-tuberculosis treatment duration based on a 22-gene transcriptomic model. Eur Respir J. 2021;2003492. \url{https://dx.doi.org/10.1183/13993003.03492-202010.1183/13993003.03492-2020}
#'  * \strong{Hoang_OD_13}: Hoang, Long & Jain, Pooja & Pillay, Timesh & Tolosa-Wright, Mica & Niazi, Umar & Takwoingi, Yemisi & Halliday, Alice & Berrocal-Almanza, Luis & Deeks, Jonathan & Beverley, Peter & Kon, Onn & Lalvani, Ajit. (2021). Transcriptomic signatures for diagnosing tuberculosis in clinical practice: a prospective, multicentre cohort study. The Lancet Infectious Diseases. \url{https://dx.doi.org/10.1016/S1473-3099(20)30928-210.1016/S1473-3099(20)30928-2}
#'  * \strong{Hoang_OD_20}: Hoang, Long & Jain, Pooja & Pillay, Timesh & Tolosa-Wright, Mica & Niazi, Umar & Takwoingi, Yemisi & Halliday, Alice & Berrocal-Almanza, Luis & Deeks, Jonathan & Beverley, Peter & Kon, Onn & Lalvani, Ajit. (2021). Transcriptomic signatures for diagnosing tuberculosis in clinical practice: a prospective, multicentre cohort study. The Lancet Infectious Diseases. \url{https://dx.doi.org/10.1016/S1473-3099(20)30928-210.1016/S1473-3099(20)30928-2}
#'  * \strong{Hoang_OD_3}: Hoang, Long & Jain, Pooja & Pillay, Timesh & Tolosa-Wright, Mica & Niazi, Umar & Takwoingi, Yemisi & Halliday, Alice & Berrocal-Almanza, Luis & Deeks, Jonathan & Beverley, Peter & Kon, Onn & Lalvani, Ajit. (2021). Transcriptomic signatures for diagnosing tuberculosis in clinical practice: a prospective, multicentre cohort study. The Lancet Infectious Diseases. \url{https://dx.doi.org/10.1016/S1473-3099(20)30928-210.1016/S1473-3099(20)30928-2}
#'  * \strong{Huang_13}: Huang, Hai-Hui et al. 'Identification of 13 Blood-based Gene Expression Signatures to Accurately Distinguish Tuberculosis from Other Pulmonary Diseases and Healthy Controls'. 1 Jan. 2015 : S1837 - S1843.\url{https://doi.org/10.3233/BME-15148610.3233/BME-151486}
#'  * \strong{Jacobsen_3}: Jacobsen, Marc, Dirk Repsilber, Andrea Gutschmidt, Albert Neher, Knut Feldmann, Hans J. Mollenkopf, Andreas Ziegler, and Stefan H. E. Kaufmann. 2007. "Candidate Biomarkers for Discrimination between Infection and Disease Caused by Mycobacterium Tuberculosis." Journal of Molecular Medicine  85 (6): 613-21. \url{https://dx.doi.org/10.1007/s00109-007-0157-610.1007/s00109-007-0157-6}
#'  * \strong{Jenum_8}: Jenum, S., Dhanasekaran, S., Lodha, R. et al. Approaching a diagnostic point-of-care test for pediatric tuberculosis through evaluation of immune biomarkers across the clinical disease spectrum. Sci Rep 6, 18520 (2016). \url{https://doi.org/10.1038/srep1852010.1038/srep18520}
#'  * \strong{Kaforou_27}: Kaforou, Myrsini, Victoria J. Wright, Tolu Oni, Neil French, Suzanne T. Anderson, Nonzwakazi Bangani, Claire M. Banwell, et al. 2013. "Detection of Tuberculosis in HIV-Infected and -Uninfected African Adults Using Whole Blood RNA Expression Signatures: A Case-Control Study." PLoS Medicine 10 (10): e1001538. \url{https://dx.doi.org/10.1371/journal.pmed.100153810.1371/journal.pmed.1001538}
#'  * \strong{Kaforou_OD_44}: Kaforou, Myrsini, Victoria J. Wright, Tolu Oni, Neil French, Suzanne T. Anderson, Nonzwakazi Bangani, Claire M. Banwell, et al. 2013. "Detection of Tuberculosis in HIV-Infected and -Uninfected African Adults Using Whole Blood RNA Expression Signatures: A Case-Control Study." PLoS Medicine 10 (10): e1001538. \url{https://dx.doi.org/10.1371/journal.pmed.100153810.1371/journal.pmed.1001538}
#'  * \strong{Kaforou_OD_53}: Kaforou, Myrsini, Victoria J. Wright, Tolu Oni, Neil French, Suzanne T. Anderson, Nonzwakazi Bangani, Claire M. Banwell, et al. 2013. "Detection of Tuberculosis in HIV-Infected and -Uninfected African Adults Using Whole Blood RNA Expression Signatures: A Case-Control Study." PLoS Medicine 10 (10): e1001538. \url{https://dx.doi.org/10.1371/journal.pmed.100153810.1371/journal.pmed.1001538}
#'  * \strong{Kaul_3}: Kaul S, Nair V, Birla S, et al. Latent Tuberculosis Infection Diagnosis among Household Contacts in a High Tuberculosis-Burden Area: a Comparison between Transcript Signature and Interferon Gamma Release Assay. Microbiol Spectr. 2022;10(2):e0244521. \url{http://dx.doi.org/10.1128/spectrum.02445-2110.1128/spectrum.02445-21}
#'  * \strong{Kulkarni_HIV_2}: Kulkarni V, Queiroz ATL, Sangle S, et al. A Two-Gene Signature for Tuberculosis Diagnosis in Persons With Advanced HIV. Front Immunol. 2021;12:631165. Published 2021 Feb 22. \url{https://dx.doi.org/10.3389/fimmu.2021.63116510.3389/fimmu.2021.631165}
#'  * \strong{Kwan_186}: Kwan PKW, Periaswamy B, De Sessions PF, et al. A blood RNA transcript signature for TB exposure in household contacts. BMC Infect Dis. 2020;20(1):403. \url{http://dx.doi.org/10.1186/s12879-020-05116-110.1186/s12879-020-05116-1}
#'  * \strong{LauxdaCosta_OD_3}: Laux da Costa L, Delcroix M, Dalla Costa ER, et al. A real-time PCR signature to discriminate between tuberculosis and other pulmonary diseases. Tuberculosis (Edinb). 2015;95(4):421-425. \url{https://dx.doi.org/10.1016/j.tube.2015.04.00810.1016/j.tube.2015.04.008}
#'  * \strong{Lee_4}: Lee, Shih-Wei, Lawrence Shih-Hsin Wu, Guan-Mau Huang, Kai-Yao Huang, Tzong-Yi Lee, and Julia Tzu-Ya Weng. 2016. "Gene Expression Profiling Identifies Candidate Biomarkers for Active and Latent Tuberculosis." BMC Bioinformatics 17 Suppl 1 (January): 3. \url{https://dx.doi.org/10.1186/s12859-015-0848-x10.1186/s12859-015-0848-x}
#'  * \strong{Leong_24}: Leong, Samantha, Yue Zhao, Noyal M. Joseph, Natasha S. Hochberg, Sonali Sarkar, Jane Pleskunas, David Hom, et al. 2018. "Existing blood transcriptional classifiers accurately discriminate active tuberculosis from latent infection in individuals from south India." Tuberculosis (109): 41-51. \url{https://doi.org/10.1016/j.tube.2018.01.00210.1016/j.tube.2018.01.002}
#'  * \strong{PREDICT29}: Leong, S., Zhao, Y., Ribeiro-Rodrigues, R., Jones-López, E. C., Acuña-Villaorduña, C., Rodrigues, P. M., Palaci, M., Alland, D., Dietze, R., Ellner, J. J., Johnson, W. E., Salgame, P., Cross-validation of existing signatures and derivation of a novel 29-gene transcriptomic signature predictive of progression to TB in a Brazilian cohort of household contacts of pulmonary TB. Tuberculosis (Edinb). 2020 Jan;120:101898. \url{https://dx.doi.org/10.1016/j.tube.2020.10189810.1016/j.tube.2020.101898}
#'  * \strong{Li_3}: Li M, Qiu Y, Guo M, Qu R, Tian F, Wang G, Wang Y, Ma J, Liu S, Takiff H, Tang Y, Gao Q.2023.Evaluation of the Cepheid 3-gene host response blood test for tuberculosis diagnosis and treatment response monitoring in a primary-level clinic in rural China. J Clin Microbiol61:e00911-23. \url{http://dx.doi.org/10.1128/jcm.00911-23}
#'  * \strong{Long_RES_10}: Long NP, Phat NK, Yen NTH, et al. A 10-gene biosignature of tuberculosis treatment monitoring and treatment outcome prediction. Tuberculosis (Edinb). 2021;131:102138. \url{http://dx.doi.org/10.1016/j.tube.2021.10213810.1016/j.tube.2021.102138}
#'  * \strong{Maertzdorf_15}: Maertzdorf J, McEwen G, Weiner J 3rd, et al. Concise gene signature for point-of-care classification of tuberculosis. EMBO Mol Med. 2016;8(2):86-95. \url{https://dx.doi.org/10.15252/emmm.20150579010.15252/emmm.201505790}
#'  * \strong{DIAG4}: Maertzdorf, Jeroen, Gayle McEwen, January Weiner 3rd, Song Tian, Eric Lader, Ulrich Schriek, Harriet Mayanja-Kizza, Martin Ota, John Kenneth, and Stefan He Kaufmann. 2016. "Concise Gene Signature for Point-of-Care Classification of Tuberculosis." EMBO Molecular Medicine 8 (2): 86-95. \url{https://dx.doi.org/10.15252/emmm.20150579010.15252/emmm.201505790}
#'  * \strong{Maertzdorf_OD_100}: Maertzdorf, Jeroen, January Weiner 3rd, Hans-Joachim Mollenkopf, TBornot TB Network, Torsten Bauer, Antje Prasse, Joachim Müller-Quernheim, and Stefan H. E. Kaufmann. 2012. "Common Patterns and Disease-Related Signatures in Tuberculosis and Sarcoidosis." Proceedings of the National Academy of Sciences of the United States of America 109 (20): 7853-58. \url{https://dx.doi.org/10.1073/pnas.112107210910.1073/pnas.1121072109}
#'  * \strong{Natarajan_7}: Natarajan S, Ranganathan M, Hanna LE, Tripathy S. Transcriptional Profiling and Deriving a Seven-Gene Signature That Discriminates Active and Latent Tuberculosis: An Integrative Bioinformatics Approach. Genes (Basel). 2022;13(4):616. Published 2022 Mar 29. \url{http://dx.doi.org/10.3390/genes1304061610.3390/genes13040616}
#'  * \strong{RISK6}: Penn-Nicholson, A. et al. RISK6, a 6-gene transcriptomic signature of TB disease risk, diagnosis and treatment response. Sci. Rep. 10, (2020). \url{https://dx.doi.org/10.1038/s41598-020-65043-810.1038/s41598-020-65043-8}
#'  * \strong{Qian_OD_17}: Qian, Zhongqing et al. "Expression of nuclear factor, erythroid 2-like 2-mediated genes differentiates tuberculosis." Tuberculosis (Edinburgh, Scotland) vol. 99 (2016): 56-62. \url{https://doi.org/10.1016/j.tube.2016.04.00810.1016/j.tube.2016.04.008}
#'  * \strong{Rajan_HIV_5}: Rajan, Jayant V., Semitala, Fred C., Kamya, Moses R., Yoon, Christina., Mehta, Tejas., Cattamanchi, Adithya., Seielstad, Mark., Montalvo, Lani., Andama, Alfred., Katende, Jane., Asege, Lucy., Nakaye, Martha., Mwebe, Sandra. 2018 "A Novel, 5-Transcript, Whole-blood Gene-expression Signature for Tuberculosis Screening Among People Living With Human Immunodeficiency Virus" Clinical Infectious Diseases: 1-7. \url{https://doi.org/10.1093/cid/ciy83510.1093/cid/ciy835}
#'  * \strong{Roe_3}: Roe, Jennifer, Venturini, Cristina, Gupta, Rishi K., Gurry, Celine, Chain, Benjamin M., Sun, Yuxin, Southern, Jo, Jackson, Charlotte, Lipman, Marc, C., Miller, Robert F., Martineau, Adrian R., Abubakar, Ibrahim, Noursadeghi, Mahdad. 2019 "T1 Blood transcriptomic stratification of short-term risk in contacts of tuberculosis": . \url{https://doi.org/10.1093/cid/ciz25210.1093/cid/ciz252}
#'  * \strong{Roe_OD_4}: Roe, Jennifer K., Niclas Thomas, Eliza Gil, Katharine Best, Evdokia Tsaliki, Stephen Morris-Jones, Sian Stafford, et al. 2016. "Blood Transcriptomic Diagnosis of Pulmonary and Extrapulmonary Tuberculosis." JCI Insight 1 (16): e87238. \url{https://dx.doi.org/10.1172/jci.insight.8723810.1172/jci.insight.87238}
#'  * \strong{Sambarey_HIV_10}: Sambarey, Awanti, Abhinandan Devaprasad, Abhilash Mohan, Asma Ahmed, Soumya Nayak, Soumya Swaminathan, George D'Souza, et al. 2017. "Unbiased Identification of Blood-Based Biomarkers for Pulmonary Tuberculosis by Modeling and Mining Molecular Interaction Networks." EBioMedicine 15 (February): 112-26. \url{https://dx.doi.org/10.1016/j.ebiom.2016.12.00910.1016/j.ebiom.2016.12.009}
#'  * \strong{Singhania_OD_20}: Singhania, Akul, Raman Verma, Christine M. Graham, Jo Lee, Trang Tran, Matthew Richardson, Patrick Lecine, et al. 2018. "A Modular Transcriptional Signature Identifies Phenotypic Heterogeneity of Human Tuberculosis Infection." Nature Communications 9 (1): 2308. \url{https://dx.doi.org/10.1038/s41467-018-04579-w10.1038/s41467-018-04579-w}
#'  * \strong{Sivakumaran_11}: Sivakumaran D, Ritz C, Gjøen JE, et al. Host Blood RNA Transcript and Protein Signatures for Sputum-Independent Diagnostics of Tuberculosis in Adults. Front Immunol. 2021;11:626049. Published 2021 Feb 4. \url{https://dx.doi.org/10.3389/fimmu.2020.62604910.3389/fimmu.2020.626049}
#'  * \strong{Sloot_HIV_2}: Sloot, Rosa, Maarten F. Schim van der Loeff, Erik W. van Zwet, Mariëlle C. Haks, Sytze T. Keizer, Maarten Scholing, Tom H. M. Ottenhoff, Martien W. Borgdorff, and Simone A. Joosten. 2015. "Biomarkers Can Identify Pulmonary Tuberculosis in HIV-Infected Drug Users Months Prior to Clinical Diagnosis." EBioMedicine 2 (2): 172-79. \url{https://dx.doi.org/10.1016/j.ebiom.2014.12.00110.1016/j.ebiom.2014.12.001}
#'  * \strong{Suliman_4}: Suliman, Sara, Ethan Thompson, Jayne Sutherland, January Weiner Rd, Martin O. C. Ota, Smitha Shankar, Adam Penn-Nicholson, et al. 2018. "Four-Gene Pan-African Blood Signature Predicts Progression to Tuberculosis." American Journal of Respiratory and Critical Care Medicine, April. https://doi.org/10.1164/rccm.201711-2340OC. \url{https://dx.doi.org/10.1164/rccm.201711-2340OC10.1164/rccm.201711-2340OC}
#'  * \strong{Suliman_RISK_2}: Suliman, S. et al. Four-gene pan-African blood signature predicts progression to tuberculosis. Am. J. Respir. Crit. Care Med. 197, 1198-1208 (2018). \url{https://dx.doi.org/10.1164/rccm.201711-2340OC10.1164/rccm.201711-2340OC}
#'  * \strong{RISK4}: Suliman, Sara, Ethan Thompson, Jayne Sutherland, January Weiner Rd, Martin O. C. Ota, Smitha Shankar, Adam Penn-Nicholson, et al. 2018. "Four-Gene Pan-African Blood Signature Predicts Progression to Tuberculosis." American Journal of Respiratory and Critical Care Medicine, April. https://doi.org/10.1164/rccm.201711-2340OC. \url{https://dx.doi.org/10.1164/rccm.201711-2340OC10.1164/rccm.201711-2340OC}
#'  * \strong{DIAG3}: Sweeney, Timothy E., Lindsay Braviak, Cristina M. Tato, and Purvesh Khatri. 2016. "Genome-Wide Expression for Diagnosis of Pulmonary Tuberculosis: A Multicohort Analysis." The Lancet. Respiratory Medicine 4 (3): 213-24. \url{https://dx.doi.org/10.1016/S2213-2600(16)00048-510.1016/S2213-2600(16)00048-5}
#'  * \strong{TB12}: Tabone O, Verma R, Singhania A, et al. Blood transcriptomics reveal the evolution and resolution of the immune response in tuberculosis. J Exp Med. 2021;218(10):e20210915. \url{http://dx.doi.org/10.1084/jem.2021091510.1084/jem.20210915}
#'  * \strong{EarlyRESP-TB25}: Tabone O, Verma R, Singhania A, et al. Blood transcriptomics reveal the evolution and resolution of the immune response in tuberculosis. J Exp Med. 2021;218(10):e20210915. \url{http://dx.doi.org/10.1084/jem.2021091510.1084/jem.20210915}
#'  * \strong{TREAT-TB27}: Tabone O, Verma R, Singhania A, et al. Blood transcriptomics reveal the evolution and resolution of the immune response in tuberculosis. J Exp Med. 2021;218(10):e20210915. \url{http://dx.doi.org/10.1084/jem.2021091510.1084/jem.20210915}
#'  * \strong{DISEASE}: Thompson, Ethan G., Ying Du, Stephanus T. Malherbe, Smitha Shankar, Jackie Braun, Joe Valvo, Katharina Ronacher, et al. 2017. "Host Blood RNA Signatures Predict the Outcome of Tuberculosis Treatment." Tuberculosis  107 (December): 48-58. \url{https://dx.doi.org/10.1016/j.tube.2017.08.00410.1016/j.tube.2017.08.004}
#'  * \strong{FAILURE}: Thompson, Ethan G., Ying Du, Stephanus T. Malherbe, Smitha Shankar, Jackie Braun, Joe Valvo, Katharina Ronacher, et al. 2017. "Host Blood RNA Signatures Predict the Outcome of Tuberculosis Treatment." Tuberculosis  107 (December): 48-58. \url{https://dx.doi.org/10.1016/j.tube.2017.08.00410.1016/j.tube.2017.08.004}
#'  * \strong{RESPONSE5}: Thompson, Ethan G., Ying Du, Stephanus T. Malherbe, Smitha Shankar, Jackie Braun, Joe Valvo, Katharina Ronacher, et al. 2017. "Host Blood RNA Signatures Predict the Outcome of Tuberculosis Treatment." Tuberculosis  107 (December): 48-58. \url{https://dx.doi.org/10.1016/j.tube.2017.08.00410.1016/j.tube.2017.08.004}
#'  * \strong{Tornheim_71}: Tornheim, Jeffrey A., Anil K. Madugundu, Mandar Paradkar, Kiyoshi F. Fukutani, Artur TL Queiroz, Nikhil Gupte, Akshay N. Gupte et al. 2020. "Transcriptomic Profiles of Confirmed Pediatric Tuberculosis Patients and Household Contacts Identifies Active Tuberculosis, Infection, and Treatment Response Among Indian Children." The Journal of Infectious Diseases 221(10): 1647-1658. \url{https://doi.org/10.1093/infdis/jiz63910.1093/infdis/jiz639}
#'  * \strong{Tornheim_RES_25}: Tornheim, Jeffrey A., Anil K. Madugundu, Mandar Paradkar, Kiyoshi F. Fukutani, Artur TL Queiroz, Nikhil Gupte, Akshay N. Gupte et al. 2020. "Transcriptomic Profiles of Confirmed Pediatric Tuberculosis Patients and Household Contacts Identifies Active Tuberculosis, Infection, and Treatment Response Among Indian Children." The Journal of Infectious Diseases 221(10): 1647-1658. \url{https://doi.org/10.1093/infdis/jiz63910.1093/infdis/jiz639}
#'  * \strong{Vargas_18}: Vargas R, Abbott L, Bower D, Frahm N, Shaffer M, Yu WH. Gene signature discovery and systematic validation across diverse clinical cohorts for TB prognosis and response to treatment. PLoS Comput Biol. 2023;19(7):e1010770. \url{http://dx.doi.org/10.1371/journal.pcbi.101077010.1371/journal.pcbi.1010770}
#'  * \strong{Vargas_42}: Vargas R, Abbott L, Bower D, Frahm N, Shaffer M, Yu WH. Gene signature discovery and systematic validation across diverse clinical cohorts for TB prognosis and response to treatment. PLoS Comput Biol. 2023;19(7):e1010770. \url{http://dx.doi.org/10.1371/journal.pcbi.101077010.1371/journal.pcbi.1010770}
#'  * \strong{Verhagen_10}: Verhagen, L.M., Zomer, A., Maes, M. et al. A predictive signature gene set for discriminating active from latent tuberculosis in Warao Amerindian children. BMC Genomics 14, 74 (2013). \url{https://doi.org/10.1186/1471-2164-14-7410.1186/1471-2164-14-74}
#'  * \strong{Walter_51}: Walter, Nicholas D., Mikaela A. Miller, Joshua Vasquez, Marc Weiner, Adam Chapman, Melissa Engle, Michael Higgins, et al. 2016. "Blood Transcriptional Biomarkers for Active Tuberculosis among Patients in the United States: A Case-Control Study with Systematic Cross-Classifier Evaluation." Journal of Clinical Microbiology 54 (2): 274-82. \url{https://dx.doi.org/10.1128/JCM.01990-1510.1128/JCM.01990-15}
#'  * \strong{Walter_PNA_119}: Walter, Nicholas D., Mikaela A. Miller, Joshua Vasquez, Marc Weiner, Adam Chapman, Melissa Engle, Michael Higgins, et al. 2016. "Blood Transcriptional Biomarkers for Active Tuberculosis among Patients in the United States: A Case-Control Study with Systematic Cross-Classifier Evaluation." Journal of Clinical Microbiology 54 (2): 274-82. \url{https://dx.doi.org/10.1128/JCM.01990-1510.1128/JCM.01990-15}
#'  * \strong{Walter_PNA_47}: Walter, Nicholas D., Mikaela A. Miller, Joshua Vasquez, Marc Weiner, Adam Chapman, Melissa Engle, Michael Higgins, et al. 2016. "Blood Transcriptional Biomarkers for Active Tuberculosis among Patients in the United States: A Case-Control Study with Systematic Cross-Classifier Evaluation." Journal of Clinical Microbiology 54 (2): 274-82. \url{https://dx.doi.org/10.1128/JCM.01990-1510.1128/JCM.01990-15}
#'  * \strong{ACS_COR}: Zak, Daniel E., Adam Penn-Nicholson, Thomas J. Scriba, Ethan Thompson, Sara Suliman, Lynn M. Amon, Hassan Mahomed, et al. 2016. "A Blood RNA Signature for Tuberculosis Disease Risk: A Prospective Cohort Study." The Lancet 387 (10035): 231222. \url{https://dx.doi.org/10.1016/S0140-6736(15)01316-110.1016/S0140-6736(15)01316-1}
#'  * \strong{Zhao_NANO_6}: Kaipilyawar, Vaishnavi, et al. Development and Validation of a Parsimonious Tuberculosis Gene Signature Using the digital NanoString nCounter Platform. Clinical Infectious Diseases 75.6 (2022): 1022-1030. \url{http://dx.doi.org/10.1093/cid/ciac010}
#'
#' @keywords datasets
#' @examples
#' data("TBcommon")
"TBcommon"


#' An example TB dataset with Indian population data.
#'
#' An example dataset containing the gene expression and metadata in a
#' SummarizedExperiment object for an Indian population. Active TB contamination
#' of the 44 subjects is denoted for each as a "1"(active) or "0"
#' (latent/not present), and can be accessed via \code{TB_indian$label}. The
#' SummarizedExperiment object contains 2 assays (counts and log(counts)),
#' and the column names give the unique subject identification number along
#' with the subject's gender.
#'
#' This dataset was published as part of a study to assess performance of
#' published TB signatures in a South Indian population (Leong et. al 2018).
#' RNA sequencing was performed on whole blood PAX gene samples collected
#' from 28 TB patients and 16 latent TB infected (LTBI) subjects enrolled
#' as part of an ongoing household contact study. Whole blood RNA-Seq analysis
#' was performed on all 44 participants.
#'
#' @name TB_indian
#' @docType data
#' @format SummarizedExperiment
#' @keywords datasets
#' @references
#' Leong S., Zhao Y., et. al. (2018). Existing blood transcriptional classifiers
#' accurately discriminate active tuberculosis from latent infection in
#' individuals from south India. \emph{Tuberculosis} \strong{109}, 41-51.
#' doi: \url{https://doi.org/10.1016/j.tube.2018.01.00210.1016/j.tube.2018.01.002}.
#'
#' @examples
#' data("TB_indian")
"TB_indian"


#' An example TB dataset with TB/HIV data.
#'
#' An example dataset containing the gene expression and metadata in a
#' SummarizedExperiment object for 31 subjects with HIV and/or Tuberculosis
#' diseases. Information on subject infection status can be accessed with
#' \code{TB_hiv$Disease}. Samples with both TB and HIV contamination are
#' marked as \code{tb_hiv}, while samples with HIV and no TB are marked
#' as \code{hiv_only}.
#'
#' This dataset was published as part of a study to assess whether gene expression
#' signatures and cytokine levels would distinguish active TB in advanced HIV
#' in a cohort residing in Sub-Saharan Africa (Verma et. al 2018).
#' Participants were severely immunosuppressed TB-HIV patients who had
#' not yet received TB treatment or anti-retroviral therapy (ART). The dataset included
#' in this package has been lightly edited from the originally published dataset
#' due to the removal of one participant who was HIV positive, on ART and developed
#' TB during follow-up. Whole blood RNA-Seq analysis was performed on all
#' 31 participants.
#'
#' @name TB_hiv
#' @docType data
#' @format SummarizedExperiment
#' @keywords datasets
#' @references
#' Verma S., Du P., et. al. (2018). Tuberculosis in advanced HIV infection is
#' associated with increased expression of IFN and its downstream targets.
#' \emph{BMC Infectious Diseases} \strong{18:220}.
#' doi: \url{https://doi.org/10.1186/s12879-018-3127-410.1186/s12879-018-3127-4}.
#'
#' @examples
#' data("TB_hiv")
"TB_hiv"

#' Annotation information for published TB signatures.
#'
#' A data.frame of annotation information for published tuberculosis signatures.
#' Currently, this table includes two variables, \code{disease} and
#' \code{tissue type}.
#'
#' The \code{disease} variable indicates whether the signature was developed
#' to distinguish TB from LTBI ("Disease"), TB from some combination of other
#' diseases and possibly LTBI ("OD"), TB from Human Immunodeficiency Virus ("HIV"),
#' TB from pneumonia ("PNA"), or identify risk of progression to TB ("RISK"),
#' risk of TB treatment failure ("FAIL"), or classify treatment responses
#' (i.e., failures from cures, "RES").
#'
#' The \code{tissue type} variable denotes whether the signature was developed
#' using samples of either whole blood/paxgene or peripheral blood mononuclear
#' cells (PBMCs). Due to the manipulation of cells inherently required to obtain
#' PBMCs, many scientists prefer to use only whole blood samples for analysis.
#'
#' @name sigAnnotData
#' @docType data
#' @format data.frame
#' @keywords datasets
#' @source
#' See \code{?TBsignatures} for reference information.
#'
#' @examples
#' data("sigAnnotData")
"sigAnnotData"

#' Annotation information for published TB signatures.
#'
#' A \code{data.frame} of annotation information for published tuberculosis
#' signatures. This table differs from that of \code{sigAnnotData} as it
#' refers to signatures via the name given in scientific publications, and
#' via a consistent naming system otherwise.
#' Currently, this table includes two variables, \code{disease} and
#' \code{tissue type}.
#'
#' The \code{disease} variable indicates whether the signature was developed
#' to distinguish TB from LTBI ("Disease"), TB from some combination of other
#' diseases and possibly LTBI ("OD"), TB from Human Immunodeficiency Virus ("HIV"),
#' TB from pneumonia ("PNA"), or identify risk of progression to TB ("RISK"),
#' risk of TB treatment failure ("FAIL"), or classify treatment responses
#' (i.e., failures from cures, "RES").
#'
#' The \code{tissue type} variable denotes whether the signature was developed
#' using samples of either whole blood/paxgene or peripheral blood mononuclear
#' cells (PBMCs). Due to the manipulation of cells inherently required to obtain
#' PBMCs, many scientists prefer to use only whole blood samples for analysis.
#'
#' @name common_sigAnnotData
#' @docType data
#' @format data.frame
#' @keywords datasets
#' @source
#' See \code{?TBcommon} for reference information.
#'
#' @keywords datasets
#' @examples
#' data("common_sigAnnotData")
"common_sigAnnotData"

#' A list of published/pre-print COVID-19 signatures.
#'
#' A set of 47 COVID-19 gene signatures from various single-cell and bulk
#' RNA-seq publications and preprint manuscripts from early- to mid-2020.
#' This set of signatures uses gene symbols.
#'
#' Signature names are composed of the last name of the primary author, followed
#' by the type of sequencing data from which the signature was derived, the
#' tissue from which the signature was derived, and ending with a reference to
#' the cell type, infection status, or disease to which the signature belongs,
#' as defined in the original publication.
#'
#' Note that in some cases signatures will be positive identifiers of COVID-19
#' as positive markers of immune cell clusters are often provided for
#' single-cell RNA-seq data; this should be taken into account when creating
#' ROC curves and computing any AUC or disease risk estimates.
#'
#' @name COVIDsignatures
#' @docType data
#' @format list
#' @source
#'  * \strong{Wilk_sc_PBMC_monocytes_up}: Wilk, A.J., Rustagi, A., Zhao, N.Q. et al. 2020. "A single-cell atlas of the peripheral immune response in patients with severe COVID-19." Nature Medicine 26 (7): 1070-1076. \url{https://doi.org/10.1038/s41591-020-0944-y}
#'  * \strong{Wilk_sc_PBMC_monocytes_up}: Wilk, A.J., Rustagi, A., Zhao, N.Q. et al. 2020. "A single-cell atlas of the peripheral immune response in patients with severe COVID-19." Nature Medicine 26 (7): 1070-1076. \url{https://doi.org/10.1038/s41591-020-0944-y}
#'  * \strong{Wilk_sc_PBMC_monocytes_down}: Wilk, A.J., Rustagi, A., Zhao, N.Q. et al. 2020. "A single-cell atlas of the peripheral immune response in patients with severe COVID-19." Nature Medicine 26 (7): 1070-1076. \url{https://doi.org/10.1038/s41591-020-0944-y}
#'  * \strong{Wilk_sc_PBMC_NK_cells_up}: Wilk, A.J., Rustagi, A., Zhao, N.Q. et al. 2020. "A single-cell atlas of the peripheral immune response in patients with severe COVID-19." Nature Medicine 26 (7): 1070-1076. \url{https://doi.org/10.1038/s41591-020-0944-y}
#'  * \strong{Wilk_sc_PBMC_NK_cells_down}: Wilk, A.J., Rustagi, A., Zhao, N.Q. et al. 2020. "A single-cell atlas of the peripheral immune response in patients with severe COVID-19." Nature Medicine 26 (7): 1070-1076. \url{https://doi.org/10.1038/s41591-020-0944-y}
#'  * \strong{Wilk_sc_PBMCs_ISG_signature}: Wilk, A.J., Rustagi, A., Zhao, N.Q. et al. 2020. "A single-cell atlas of the peripheral immune response in patients with severe COVID-19." Nature Medicine 26 (7): 1070-1076. \url{https://doi.org/10.1038/s41591-020-0944-y}
#'  * \strong{Wilk_sc_PBMC_activated_granulocytes}: Wilk, A.J., Rustagi, A., Zhao, N.Q. et al. 2020. "A single-cell atlas of the peripheral immune response in patients with severe COVID-19." Nature Medicine 26 (7): 1070-1076. \url{https://doi.org/10.1038/s41591-020-0944-y}
#'  * \strong{Huang_sc_PBMC_IFN_signature}: Wilk, A.J., Rustagi, A., Zhao, N.Q. et al. 2020. "Blood single cell immune profiling reveals the interferon-MAPK pathway mediated adaptive immune response for COVID-19." medRxiv.org: {https://doi.org/10.1101/2020.03.15.20033472}
#'  * \strong{Wen_sc_PBMC_monocytes}: Wen, W., Su, W., Tang, H. et al. 2020. "Immune cell profiling of COVID-19 patients in the recovery stage by single-cell sequencing." Cell Discovery 6 (31). \url{https://doi.org/10.1038/s41421-020-0168-9}
#'  * \strong{Wen_sc_PBMC_NK_cells}: Wen, W., Su, W., Tang, H. et al. 2020. "Immune cell profiling of COVID-19 patients in the recovery stage by single-cell sequencing." Cell Discovery 6 (31). \url{https://doi.org/10.1038/s41421-020-0168-9}
#'  * \strong{Wen_sc_PBMC_CD4_T_cells}: Wen, W., Su, W., Tang, H. et al. 2020. "Immune cell profiling of COVID-19 patients in the recovery stage by single-cell sequencing." Cell Discovery 6 (31). \url{https://doi.org/10.1038/s41421-020-0168-9}
#'  * \strong{Wen_sc_PBMC_CD8_T_cells}: Wen, W., Su, W., Tang, H. et al. 2020. "Immune cell profiling of COVID-19 patients in the recovery stage by single-cell sequencing." Cell Discovery 6 (31). \url{https://doi.org/10.1038/s41421-020-0168-9}
#'  * \strong{Wen_sc_PBMC_B_cells}: Wen, W., Su, W., Tang, H. et al. 2020. "Immune cell profiling of COVID-19 patients in the recovery stage by single-cell sequencing." Cell Discovery 6 (31). \url{https://doi.org/10.1038/s41421-020-0168-9}
#'  * \strong{Xiong_bulk_PBMC_gene_signature_up}: Xiong Y, Liu Y, Cao L, et al. 2020. "Transcriptomic characteristics of bronchoalveolar lavage fluid and peripheral blood mononuclear cells in COVID-19 patients." Emerging Microbes & Infections 9 (1):761-770. \url{https://doi/org/10.1080/22221751.2020.1747363}
#'  * \strong{Xiong_bulk_PBMC_gene_signature_down}: Xiong Y, Liu Y, Cao L, et al. 2020. "Transcriptomic characteristics of bronchoalveolar lavage fluid and peripheral blood mononuclear cells in COVID-19 patients." Emerging Microbes & Infections 9 (1):761-770. \url{https://doi/org/10.1080/22221751.2020.1747363}
#'  * \strong{Xiong_sc_PBMC_cytokines_up}: Xiong Y, Liu Y, Cao L, et al. 2020. "Transcriptomic characteristics of bronchoalveolar lavage fluid and peripheral blood mononuclear cells in COVID-19 patients." Emerging Microbes & Infections 9 (1):761-770. \url{https://doi/org/10.1080/22221751.2020.1747363}
#'  * \strong{Xiong_sc_PBMC_cytokines_down}: Xiong Y, Liu Y, Cao L, et al. 2020. "Transcriptomic characteristics of bronchoalveolar lavage fluid and peripheral blood mononuclear cells in COVID-19 patients." Emerging Microbes & Infections 9 (1):761-770. \url{https://doi/org/10.1080/22221751.2020.1747363}
#'  * \strong{Liao_sc_BALF_G1_macrophages}: Liao, M., Liu, Y., Yuan, J. et al. 2020. "Single-cell landscape of bronchoalveolar immune cells in patients with COVID-19." Nature Medicine 26 (6): 842-844. \url{https://doi.org/10.1038/s41591-020-0901-9}
#'  * \strong{Liao_sc_BALF_G1_2_macrophages}: Liao, M., Liu, Y., Yuan, J. et al. 2020. "Single-cell landscape of bronchoalveolar immune cells in patients with COVID-19." Nature Medicine 26 (6): 842-844. \url{https://doi.org/10.1038/s41591-020-0901-9}
#'  * \strong{Liao_sc_BALF_G2_macrophages}: Liao, M., Liu, Y., Yuan, J. et al. 2020. "Single-cell landscape of bronchoalveolar immune cells in patients with COVID-19." Nature Medicine 26 (6): 842-844. \url{https://doi.org/10.1038/s41591-020-0901-9}
#'  * \strong{Liao_sc_BALF_G3_macrophages}: Liao, M., Liu, Y., Yuan, J. et al. 2020. "Single-cell landscape of bronchoalveolar immune cells in patients with COVID-19." Nature Medicine 26 (6): 842-844. \url{https://doi.org/10.1038/s41591-020-0901-9}
#'  * \strong{Liao_sc_BALF_G4_macrophages}: Liao, M., Liu, Y., Yuan, J. et al. 2020. "Single-cell landscape of bronchoalveolar immune cells in patients with COVID-19." Nature Medicine 26 (6): 842-844. \url{https://doi.org/10.1038/s41591-020-0901-9}
#'  * \strong{Liao_sc_BALF_CD8_T_cells_up}: Liao, M., Liu, Y., Yuan, J. et al. 2020. "Single-cell landscape of bronchoalveolar immune cells in patients with COVID-19." Nature Medicine 26 (6): 842-844. \url{https://doi.org/10.1038/s41591-020-0901-9}
#'  * \strong{Liao_sc_BALF_CD8_T_cells_down}: Liao, M., Liu, Y., Yuan, J. et al. 2020. "Single-cell landscape of bronchoalveolar immune cells in patients with COVID-19." Nature Medicine 26 (6): 842-844. \url{https://doi.org/10.1038/s41591-020-0901-9}
#'  * \strong{Hadjadj_nanostring_WB_gene_signature_up}: Hadjadj J, Yatim N, Barnabei L, et al. 2020. "Impaired type I interferon activity and inflammatory responses in severe COVID-19 patients." Science 369 (6504): 718-724. \url{https://doi.org/10.1126/science.abc6027}
#'  * \strong{Hadjadj_nanostring_WB_gene_signature_down}: Hadjadj J, Yatim N, Barnabei L, et al. 2020. "Impaired type I interferon activity and inflammatory responses in severe COVID-19 patients." Science 369 (6504): 718-724. \url{https://doi.org/10.1126/science.abc6027}
#'  * \strong{Hadjadj_nanostring_WB_ISG_signature}: Hadjadj J, Yatim N, Barnabei L, et al. 2020. "Impaired type I interferon activity and inflammatory responses in severe COVID-19 patients." Science 369 (6504): 718-724. \url{https://doi.org/10.1126/science.abc6027}
#'  * \strong{Hadjadj_nanostring_WB_mild_moderate_up}: Hadjadj J, Yatim N, Barnabei L, et al. 2020. "Impaired type I interferon activity and inflammatory responses in severe COVID-19 patients." Science 369 (6504): 718-724. \url{https://doi.org/10.1126/science.abc6027}
#'  * \strong{Hadjadj_nanostring_WB_mild_moderate_down}: Hadjadj J, Yatim N, Barnabei L, et al. 2020. "Impaired type I interferon activity and inflammatory responses in severe COVID-19 patients." Science 369 (6504): 718-724. \url{https://doi.org/10.1126/science.abc6027}
#'  * \strong{Hadjadj_nanostring_WB_severe_up}: Hadjadj J, Yatim N, Barnabei L, et al. 2020. "Impaired type I interferon activity and inflammatory responses in severe COVID-19 patients." Science 369 (6504): 718-724. \url{https://doi.org/10.1126/science.abc6027}
#'  * \strong{Hadjadj_nanostring_WB_severe_down}: Hadjadj J, Yatim N, Barnabei L, et al. 2020. "Impaired type I interferon activity and inflammatory responses in severe COVID-19 patients." Science 369 (6504): 718-724. \url{https://doi.org/10.1126/science.abc6027}
#'  * \strong{Hadjadj_nanostring_critical_up}: Hadjadj J, Yatim N, Barnabei L, et al. 2020. "Impaired type I interferon activity and inflammatory responses in severe COVID-19 patients." Science 369 (6504): 718-724. \url{https://doi.org/10.1126/science.abc6027}
#'  * \strong{Hadjadj_nanostring_critical_down}: Hadjadj J, Yatim N, Barnabei L, et al. 2020. "Impaired type I interferon activity and inflammatory responses in severe COVID-19 patients." Science 369 (6504): 718-724. \url{https://doi.org/10.1126/science.abc6027}
#'  * \strong{Wei_sc_PBMC_inactivated_monocytes}: Wei et al. 2020. "Viral Invasion and Type I Interferon Response Characterize the Immunophenotypes during COVID-19 Infection." SSRN: \url{https://dx.doi.org/10.2139/ssrn.3555695}
#'  * \strong{Wei_sc_PBMC_classical_monocytes}: Wei et al. 2020. "Viral Invasion and Type I Interferon Response Characterize the Immunophenotypes during COVID-19 Infection." SSRN: \url{https://dx.doi.org/10.2139/ssrn.3555695}
#'  * \strong{Wei_sc_PBMCs_T_cells}: Wei et al. 2020. "Viral Invasion and Type I Interferon Response Characterize the Immunophenotypes during COVID-19 Infection." SSRN: \url{https://dx.doi.org/10.2139/ssrn.3555695}
#'  * \strong{Wei_sc_PBMC_B_cells}: Wei et al. 2020. "Viral Invasion and Type I Interferon Response Characterize the Immunophenotypes during COVID-19 Infection." SSRN: \url{https://dx.doi.org/10.2139/ssrn.3555695}
#'  * \strong{Silvin_sc_WB_combined_signature}: Silvin A, Chapuis N, Dunsmore G, et al. 2020. "Elevated Calprotectin and Abnormal Myeloid Cell Subsets Discriminate Severe from Mild COVID-19." Cell 182 (6): 1401-1418.E18. \url{https://doi.org/10.1016/j.cell.2020.08.002}
#'  * \strong{Silvin_sc_WB_monocytes_up}: Silvin A, Chapuis N, Dunsmore G, et al. 2020. "Elevated Calprotectin and Abnormal Myeloid Cell Subsets Discriminate Severe from Mild COVID-19." Cell 182 (6): 1401-1418.E18. \url{https://doi.org/10.1016/j.cell.2020.08.002}
#'  * \strong{Silvin_sc_WB_monocytes_down}: Silvin A, Chapuis N, Dunsmore G, et al. 2020. "Elevated Calprotectin and Abnormal Myeloid Cell Subsets Discriminate Severe from Mild COVID-19." Cell 182 (6): 1401-1418.E18. \url{https://doi.org/10.1016/j.cell.2020.08.002}
#'  * \strong{Silvin_sc_WB_neutrophils_up}: Silvin A, Chapuis N, Dunsmore G, et al. "Elevated Calprotectin and Abnormal Myeloid Cell Subsets Discriminate Severe from Mild COVID-19." Cell 182 (6): 1401-1418.E18. \url{https://doi.org/10.1016/j.cell.2020.08.002}
#'  * \strong{Silvin_sc_WB_neutrophils_down}: Silvin A, Chapuis N, Dunsmore G, et al. "Elevated Calprotectin and Abnormal Myeloid Cell Subsets Discriminate Severe from Mild COVID-19." Cell 182 (6): 1401-1418.E18. \url{https://doi.org/10.1016/j.cell.2020.08.002}
#'  * \strong{Arunachalam_bulk_PBMC_blood_modules}: Arunachalam PS, Wimmers F, Mok CKP, et al. 2020. "Systems biological assessment of immunity to mild versus severe COVID-19 infection in humans." Science 369 (6508): 1210-1220. \url{https://doi.org/10.1126/science.abc6261}
#'  * \strong{Arunachalam_bulk_PBMC_covid_combined}: Arunachalam PS, Wimmers F, Mok CKP, et al. 2020. "Systems biological assessment of immunity to mild versus severe COVID-19 infection in humans." Science 369 (6508): 1210-1220. \url{https://doi.org/10.1126/science.abc6261}
#'  * \strong{Arunachalam_bulk_PBMC_moderate}: Arunachalam PS, Wimmers F, Mok CKP, et al. 2020. "Systems biological assessment of immunity to mild versus severe COVID-19 infection in humans." Science 369 (6508): 1210-1220. \url{https://doi.org/10.1126/science.abc6261}
#'  * \strong{Arunachalam_bulk_PBMC_severe}: Arunachalam PS, Wimmers F, Mok CKP, et al. 2020. "Systems biological assessment of immunity to mild versus severe COVID-19 infection in humans." Science 369 (6508): 1210-1220. \url{https://doi.org/10.1126/science.abc6261}
#'  * \strong{Arunachalam_bulk_PBMC_intensive_care}: Arunachalam PS, Wimmers F, Mok CKP, et al. 2020. "Systems biological assessment of immunity to mild versus severe COVID-19 infection in humans." Science 369 (6508): 1210-1220. \url{https://doi.org/10.1126/science.abc6261}
#'  * \strong{Dunning_bulk_WB_flu}: Dunning J, Blankley S, Hoang LT, et al. 2018. "Progression of whole-blood transcriptional signatures from interferon-induced to neutrophil-associated patterns in severe influenza." Nature Immunology 19 (6): 625-635. \url{https://doi.org/10.1038/s41590-018-0111-5}
#'
#' @keywords datasets
#' @examples
#' data("COVIDsignatures")

"COVIDsignatures"

#' Up/Down-regulated genes information for selected TB signatures.
#' @name TBsignaturesSplit
#' @docType data
#' @format list
#' @source
#' See \code{?TBsignatures} for reference information.
#' @keywords datasets
#' @examples
#' data("TBsignaturesSplit")
"TBsignaturesSplit"

#' Discovery datasets for corresponding gene signatures.
#' @name OriginalTrainingData
#' @docType data
#' @format list
#' @source
#' See \code{?TBsignatures} for reference information.
#' @keywords datasets
#' @examples
#' data("OriginalTrainingData")
"OriginalTrainingData"

globalVariables(c("BS_AUC", "FPR", "LowerTPR", "Signatures",
                  "TBsignatures", "TPR", "UpperTPR", "sigAnnotData"))

#' Plot a heatmap of signature scores.
#'
#' This function takes a dataset of scored gene expression data as an input
#' and returns a \code{ComplexHeatmap} plot for for visual comparison of
#' signature performance. The function takes arguments listed here as well
#' as any others to be passed on to \code{ComplexHeatmap::Heatmap()}.
#'
#' If both \code{annotationData = NULL} and \code{annotationColNames = NULL},
#' no annotation bar will be drawn on the heatmap.
#'
#' @param inputData an input data object. It should either be of the class
#' \code{SummarizedExperiment} and contain the profiled signature data and
#' annotation data as columns in the colData, or alternatively be of the classes
#' \code{data.frame} or \code{matrix} and contain only the gene expression data.
#' Required.
#' @param annotationData a \code{data.frame} or \code{matrix} of annotation
#' data, with one column. Only required if \code{inputData} is a
#' \code{data.frame} or \code{matrix} of signature data.
#' The row names must equal those of the \code{inputData} column names.
#' Default is \code{NULL}.
#' @param name a character string with the plot title of the heatmap. The
#' default is \code{"Signatures"}.
#' @param signatureColNames a vector of the column names in \code{colData} that
#' contain the signature data. Only required if \code{inputData} is a
#' SummarizedExperiment object.
#' @param annotationColNames a vector of the column names in \code{colData} that
#' contain the annotation data. Only required if \code{inputData} is a
#' \code{SummarizedExperiment}. Default is \code{NULL}.
#' @param colList a named \code{list} of named vectors specifying custom color
#' information to
#' pass to \code{ComplexHeatmap::Heatmap()}. The list should have as many
#' elements as there are annotation columns, and each element name should
#' correspond exactly with the name of each annotation column.
#' The colors in the vector elements should be named according to the
#' levels of the factor in that column's annotation data if the annotation
#' is discrete, or it should be produced with \code{circlize::colorRamp2}
#' if the annotation is continuous.
#' By default, \code{ColorBrewer} color sets will be used.
#' See the the parameter \code{colorSets} for additional details.
#' @param scale logical. Setting \code{scale = TRUE} scales the signature data.
#' The default is \code{FALSE}.
#' @param showColumnNames logical. Setting \code{showColumnNames = TRUE} will
#' show the column names (i.e. sample names) on the heatmap. The default is
#' \code{TRUE}.
#' @param showRowNames logical. Setting \code{showColumnNames = TRUE} will
#' show the row names (i.e. signature names) on the heatmap. The default is
#' \code{TRUE}.
#' @param colorSets a vector of names listing the color sets in the order
#' that they should be used in creating the heatmap. By default, this function
#' will use the color sets in the order listed in \code{Usage} for annotation
#' information. You may replace the default with the same collection of sets
#' in order that you want to use them, or provide custom color sets with the
#' \code{colList} parameter.
#' @param choose_color a vector of color names to be interpolated for the
#' heatmap gradient, or a \code{colorRamp} function produced by
#' \code{circlize::colorRamp2}. The default is \code{c("blue", "gray95", "red")}.
#' @param split_heatmap a character string either giving the column title of
#' \code{annotationSignature} containing annotation data for which to split
#' the heatmap rows (i.e., signatures), or \code{"none"} if no split is desired.
#' To split based on the type of signature, set \code{split_heatmap = "disease"}.
#' The default is \code{"none"}.
#' @param annotationSignature a \code{data.frame} or \code{matrix} with information
#' to be used
#' in splitting the heatmap. The first column should signature names. The
#' column of annotation information should be specified in \code{split_heatmap.}
#' Other columns will be ignored. The default is \code{sigAnnotData}.
#' @param column_order a vector of character strings indicating the order in
#' which to manually arrange the heatmap columns. Default is \code{NULL},
#' such that column order is automatically determined via clustering.
#' @param cluster_columns A logical indicating whether columns (samples)
#' should be clustered together. Must be \code{FALSE} if user supplies
#' \code{column_order}. Default is \code{TRUE}.
#' @param ... Additional arguments to be passed to
#' \code{ComplexHeatmap::Heatmap()}.
#'
#' @return A ComplexHeatmap plot.
#'
#' @export
#'
#' @examples
#' library(SummarizedExperiment)
#' # Generate some artificial data that shows a difference in Zak_RISK_16
#' mat_testdata <- rbind(matrix(c(rnorm(80), rnorm(80) + 5), 16, 10,
#'                              dimnames = list(TBsignatures$Zak_RISK_16,
#'                                              paste0("sample", seq_len(10)))),
#'                       matrix(rnorm(1000), 100, 10,
#'                              dimnames = list(paste0("gene", seq_len(100)),
#'                                              paste0("sample", seq_len(10)))))
#' # Create a SummarizedExperiment object that contains the data
#' testdataSE <- SummarizedExperiment(assays = SimpleList(data = mat_testdata),
#'                                      colData = DataFrame(sample =
#'                                                            c(rep("down", 5),
#'                                                                 rep("up", 5))))
#' res <- runTBsigProfiler(testdataSE, useAssay = "data",
#'                         signatures = TBsignatures["Zak_RISK_16"],
#'                         algorithm = c("GSVA", "ssGSEA"), parallel.sz = 1,
#'                         combineSigAndAlgorithm = TRUE)
#' signatureHeatmap(res, signatureColNames = c("GSVA_Zak_RISK_16",
#'                                             "ssGSEA_Zak_RISK_16"),
#'                  annotationColNames = "sample", scale = TRUE,
#'                  showColumnNames = FALSE, split_heatmap = "none")
#'
#' # Example using custom colors for the annotation information
#' color2 <- stats::setNames(c("purple", "black"), c("down", "up"))
#' color.list <- list("sample" = color2)
#'
#' signatureHeatmap(res, signatureColNames = c("GSVA_Zak_RISK_16",
#'                                             "ssGSEA_Zak_RISK_16"),
#'                  annotationColNames = "sample", scale = TRUE,
#'                  showColumnNames = FALSE,
#'                  colList = color.list, split_heatmap = "none")
#'
signatureHeatmap <- function(inputData, annotationData = NULL, name = "Signatures",
                             signatureColNames,
                             annotationColNames = NULL,
                             colList = list(), scale = FALSE,
                             showColumnNames = TRUE,
                             showRowNames = TRUE, colorSets = c("Set1", "Set2",
                                                                "Set3", "Pastel1", "Pastel2", "Accent", "Dark2",
                                                                "Paired"),
                             choose_color = c("blue", "gray95", "red"),
                             split_heatmap = "none",
                             annotationSignature = sigAnnotData,
                             column_order = NULL,
                             cluster_columns = TRUE,
                             ...) {
  if (methods::is(inputData, "SummarizedExperiment")) {
    if (any(duplicated(signatureColNames))) {
      stop("Duplicate signature column name is not supported.")
    }
    if (!all(signatureColNames %in% colnames(SummarizedExperiment::colData(inputData)))) {
      stop("Signature column name not found in inputData.")
    }
    if (!is.null(annotationColNames)) {
      if (!all(annotationColNames %in% colnames(SummarizedExperiment::colData(inputData)))) {
        stop("Annotation column name not found in inputData.")
      }
      annotationData <- SummarizedExperiment::colData(inputData)[, annotationColNames, drop = FALSE]
      inputData <- SummarizedExperiment::colData(inputData)[, signatureColNames, drop = FALSE]
    }
  } else {
    if (is.null(annotationData)) {
      stop("annotationData must be provided for a data.frame input object.")
    } else if (!is.null(annotationData)) {
      annotationColNames <- colnames(annotationData)
    }
  }
  if (!is.null(annotationData)) {
    if (nrow(annotationData) == nrow(inputData)) {
      if (!all(rownames(annotationData) == rownames(inputData))) {
        stop("Annotation data and signature data does not match.")
      }
    } else if (nrow(annotationData) == ncol(inputData)) {
      if (!all(rownames(annotationData) == colnames(inputData))) {
        stop("Annotation data and signature data does not match.")
      }
      inputData <- t(inputData)
    } else {
      stop("Annotation data and signature data does not match.")
    }
  }
  sigresults <- t(as.matrix(inputData))
  keyname <- "Score"
  if (scale) {
    sigresults <- t(scale(t(sigresults)))
    keyname <- "Scaled Score"
  }
  # To split heatmap by signatures
  if (split_heatmap != "none") {
    if (!(split_heatmap %in% colnames(annotationSignature))) {
      stop("The column specified in 'split_heatmap' must be in the matrix or data.frame
           provided by 'annotationSignature'")
    }
  }
  ann_data <- annotationSignature[annotationSignature[, 1] %in%
                                    signatureColNames, ]
  if (split_heatmap == "none") {
    row_split_pass <- c()
  } else {
    row_split_pass <- ann_data[, split_heatmap]
  }
  if (!is.null(annotationData)) {
    if (length(colList) == 0) {
      colorSetNum <- 1
      for (annot in annotationColNames) {
        if (is.numeric(annotationData[, annot])) {
          t1min <- min(annotationData[, annot], na.rm = TRUE)
          t1max <- max(annotationData[, annot], na.rm = TRUE)
          colList[[annot]] <- circlize::colorRamp2(c(t1min, t1max),
                                                   c("white", "blue"))
        } else {
          if (is.factor(annotationData[, annot][!is.na(annotationData[, annot])])) {
            condLevels <- levels(annotationData[, annot][!is.na(annotationData[, annot])])
          } else {
            condLevels <- unique(annotationData[, annot][!is.na(annotationData[, annot])])
          }
          if (length(condLevels) > 8) {
            colors <- distinctColors(length(condLevels))
          } else {
            colors <- RColorBrewer::brewer.pal(8, colorSets[colorSetNum])
            colorSetNum <- colorSetNum + 1
          }
          colList[[annot]] <- stats::setNames(colors[seq_along(condLevels)],
                                              condLevels)
        }
      }
    }
    topha2 <- ComplexHeatmap::HeatmapAnnotation(
      df = data.frame(annotationData),
      col = colList, height = grid::unit(0.4 * length(annotationColNames), "cm"),
      show_legend = TRUE, show_annotation_name = TRUE)
    return(ComplexHeatmap::draw(
      ComplexHeatmap::Heatmap(sigresults, column_title = name,
                              show_column_names = showColumnNames,
                              col = choose_color,
                              show_row_names = showRowNames,
                              top_annotation = topha2, name = keyname,
                              row_split = row_split_pass,
                              column_order = column_order,
                              cluster_columns = cluster_columns,
                              ...),
      annotation_legend_side = "bottom"))
  }
}

#' Plot a boxplot of signature genes.
#'
#' @param inputData an input data object. It should either be of the class
#' \code{SummarizedExperiment} and contain the profiled signature data and
#' annotation data as columns in the \code{colData}, or alternatively be of the
#' classes \code{data.frame} or \code{matrix} and contain only the gene
#' expression data. Required.
#' @param annotationData a \code{data.frame} or \code{matrix} of annotation data,
#' with one column. Only required if \code{inputData} is a \code{data.frame} or
#' \code{matrix} of signature data.
#' @param signatureColNames a \code{vector} of the column names in \code{colData}
#' that contain the signature data. Only required if \code{inputData} is a
#' \code{SummarizedExperiment} object.
#' @param annotationColName a character string naming the column name in the
#' \code{colData} that contains the annotation data to be used in making the
#' boxplot. Only required if inputData is a \code{SummarizedExperiment} object.
#' @param name a character string giving the title of the boxplot. The default
#' is \code{"Signatures"}.
#' @param scale logical. Setting \code{scale = TRUE} scales the signature data.
#' The default is \code{FALSE}.
#' @param violinPlot logical. Setting \code{violinPlot = TRUE} creates violin
#' plots in place of boxplots. The default is \code{FALSE}.
#' @param includePoints logical. If \code{TRUE}, points will be included over
#' the boxplots. The default is \code{TRUE}.
#' @param notch logical. Notches are used to compare groups; if the notches of
#' two boxes do not overlap, this suggests that the medians are significantly
#' different. If \code{TRUE}, the boxplot will be notched. The default is
#' \code{FALSE}.
#' @param rotateLabels logical. If \code{TRUE}, the x-axis labels will be
#' rotated. The default is \code{FALSE}.
#' @param nrow integer giving the number of rows in the resulting array.
#' @param ncol integer giving the number of columns in the resulting array.
#' @param fill_colors a vector of color names to be used as the fill colors for
#' the boxplot. If \code{NULL}, colors will be supplied via RColorBrewer.
#' The default is \code{fill_colors = NULL}.
#'
#' @return A \code{ggplot2} boxplot of the signature data using the provided
#' annotation information.
#'
#' @export
#'
#' @examples
#' library(SummarizedExperiment)
#'
#' # Generate some artificial data that shows a difference in Zak_RISK_16
#' mat_testdata <- rbind(matrix(c(rnorm(80), rnorm(80) + 5), 16, 10,
#'                              dimnames = list(TBsignatures$Zak_RISK_16,
#'                                              paste0("sample", seq_len(10)))),
#'                       matrix(rnorm(1000), 100, 10,
#'                              dimnames = list(paste0("gene", seq_len(100)),
#'                                              paste0("sample", seq_len(10)))))
#'
#' # Create a SummarizedExperiment object that contains the data
#' testdataSE <- SummarizedExperiment(assays = SimpleList(data = mat_testdata),
#'                                    colData = DataFrame(sample =
#'                                                          c(rep("down", 5),
#'                                                            rep("up", 5))))
#'
#' # Run profiler using GSVA and ssGSEA on Zak_RISK_16 signature
#' res <- runTBsigProfiler(testdataSE, useAssay = "data",
#'                         signatures = TBsignatures["Zak_RISK_16"],
#'                         algorithm = c("GSVA", "ssGSEA"), parallel.sz = 1,
#'                         combineSigAndAlgorithm = TRUE)
#' signatureBoxplot(res, signatureColNames = c("GSVA_Zak_RISK_16",
#'                                             "ssGSEA_Zak_RISK_16"),
#'                  annotationColName = "sample", name = "Zak_RISK_16 Signature")
#'
signatureBoxplot <- function(inputData, annotationData, signatureColNames, annotationColName, 
                             name = "Signatures", scale = FALSE, violinPlot = FALSE, 
                             includePoints = TRUE, notch = FALSE, rotateLabels = FALSE, 
                             nrow = NULL, ncol = NULL, fill_colors = NULL) {
  if (methods::is(inputData, "SummarizedExperiment")) {
    if (any(duplicated(signatureColNames))) {
      stop("Duplicate signature column name is not supported.")
    }
    if (!all(signatureColNames %in% colnames(SummarizedExperiment::colData(inputData)))) {
      stop("Signature column name not found in inputData.")
    }
    if (!all(annotationColName %in% colnames(SummarizedExperiment::colData(inputData)))) {
      stop("Annotation column name not found in inputData.")
    }
    annotationData <- data.frame(SummarizedExperiment::colData(inputData)[, 
                                                                          annotationColName, drop = FALSE])
    inputData <- data.frame(SummarizedExperiment::colData(inputData)[, 
                                                                     signatureColNames, drop = FALSE])
  }
  else {
    if (ncol(annotationData) != 1) {
      stop("annotationData must have only one column.")
    }
    annotationColName <- colnames(annotationData)
  }
  if (length(annotationColName) != 1) {
    stop("You must specify a single annotation column name to color boxplots by.")
  }
  if (!is.factor(annotationData[, 1])) {
    annotationData[, 1] <- as.factor(annotationData[, 1])
  }
  n <- length(levels(annotationData[, 1]))
  if (n > 9) {
    stop("Too many levels in the annotation data. The boxplot can contain a maximum of 9 levels")
  }
  if (nrow(annotationData) == nrow(inputData)) {
    if (!all(rownames(annotationData) == rownames(inputData))) {
      stop("Annotation data and signature data does not match.")
    }
  }
  else if (nrow(annotationData) == ncol(inputData)) {
    if (!all(rownames(annotationData) == colnames(inputData))) {
      stop("Annotation data and signature data does not match.")
    }
    inputData <- t(inputData)
  }
  else {
    stop("Annotation data and signature data does not match.")
  }
  pathwaydata <- t(inputData)
  if (scale) {
    pathwaydata <- t(scale(t(pathwaydata)))
  }
  boxplotdf <- data.frame(t(pathwaydata), Group = annotationData[, 
                                                                 1])
  boxplotdfm <- reshape2::melt(boxplotdf, value.name = "Score", 
                               variable.name = "Signature", id.vars = "Group")
  sym_group <- "Group"
  sym_score <- "Score"
  theplot <- ggplot2::ggplot(boxplotdfm,
                             ggplot2::aes(!!ggplot2::sym(sym_group), !!ggplot2::sym(sym_score))) +
    ggplot2::facet_wrap(~Signature, scales = "free", nrow = nrow, ncol = ncol)
  if (violinPlot) {
    theplot <- theplot + ggplot2::geom_violin(ggplot2::aes(fill = !!ggplot2::sym(sym_group))) + 
      ggplot2::theme_classic()
  }
  else {
    theplot <- theplot + ggplot2::geom_boxplot(outlier.shape = NA, 
                                               ggplot2::aes(fill = !!ggplot2::sym(sym_group)), notch = notch) + 
      ggplot2::theme_classic()
  }
  if (includePoints) {
    theplot <- theplot + ggplot2::geom_point(position = ggplot2::position_jitter(width = 0.1))
  }
  if (rotateLabels) {
    theplot <- theplot + ggplot2::theme(axis.text.x = ggplot2::element_text(angle = 90, 
                                                                            hjust = 1))
  }
  if (is.null(fill_colors)) {
    if (n < 3) 
      n <- 3
    fill_colors <- RColorBrewer::brewer.pal(n, "Set1")
  }
  return(theplot + ggplot2::scale_fill_manual(values = fill_colors) + 
           ggplot2::ggtitle(name))
}

#' Plot a heatmap of a single signature score with individual gene expression levels.
#'
#' This function takes the profiled gene expression data for a single signature
#' and creates a heatmap based on the expression scores.
#'
#' @inheritParams signatureHeatmap
#' @param inputData a \code{SummarizedExperiment} object containing the profiled
#' signature data and annotation data as columns in the \code{colData}.
#' Required.
#' @param useAssay a character string specifying the assay to use for the gene
#' expression data. Required.
#' @param sigGenes a vector identifying the genes in the signature to use in
#' the heatmap. For inbuilt signatures, you can use \code{TBsignatures}
#' (e.g., \code{TBsignatures[["ACS_COR"]]}). Required.
#' @param name a character string with the plot title of the heatmap. The
#' default is \code{"Signatures"}.
#' @param signatureColNames a vector of the column names in the \code{colData}
#' that contain the signature data. Required.
#' @param annotationColNames a vector of the column names in the \code{colData}
#' that contain the annotation data. If \code{NULL}, no annotation bar besides
#' those of the scoring algorithms will be drawn on the heatmap. The default
#' is \code{NULL}.
#' @param scale logical. Setting \code{scale = TRUE} scales the signature data.
#' The default is \code{TRUE}.
#' @param showColumnNames logical. Setting \code{showColumnNames = TRUE} will
#' show the column names (i.e. sample names) on the heatmap. The default is
#' \code{TRUE}.
#' @param showRowNames logical. Setting \code{showColumnNames = TRUE} will
#' show the row names (i.e. signature names) on the heatmap. The default is
#' \code{TRUE}.
#' @param colList a named \code{list} of named vectors specifying custom color
#' information to pass to \code{ComplexHeatmap::Heatmap()}.
#' The list should have as many elements as there are annotation columns
#' and gene signatures (i.e. \code{sigGenes}), and each element name should
#' correspond exactly with the name of each annotation column/signature.
#' The colors in the vector elements should be named according to the
#' levels of the factor in that column's annotation data if the annotation
#' is discrete, or it should be produced with \code{circlize::colorRamp2}
#' if the annotation/gene is continuous.
#' By default, \code{ColorBrewer} color sets will be used.
#' See the the parameter \code{colorSets} for additional details.
#'
#' @return  A \code{ComplexHeatmap} plot.
#'
#' @export
#'
#' @examples
#' library(SummarizedExperiment)
#' # Generate some artificial data that shows a difference in Zak_RISK_16
#' mat_testdata <- rbind(matrix(c(rnorm(80), rnorm(80) + 5), 16, 10,
#'                              dimnames = list(TBsignatures$Zak_RISK_16,
#'                                              paste0("sample", seq_len(10)))),
#'                       matrix(rnorm(1000), 100, 10,
#'                              dimnames = list(paste0("gene", seq_len(100)),
#'                                              paste0("sample", seq_len(10)))))
#'
#' # Create a SummarizedExperiment object that contains the data
#' testdataSE <- SummarizedExperiment(assays = SimpleList(data = mat_testdata),
#'                                    colData = DataFrame(sample =
#'                                                        c(rep("down", 5),
#'                                                          rep("up", 5))))
#' # Run profiler using GSVA and ssGSEA on Zak_RISK_16
#' res <- runTBsigProfiler(testdataSE, useAssay = "data",
#'                         signatures = TBsignatures["Zak_RISK_16"],
#'                         algorithm = c("GSVA", "ssGSEA"), parallel.sz = 1,
#'                         combineSigAndAlgorithm = TRUE)
#'
#' # Plot a heatmap of signature genes and pathway predictions
#' signatureGeneHeatmap(res, useAssay = "data",
#'                      sigGenes = TBsignatures[["Zak_RISK_16"]],
#'                      signatureColNames = c("GSVA_Zak_RISK_16",
#'                                            "ssGSEA_Zak_RISK_16"),
#'                      annotationColNames = c("sample"), showColumnNames = FALSE,
#'                      name = "Zak_RISK_16")
signatureGeneHeatmap <- function(inputData, useAssay, sigGenes,
                                 name = "Signature", signatureColNames = NULL,
                                 annotationColNames = NULL, scale = TRUE,
                                 showColumnNames = TRUE, showRowNames = TRUE,
                                 colList = list(), colorSets = c("Set1", "Set2",
                                 "Set3", "Pastel1", "Pastel2", "Accent",
                                 "Dark2", "Paired"),
                                 choose_color = c("blue", "gray95", "red"),
                                 column_order = NULL,
                                 ...) {
  if (!is.null(signatureColNames)) {
    pathwaycols <- list()
    pathwaydata <- data.frame(SummarizedExperiment::
                                colData(inputData)[, signatureColNames,
                                                   drop = FALSE])
    for (i in colnames(pathwaydata)) {
      t1min <- min(pathwaydata[, i], na.rm = TRUE)
      t1max <- max(pathwaydata[, i], na.rm = TRUE)
      pathwaycols[[i]] <- circlize::colorRamp2(c(t1min,
                                                 mean(c(t1min, t1max)),
                                                 t1max),
                                               c("darkgreen",
                                                 "white",
                                                 "darkorange"))
    }
  } else {
    pathwaycols <- NULL
    pathwaydata <- NULL
  }
  heatdata <- SummarizedExperiment::assay(
    inputData, useAssay)[sigGenes[sigGenes %in% rownames(inputData)], ]
  heatname <- useAssay
  if (scale) {
    heatdata <- heatdata[base::rowSums(heatdata, na.rm = TRUE) != 0, ]
    heatdata <- t(scale(t(heatdata)))
    heatname <- paste("Scaled", heatname, sep = "\n")
  }

  if (!is.null(annotationColNames)) {
    annotationData <- data.frame(SummarizedExperiment::
                                   colData(inputData)[, annotationColNames,
                                                      drop = FALSE])
    if (length(colList) == 0) {
      colorSetNum <- 1
      for (annot in annotationColNames) {
        if (is.numeric(annotationData[, annot])) {
          t1min <- min(annotationData[, annot], na.rm = TRUE)
          t1max <- max(annotationData[, annot], na.rm = TRUE)
          colList[[annot]] <- circlize::colorRamp2(c(t1min, t1max),
                                                   c("white", "blue"))
        } else {
          if (is.factor(annotationData[, annot][!is.na(annotationData[, annot])])) {
            condLevels <- levels(
              annotationData[, annot][!is.na(annotationData[, annot])])
          } else {
            condLevels <- unique(
              annotationData[, annot][!is.na(annotationData[, annot])])
          }
          if (length(condLevels) > 8) {
            colors <- distinctColors(length(condLevels))
          } else {
            colors <- RColorBrewer::brewer.pal(8, colorSets[colorSetNum])
            colorSetNum <- colorSetNum + 1
          }
          colList[[annot]] <- stats::setNames(colors[seq_along(condLevels)],
                                              condLevels)
        }
      }
    } else {
      if (any(annotationColNames != names(colList))) {
        stop("The colList is out of sync with the annotation columns")
      }
    }
    colList <- c(colList, pathwaycols)
  } else {
    colList <- pathwaycols
  }

  if (!is.null(pathwaydata) | !is.null(annotationColNames)) {
    if (!is.null(annotationColNames) && !is.null(pathwaydata)) {
      annotDF <- cbind(data.frame(
        SummarizedExperiment::colData(inputData)[, annotationColNames,
                                                 drop = FALSE]),
                       pathwaydata)
    } else if (!is.null(annotationColNames)) {
      annotDF <- cbind(data.frame(SummarizedExperiment::
                                    colData(inputData)[, annotationColNames,
                                                       drop = FALSE]))
    } else {
      annotDF <- pathwaydata
    }
    topha <- ComplexHeatmap::HeatmapAnnotation(
      df = annotDF,
      col = colList,
      height = grid::unit(0.4 * length(c(annotationColNames,
                                         signatureColNames)), "cm"),
      show_legend = TRUE,
      show_annotation_name = TRUE)
  } else {
    topha <- NULL
  }
  return(ComplexHeatmap::draw(
    ComplexHeatmap::Heatmap(
      heatdata, show_column_names = showColumnNames,
      col = choose_color,
      show_row_names = showRowNames, top_annotation = topha,
      name = heatname, column_title = name,
      cluster_columns = TRUE,
      column_order = column_order, ...),
    annotation_legend_side = "bottom")
  )
}

#' Generate a distinct palette for coloring different clusters.
#'
#' Create a distinct palette for coloring different heatmap clusters. The
#' function returns colors for input into \code{ComplexHeatmap:Heatmap()},
#' \code{signatureGeneHeatmap()} and \code{signatureHeatmap()}.
#'
#' @param n an integer describing the number of colors to generate. Required.
#' @param hues a vector of character strings indicating the R colors available
#' from the \code{colors()} function. These will be used as the base colors for
#' the clustering scheme. Different saturations and values (i.e. darkness)
#' will be generated for each hue. Default is \code{c("red", "cyan", "orange",
#' "blue", "yellow", "purple", "green", "magenta")}
#' @param saturation.range a numeric vector of length 2 with values between 0
#' and 1 giving the range of saturation. The default is \code{c(0.25, 1)}.
#' @param value.range a numeric vector of length 2 with values between 0 and 1
#' giving the range of values. The default is \code{c(0.5, 1)}.
#'
#' @return A vector of distinct colors that have been converted to HEX from
#' HSV.
#'
#' @export
#'
#' @examples
#'
#' distinctColors(10)
#'
distinctColors <- function(n, hues = c("red", "cyan", "orange", "blue",
                                       "yellow", "purple", "green", "magenta"),
                           saturation.range = c(0.7, 1),
                           value.range = c(0.7, 1)) {

  if (!(all(hues %in% grDevices::colors()))) {
    stop("Only color names listed in the 'color'",
         " function can be used in 'hues'")
  }

  ## Convert R colors to RGB and then to HSV color format
  hues.hsv <- grDevices::rgb2hsv(grDevices::col2rgb(hues))

  ## Calculate all combination of saturation/value pairs.
  ## Note that low saturation with low value (i.e. high darkness) is too dark
  ## for all hues. Likewise, high saturation with high value (i.e. low darkness)
  ## is hard to distinguish. Therefore, saturation and value are set to be
  ## anticorrelated.
  num.vs <- ceiling(n / length(hues))
  s <- seq(from = saturation.range[1], to = saturation.range[2],
           length = num.vs)
  v <- seq(from = value.range[2], to = value.range[1], length = num.vs)

  ## Create all combinations of hues with saturation/value pairs
  new.hsv <- c()
  for (i in seq_len(num.vs)) {
    temp <- rbind(hues.hsv[1, ], s[i], v[i])
    new.hsv <- cbind(new.hsv, temp)
  }

  ## Convert to HEX
  col <- grDevices::hsv(new.hsv[1, ], new.hsv[2, ], new.hsv[3, ])

  return(col[seq_len(n)])
}

context("test-plot")

annotdata <- data.frame(sample = c(rep("down", 5), rep("up", 5)),
                        samplename = paste0("sample", 1:10),
                        row.names = paste0("sample", 1:10))
mat_testdata <- rbind(matrix(c(rnorm(80), rnorm(80) + 5), 16, 10,
                             dimnames = list(TBsignatures$Zak_RISK_16,
                                             paste0("sample", 1:10))),
                      matrix(rnorm(1000), 100, 10,
                             dimnames = list(paste0("gene", 1:100),
                                             paste0("sample", 1:10))))
df_testdata <- data.frame(mat_testdata)
SE_testdata <- SummarizedExperiment::SummarizedExperiment(
  assays = S4Vectors::SimpleList(data = mat_testdata),
  colData = S4Vectors::DataFrame(sample = c(rep("down", 5), rep("up", 5)),
                                 samplename = paste0("sample", 1:10),
                                 samplenum = c(1:5, 1:5)))
SE_wres <- runTBsigProfiler(SE_testdata, useAssay = "data",
                            signatures = list(sig1 = paste0("gene", 1:10)),
                            algorithm = "ssGSEA", parallel.sz = 1)
dfres <- runTBsigProfiler(SE_testdata, useAssay = "data",
                          outputFormat = "data.frame",
                          signatures = list(sig1 = paste0("gene", 1:10)),
                          algorithm = "ssGSEA", parallel.sz = 1)
df_errornames <- dfres
colnames(df_errornames)[1] <- "errorname"
terrorname <- t(df_errornames)
SummarizedExperiment::colData(SE_wres)$`Notfac` <- c(rep("yes", 5),
                                                     rep("no", 5))

test_that("Missing annotationData", {
  #signatureHeatmap
  expect_error(
    signatureHeatmap(inputData = SE_wres),
    "argument \"signatureColNames\" is missing, with no default")
  expect_error(
    signatureHeatmap(inputData = SE_wres, signatureColNames = "sig1",
                     annotationColNames = "group"),
    "Annotation column name not found in inputData.")
  expect_error(
    signatureHeatmap(inputData = SE_wres, signatureColNames = c("sig1", "sig1"),
                     annotationColNames = "group"),
    "Duplicate signature column name is not supported.")
  expect_error(
    signatureHeatmap(inputData = SE_wres, signatureColNames = c("sig2"),
                     annotationColNames = "group"),
    "Signature column name not found in inputData.")
  expect_error(
    signatureHeatmap(inputData = df_errornames, annotationData = annotdata),
    "Annotation data and signature data does not match.")
  expect_error(
    signatureHeatmap(inputData = terrorname, annotationData = annotdata),
    "Annotation data and signature data does not match.")
  expect_error(
    signatureHeatmap(inputData = df_errornames[, 1:5],
                     annotationData = annotdata),
    "Annotation data and signature data does not match.")
  expect_error(
    signatureHeatmap(inputData = SE_wres, signatureColNames = "sig1",
                     annotationColNames = "sample", scale = TRUE,
                     split_heatmap = "wrong"),
    "The column specified in 'split_heatmap' must be in the matrix or data.frame
           provided by 'annotationSignature'")
  expect_error(
    signatureHeatmap(inputData = dfres,
                     annotationData = NULL,
                     scale = TRUE,
                     split_heatmap = "none"),
    "annotationData must be provided for a data.frame input object.")

  #signatureBoxplot
  expect_error(
    signatureBoxplot(inputData = SE_wres),
    "argument \"signatureColNames\" is missing, with no default")
  expect_error(
    signatureBoxplot(inputData = SE_wres,
                     signatureColNames = "sig1"),
    "argument \"annotationColName\" is missing, with no default")
  expect_error(
    signatureBoxplot(inputData = SE_wres,
                     annotationColName = "sample",
                     signatureColNames = "sig2"),
    "Signature column name not found in inputData.")
  expect_error(
    signatureBoxplot(inputData = SE_wres,
                     annotationColName = "sample",
                     signatureColNames = c("sig1", "sig1")),
    "Duplicate signature column name is not supported.")
  expect_error(
    signatureBoxplot(inputData = SE_wres,
                     annotationColName = c("sample", "sample"),
                     signatureColNames = "sig1"),
    "You must specify a single annotation column name to color boxplots by.")
  expect_error(
    signatureBoxplot(inputData = SE_wres,
                     annotationColName = "samplea",
                     signatureColNames = "sig1"),
    "Annotation column name not found in inputData.")
  expect_error(
    signatureBoxplot(inputData = dfres,
                     annotationData = annotdata),
    "annotationData must have only one column.")
  expect_error(
    signatureBoxplot(inputData = df_errornames,
                     annotationData = annotdata[, 1, drop = FALSE]),
    "Annotation data and signature data does not match.")
  expect_error(
    signatureBoxplot(inputData = terrorname,
                     annotationData = annotdata[, 1, drop = FALSE]),
    "Annotation data and signature data does not match.")
  expect_error(
    signatureBoxplot(inputData = SE_wres, annotationColName = "samplename",
                     signatureColNames = "sig1"),
    "Too many levels in the annotation data. The boxplot can contain a maximum of 9 levels")
  expect_error(
    signatureBoxplot(inputData = df_errornames[, 1:5],
                     annotationData = annotdata[, 1, drop = FALSE]),
    "Annotation data and signature data does not match.")
  expect_error(
    distinctColors(10, hues = "peuce"),
    "Only color names listed in the \'color\' function can be used in \'hues\'")

  #signatureGeneHeatmap
  expect_error(
    signatureGeneHeatmap(),
    "argument \"inputData\" is missing, with no default")
  expect_error(
    signatureGeneHeatmap(inputData = SE_wres),
    "argument \"useAssay\" is missing, with no default")
  expect_error(
    signatureGeneHeatmap(inputData = SE_wres, useAssay = "data"),
    "argument \"sigGenes\" is missing, with no default")
  expect_error(
    signatureGeneHeatmap(inputData = SE_wres, signatureColNames = "sig1",
                         annotationColNames = "sample"),
    "argument \"useAssay\" is missing, with no default")
  expect_error(
    signatureGeneHeatmap(inputData = SE_wres, useAssay = "data",
                         signatureColNames = "sig1",
                         annotationColNames = "sample"),
    "argument \"sigGenes\" is missing, with no default")
  expect_error(
    signatureGeneHeatmap(inputData = SE_wres, useAssay = "data",
                         sigGenes = TBsignatures$Zak_RISK_16,
                         annotationColNames = c("sample"),
                         colList = list("wrong" = c("yes" = "blue"))),
    "The colList is out of sync with the annotation columns")
  expect_is(
    signatureGeneHeatmap(inputData = SE_wres, useAssay = "data",
                         sigGenes = TBsignatures$Zak_RISK_16,
                         annotationColNames = c("sample")),
    "HeatmapList")
  expect_is(
    signatureGeneHeatmap(inputData = SE_wres, useAssay = "data",
                         sigGenes = TBsignatures$Zak_RISK_16,
                         annotationColNames = c("Notfac")),
    "HeatmapList")
})

test_that("SummarizedExperiment Plot Works", {
  expect_is(
    signatureHeatmap(inputData = SE_wres, signatureColNames = "sig1",
                     annotationColNames = "sample"),
    "HeatmapList"
  )
  expect_is(
    signatureHeatmap(inputData = SE_wres, signatureColNames = "sig1",
                     annotationColNames = "sample", scale = TRUE,
                     split_heatmap = "disease",
                     annotationSignature = as.data.frame(
                       cbind(names = "sig1",
                             disease = "RISK",
                             tissue_type = "Whole"))),
    "HeatmapList"
  )
  expect_is(
    signatureHeatmap(inputData = SE_wres, signatureColNames = "sig1",
                     annotationColNames = "sample", scale = TRUE,
                     split_heatmap = "none"),
    "HeatmapList"
  )

  #signatureBoxplot
  expect_is(
    signatureBoxplot(inputData = SE_wres, annotationColName = "sample",
                     signatureColNames = "sig1"),
    "ggplot"
  )
  expect_is(
    signatureBoxplot(inputData = SE_wres, annotationColName = "sample",
                     signatureColNames = "sig1", scale = TRUE),
    "ggplot"
  )
  expect_is(
    signatureBoxplot(inputData = SE_wres, annotationColName = "samplenum",
                     signatureColNames = "sig1"),
    "ggplot"
  )
  expect_is(
    signatureBoxplot(inputData = SE_wres, annotationColName = "samplenum",
                     signatureColNames = "sig1",
                     violinPlot = TRUE, scale = TRUE),
    "ggplot"
  )
  expect_is(
    signatureGeneHeatmap(inputData = SE_wres, useAssay = "data",
                         sigGenes = TBsignatures$Zak_RISK_16),
    "HeatmapList"
  )
  expect_is(
    signatureGeneHeatmap(inputData = SE_wres, useAssay = "data",
                         sigGenes = TBsignatures$Zak_RISK_16,
                         signatureColNames = "sig1"),
    "HeatmapList"
  )
  expect_is(
    signatureGeneHeatmap(inputData = SE_wres, useAssay = "data",
                         sigGenes = TBsignatures$Zak_RISK_16,
                         annotationColNames = c("sample")),
    "HeatmapList"
  )
  expect_is(
    signatureGeneHeatmap(inputData = SE_wres, useAssay = "data",
                         sigGenes = TBsignatures$Zak_RISK_16,
                         signatureColNames = "sig1",
                         annotationColNames = c("sample", "samplename")),
    "HeatmapList"
  )
})

test_that("DataFrame Plot Works", {
  expect_is(
    signatureHeatmap(inputData = dfres,
                     annotationData = annotdata,
                     signatureColNames = c("sig1")),
    "HeatmapList"
  )
  expect_is(
    signatureBoxplot(inputData = dfres,
                     annotationData = annotdata[, 1, drop = FALSE],
                     rotateLabels = TRUE),
    "ggplot"
  )
})

shiny::observeEvent(input$upload, {
  if (input$dat == "samp") {
    if (input$sampdat == "tbhiv") {
      vals$tbdat <- TB_hiv
      vals$coldat <- colData(vals$tbdat)
      vals$covars <- colnames(colData(vals$tbdat))
      vals$datassays <- names(assays(vals$tbdat))
    } else if (input$sampdat == "tbind") {
      vals$tbdat <- TB_indian
      vals$coldat <- colData(TB_indian)
      vals$covars <- colnames(colData(vals$tbdat))
      vals$datassays <- names(assays(vals$tbdat))
    }
  } else if (input$dat == "updat") {
    if (input$updattype == "rawdat") {
      countdat <- read.table(input$countsfile$datapath, header = TRUE,
                            row.names = 1)
      metadat <- read.table(input$metdatfile$datapath, header = TRUE)
      vals$tbdat <- SummarizedExperiment::SummarizedExperiment(
        assays = list(counts = as.matrix(countdat)),
        colData = metadat)
      vals$coldat <- SummarizedExperiment::colData(vals$tbdat)
      vals$covars <- colnames(SummarizedExperiment::colData(vals$tbdat))
      vals$datassays <- names(SummarizedExperiment::assays(vals$tbdat))
    } else if (input$updattype == "sumexp") {
      tb1 <- shiny::get(load(input$rdsFile$datapath))
      vals$tbdat <- print(tb1)
      vals$coldat <- SummarizedExperiment::colData(vals$tbdat)
      vals$covars <- colnames(SummarizedExperiment::colData(vals$tbdat))
      vals$datassays <- names(SummarizedExperiment::assays(vals$tbdat))
    }
  }
})

shiny::observeEvent(input$upload, {
  output$counttable <- DT::renderDataTable(
    as.data.frame(SummarizedExperiment::assays(head(vals$tbdat, n = 20L))),
    options = list(scrollX = TRUE)
  )
  vals$profilerdat <- NULL
})

shiny::observeEvent(input$upload, {
  output$visdat <- renderDataTable(NULL)
  output$allheat <- NULL
  output$indheat <- NULL
  output$boxplotind <- NULL
  output$heatcomp <- NULL
  output$bootbox <- NULL
  output$rocsep <- NULL
})

for (package in c("shiny", "shinyWidgets", "shinythemes", "markdown", "DT",
                  "BiocManager", "SummarizedExperiment", "shinycssloaders")) {
  if (identical(find.package(package, quiet = FALSE), character(0))) {
    install.packages(package)
  }
}

library(shiny)
library(shinyWidgets)
library(shinythemes)
library(markdown)
library(DT)
library(BiocManager)
library(SummarizedExperiment)
library(TBSignatureProfiler)
library(shinycssloaders)

siglist <- names(TBsignatures)

ui <- fluidPage(
  theme = shinytheme("cosmo"),
  navbarPage(
    "TB Signature Profiler",
    source(file.path("ui", "ui_upload.R"), local = TRUE)$value,
    source(file.path("ui", "ui_profiler.R"), local = TRUE)$value,
    source(file.path("ui", "ui_visualization.R"), local = TRUE)$value,
    source(file.path("ui", "ui_auc.R"), local = TRUE)$value
  )
)

server <- function(input, output, session) {
  options(shiny.maxRequestSize = 100*1024^2) # 100MB limit
  vals <- reactiveValues(
    tbdat = NULL,
    coldat = NULL,
    covars = NULL,
    datassays = NULL,
    profilerdat = NULL
  )
  source(file.path("server", "server_upload.R"), local = TRUE)$value
  source(file.path("server", "server_profiler.R"), local = TRUE)$value
  source(file.path("server", "server_visualization.R"), local = TRUE)$value
  source(file.path("server", "server_auc.R"), local = TRUE)$value
}

shinyApp(ui, server)

output$ttest <- DT::renderDataTable({
  tableAUC(vals$profilerdat,
           annotationColName = "Disease",
           signatureColNames = names(TBsignatures),
           num.boot = 100,
           pb.show = FALSE)
})

shiny::observe({
  if (is.null(vals$profilerdat)) {
    shinyWidgets::updatePickerInput(session, "bootsigs", choices = NULL)
  } else {
    shinyWidgets::updatePickerInput(
      session, "bootsigs",
      choices = subset(siglist,
                       siglist %in% colnames(
                         SummarizedExperiment::colData(vals$profilerdat))))
  }
})

shiny::observeEvent(input$bootplot, {
  colors_box <- RColorBrewer::brewer.pal(12, "Set3")
  colors_rep <- rep(colors_box, 3)
  l_sig <- length(input$bootsigs)
  output$bootbox <- shiny::renderPlot({
    shiny::isolate({
      compareBoxplots(
        vals$profilerdat, annotationColName = "Disease",
        signatureColNames = names(TBsignatures[input$bootsigs]),
        pb.show = FALSE, fill.col = colors_rep[1:l_sig],
        rotateLabels = TRUE)
    })
  })
})

shiny::observe({
  if (is.null(vals$profilerdat)) {
    shinyWidgets::updatePickerInput(session, "singroc", choices = NULL)
  } else {
    shinyWidgets::updatePickerInput(
      session, "singroc", choices = subset(
        siglist, siglist %in% colnames(
          SummarizedExperiment::colData(vals$profilerdat))))
  }
})

shiny::observeEvent(input$rocplot, {
  output$rocsep <- shiny::renderPlot({
    shiny::isolate({
      print(signatureROCplot_CI(inputData = vals$profilerdat,
                                signatureColNames = input$singroc,
                                annotationColName = "Disease",
                                name = paste("ROC plot")))
    })
  })
})

shiny::navbarMenu(
  "Signature Visualization",
  shiny::tabPanel(
    "Heatmap with Selected Signatures",
    shiny::sidebarPanel(
      shinyWidgets::pickerInput(
        "selectsigs", label = "Select Signatures for Profiler",
        choices = siglist, options = list("actions-box" = TRUE),
        multiple = TRUE, selected = siglist),
      shiny::selectInput("allheatcovar", "Select Covariate", choices = NULL),
      shiny::actionButton("allheatplot", "Plot Heatmap")
    ),
    shiny::mainPanel(plotOutput("allheat", height = 800))
  ),
  shiny::tabPanel(
    "Heatmaps of Individual Signatures",
    shiny::sidebarPanel(
      shinyWidgets::pickerInput(
        "singheat", "Signature", choices = siglist,
        multiple = FALSE, selected = NULL),
      shinyWidgets::pickerInput(
        "genes", label = "Genes", choices = NULL,
        options = list("actions-box" = TRUE),
        multiple = TRUE),
      shiny::hr(),
      shiny::selectInput("singheatcovar", "Covariate", choices = NULL),
      shiny::actionButton("singheatplot", "Plot Heatmap(s)")
    ),
    shiny::mainPanel(
      shiny::plotOutput("indheat", height = 800)
    )
  ),
  shiny::tabPanel(
    "Boxplots of Individual Signatures",
    shiny::sidebarPanel(
      shinyWidgets::pickerInput(
        "singbox", "Signature(s)", choices = siglist,
        options = list("actions-box" = TRUE),
        multiple = TRUE, selected = NULL),
      shiny::hr(),
      shiny::selectInput("singboxcovar", "Covariate", choices = NULL),
      shiny::actionButton("singboxplot", "Plot Boxplot(s)")
    ),
    shiny::mainPanel(
      shiny::plotOutput("boxplotind", height = 500)
    )
  ),
  shiny::tabPanel(
    "Compare Scoring Methods for a Single Signature",
    shiny::sidebarPanel(
      shiny::selectInput("singcomp", "Select Signature", choices = siglist),
      shiny::selectInput("compassay", "Select Assay", choices = NULL),
      shiny::selectInput("compcovar", "Select Covariate", choices = NULL),
      shinyWidgets::pickerInput("compalg", "Select Algorithms", choices = c(
        "GSVA", "ssGSEA", "singscore", "PLAGE", "Zscore", "ASSIGN"),
        options = list("actions-box" = TRUE), multiple = TRUE, selected = NULL),
      shiny::actionButton("compplot", "Plot Heatmap")
    ),
    shiny::mainPanel(shiny::plotOutput("heatcomp", height = 400))
  )
)

---
title: "Introduction to the TBSignatureProfiler"
author: 
- name: Aubrey Odom
  affiliation: 
  - Program in Bioinformatics, Boston University, Boston, MA
  email: aodom@bu.edu
- name: W. Evan Johnson
  affiliation:
  - Division of Infectious Disease, Center for Data Science, Rutgers University – New Jersey Medical School, Newark, NJ, USA
  email: wj183@njms.rutgers.edu
date: '`r format(Sys.Date(), "%B %e, %Y")`'
package: TBSignatureProfiler
output: 
  BiocStyle::html_document
vignette: >
  %\VignetteIndexEntry{"Introduction to the TBSignatureProfiler"}
  %\VignetteEncoding{UTF-8}  
  %\VignetteEngine{knitr::rmarkdown}
editor_options: 
  chunk_output_type: console
---

# Introduction to the TBSignatureProfiler

Tuberculosis (TB) is the leading cause of infectious disease mortality worldwide, causing on average nearly 1.4 million deaths per year. A consistent issue faced in controlling TB outbreak is difficulty in diagnosing individuals with particular types of TB infections for which bacteria tests (e.g., via GeneXpert, sputum) prove inaccurate. As an alternative mechanism of diagnosis for these infections, researchers have discovered and published multiple gene expression signatures as blood-based disease biomarkers. In this context, gene signatures are defined as a combined group of genes with a uniquely characteristic pattern of gene expression that occurs as a result of a medical condition. To date, more than 75 signatures have been published by researchers, though most have relatively low cross-condition validation (e.g., testing TB in samples from diverse geographic and comorbidity backgrounds). Furthermore, these signatures have never been formally collected and made available as a single unified resource. 

We aim to provide the scientific community with a resource to access these aggregated signatures and to create an efficient means for their visual and quantitative comparison via open source software. This necessitated the development of the TBSignatureProfiler, a novel R package which delivers a computational profiling platform for researchers to characterize the diagnostic ability of existing signatures in multiple comorbidity settings. This software allows for signature strength estimation via several enrichment methods and subsequent visualization of single- and multi-pathway results. Its signature evaluation functionalities include signature profiling, AUC bootstrapping, and leave-one-out cross-validation (LOOCV) of logistic regression to approximate TB samples’ status. Its plotting functionalities include sample-signature score heatmaps, bootstrap AUC and LOOCV boxplots, and tables for presenting results.

More recently, the TBSignatureProfiler has undertaken a new role in analyzing signatures across multiple chronic airway diseases, the most recent being COVID-19 (see the `COVIDsignatures` object). As we grow and expand the TBSignatureProfiler, we hope to add signatures from multiple diseases to improve the package's utility in the area of gene signature comparison.
 
# Installation

In order to install the TBSignatureProfiler from Bioconductor, run the following code:

```{r load_profiler, eval = FALSE}
if (!requireNamespace("BiocManager", quietly = TRUE))
  install.packages("BiocManager")
BiocManager::install("TBSignatureProfiler")
```
                                                                      
# Compatibility with SummarizedExperiment objects

While the TBSignatureProfiler often allows for the form of a `data.frame` or `matrix` as input data, the most ideal form of input for this package is that of the `SummarizedExperiment` object. This is an amazing data structure that is being developed by the \emph{Bioconductor team} as part of the `r Biocpkg("SummarizedExperiment")` package, and is imported as part of the TBSignatureProfiler package. It is able to store data matrices along with annotation information, metadata, and reduced dimensionality data
(PCA, t-SNE, etc.). To learn more about proper usage and context of the `SummarizedExperiment` object, you may want to take a look at the [package vignette](https://bioconductor.org/packages/release/bioc/vignettes/SummarizedExperiment/inst/doc/SummarizedExperiment.html). A basic understanding of the `assay` and `colData` properties of a `SummarizedExperiment` will be useful for the purposes of this vignette. 

# A Quick Tutorial for the TBSignatureProfiler

## Load packages

```{r setup}
suppressPackageStartupMessages({
  library(TBSignatureProfiler)
  library(SummarizedExperiment)
})
```

## Run Shiny App
This command is to start the TBSignatureProfiler shiny app. The Shiny app implements several functions described in this vignette.

```{R Run_shiny_app, eval = FALSE}
TBSPapp()
```

The basic functions of the shiny app are also included in the command line version of the TBSignatureProfiler, which is the focus of the remainder of this vignette.

## Load dataset from a SummarizedExperiment object
In this tutorial, we will work with HIV and Tuberculosis (TB) gene expression data in a `SummarizedExperiment` format. This dataset is included in the TBSignatureProfiler package and can be loaded into the global environment with `data("TB_hiv")`. The 31 samples in the dataset are marked as either having both TB and HIV infection, or HIV infection only.

We begin by examining the dataset, which contains a matrix of counts information (an "assay" in SummarizedExperiment terms) and another matrix of meta data information on our samples (the "colData"). We will also generate a few additional assays; these are the log(counts), the counts per million (CPM) reads mapped, and the log(CPM) assays. 

```{r loading_data}
## HIV/TB gene expression data, included in the package
hivtb_data <- get0("TB_hiv", envir = asNamespace("TBSignatureProfiler"))

### Note that we have 25,369 genes, 33 samples, and 1 assay of counts
dim(hivtb_data)

# We start with only one assay
assays(hivtb_data)
```


We now make a log counts, CPM and log CPM assay.
```{r add_assays}
## Make a log counts, CPM and log CPM assay
hivtb_data <- mkAssay(hivtb_data, log = TRUE, counts_to_CPM = TRUE)

### Check to see that we now have 4 assays
assays(hivtb_data)
```

## Profile the data {.tabset}

The TBSignatureProfiler enables comparison of multiple Tuberculosis gene signatures. The package currently contains information on 79 signatures for comparison. The default signature list object for most functions here is `TBsignatures`, although a list with publication-given signature names is also available as `TBcommon`. Data frames of annotation information for these signatures, including information on associated disease and tissue type, can be accessed as `sigAnnotData` and `common_sigAnnotData` respectively.

With the `runTBSigProfiler` function, we are able to score these signatures with a selection of algorithms, including [gene set variation analysis](https://bmcbioinformatics.biomedcentral.com/articles/10.1186/1471-2105-14-7) (GSVA) (Hänzelmann et al, 2013), [single-sample GSEA](https://bmcbioinformatics.biomedcentral.com/articles/10.1186/1471-2105-14-7) (ssGSEA) (Barbie et al, 2009), and the [ASSIGN](https://bmcbioinformatics.biomedcentral.com/articles/10.1186/1471-2105-14-7) pathway profiling toolkit (Shen et al, 2015). For a complete list of included scoring methods, run `?runTBsigProfiler` in the terminal.

Here, we evaluate all signatures included in the package with ssGSEA. Paraphrasing from the [ssGSEA documentation](http://software.broadinstitute.org/cancer/software/genepattern/modules/docs/ssGSEAProjection/4), for each pairing of one of the 31 samples and its gene set, ssGSEA calculates a separate enrichment score independent of the phenotypic labeling (in this case, whether a sample has HIV/TB, or HIV only). The single sample's gene expression profile is then transformed to a gene set enrichment profile. A score from the set profile represents the activity level of the biological process in which the gene set's members are coordinately up- or down-regulated.  

```{r run_data}
## List all signatures in the profiler
data("TBsignatures")
names(TBsignatures)

## We can use all of these signatures for further analysis
siglist_hivtb <- names(TBsignatures)
```

A more complete tutorial is available by going to [our website](https://wejlab.github.io/TBSignatureProfiler-docs/index.html), and selecting the tab labeled "Command Line Analysis." 

# Session Info
```{r session info}
sessionInfo()

```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/OriginalModel.R
\name{.OriginalModel_Retraining}
\alias{.OriginalModel_Retraining}
\title{TB gene signatures that require retraining.}
\usage{
.OriginalModel_Retraining(input, useAssay, geneSignaturesName, adj, BPPARAM)
}
\arguments{
\item{input}{A SummarizedExperiment object with gene symbols as the assay row
names.}

\item{useAssay}{A character string or an integer specifying the assay in the
\code{input}. Default is the first assay in the assay list.
Used for the test SummarizedExperiment object. Default is \code{1}, indicating the
first assay in the \code{input}.}

\item{geneSignaturesName}{A character string/vector specifying the signature
of interest. If \code{any(geneSignaturesName == "") == TRUE}, it will run all
available gene signatures' original models.}

\item{adj}{A small positive real number used in \code{\link[sva]{ComBat}} to solve
for genes with 0 counts(rare cases). Default is \code{1e-3}.}

\item{BPPARAM}{An instance inherited from \code{\link[BiocParallel]{bplapply}}.}
}
\value{
A SummarizedExperiment object with predicted scores for each sample
obtained from the signature's original model.
}
\description{
A function to obtain predicted score for TB gene signatures that need retraining of original models.
}
\details{
Maertzdorf_4 and Maertzdorf_15 were trained using a random forest to distinguish
patients with active TB from healthy controls.

Verhagen_10 was also trained using a random forest to distinguish samples with active TB
from either latent infection or healthy controls.
The random forest model was build using \code{\link[randomForest]{randomForest}}.\cr

Jacobsen_3 were trained using linear discriminant analysis (LDA)
to distinguish samples with active TB from latent infection status.

Sambarey_HIV_10 were also trained using LDA to distinguish samples with active TB
from either latent infection, healthy control, or other disease (HIV).
The LDA model was built using \code{\link[MASS]{lda}}.\cr

Berry_OD_86 and Berry_393 were trained using K-nearest neighbors (KNN) model to
differentiate samples with active TB from latent infection status.
The KNN model was built using \code{\link[class]{knn}}.\cr

Suliman_RISK_4 and Zak_RISK_16 were trained using support vector machines (SVM)
to distinguish TB progressor from non-progressors. The input gene expression features
for Suliman_RISK_4 used the paired ratio of GAS6/CD1C, SEPTIN4/BLK, SEPTIN4/CD1C, GAS6/BLK.
The SVM model was built using \code{\link[e1071]{svm}}.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/OriginalModel.R
\name{.OriginalModel_NoRetraining}
\alias{.OriginalModel_NoRetraining}
\title{TB gene signatures that do not require retraining.}
\usage{
.OriginalModel_NoRetraining(input, useAssay, geneSignaturesName, BPPARAM)
}
\arguments{
\item{input}{A SummarizedExperiment object with gene symbols as the assay row
names.}

\item{useAssay}{A character string or an integer specifying the assay in the
\code{input}. Default is the first assay in the assay list.
Used for the test SummarizedExperiment object. Default is \code{1}, indicating the
first assay in the \code{input}.}

\item{geneSignaturesName}{A character string/vector specifying the signature
of interest. If \code{any(geneSignaturesName == "") == TRUE}, it will run all
available gene signatures' original models.}

\item{BPPARAM}{An instance inherited from \code{\link[BiocParallel]{bplapply}}.}
}
\value{
A SummarizedExperiment object with predicted scores for each sample
obtained from the signature's original model.
}
\description{
A function to obtain predicted score for TB gene signatures that do not need to be retrained.
}
\details{
Anderson_42 and Anderson_OD_51 used difference of sums to calculate
prediction scores. Difference of sums is obtained by subtracting the sum of
the expression of genes within signatures that are down-regulated from the
sum of the expression of genes that are up-regulated within signatures.
Kaforou_27, Kaforou_OD_44, and Kaforou_OD_53 used difference of arithmetic
means to calculate prediction scores.
Sweeney_OD_3 used difference of arithmetic mean to calculate prediction score.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot.R
\name{signatureGeneHeatmap}
\alias{signatureGeneHeatmap}
\title{Plot a heatmap of a single signature score with individual gene expression levels.}
\usage{
signatureGeneHeatmap(
  inputData,
  useAssay,
  sigGenes,
  name = "Signature",
  signatureColNames = NULL,
  annotationColNames = NULL,
  scale = TRUE,
  showColumnNames = TRUE,
  showRowNames = TRUE,
  colList = list(),
  colorSets = c("Set1", "Set2", "Set3", "Pastel1", "Pastel2", "Accent", "Dark2",
    "Paired"),
  choose_color = c("blue", "gray95", "red"),
  column_order = NULL,
  ...
)
}
\arguments{
\item{inputData}{a \code{SummarizedExperiment} object containing the profiled
signature data and annotation data as columns in the \code{colData}.
Required.}

\item{useAssay}{a character string specifying the assay to use for the gene
expression data. Required.}

\item{sigGenes}{a vector identifying the genes in the signature to use in
the heatmap. For inbuilt signatures, you can use \code{TBsignatures}
(e.g., \code{TBsignatures[["ACS_COR"]]}). Required.}

\item{name}{a character string with the plot title of the heatmap. The
default is \code{"Signatures"}.}

\item{signatureColNames}{a vector of the column names in the \code{colData}
that contain the signature data. Required.}

\item{annotationColNames}{a vector of the column names in the \code{colData}
that contain the annotation data. If \code{NULL}, no annotation bar besides
those of the scoring algorithms will be drawn on the heatmap. The default
is \code{NULL}.}

\item{scale}{logical. Setting \code{scale = TRUE} scales the signature data.
The default is \code{TRUE}.}

\item{showColumnNames}{logical. Setting \code{showColumnNames = TRUE} will
show the column names (i.e. sample names) on the heatmap. The default is
\code{TRUE}.}

\item{showRowNames}{logical. Setting \code{showColumnNames = TRUE} will
show the row names (i.e. signature names) on the heatmap. The default is
\code{TRUE}.}

\item{colList}{a named \code{list} of named vectors specifying custom color
information to pass to \code{ComplexHeatmap::Heatmap()}.
The list should have as many elements as there are annotation columns
and gene signatures (i.e. \code{sigGenes}), and each element name should
correspond exactly with the name of each annotation column/signature.
The colors in the vector elements should be named according to the
levels of the factor in that column's annotation data if the annotation
is discrete, or it should be produced with \code{circlize::colorRamp2}
if the annotation/gene is continuous.
By default, \code{ColorBrewer} color sets will be used.
See the the parameter \code{colorSets} for additional details.}

\item{colorSets}{a vector of names listing the color sets in the order
that they should be used in creating the heatmap. By default, this function
will use the color sets in the order listed in \code{Usage} for annotation
information. You may replace the default with the same collection of sets
in order that you want to use them, or provide custom color sets with the
\code{colList} parameter.}

\item{choose_color}{a vector of color names to be interpolated for the
heatmap gradient, or a \code{colorRamp} function produced by
\code{circlize::colorRamp2}. The default is \code{c("blue", "gray95", "red")}.}

\item{column_order}{a vector of character strings indicating the order in
which to manually arrange the heatmap columns. Default is \code{NULL},
such that column order is automatically determined via clustering.}

\item{...}{Additional arguments to be passed to
\code{ComplexHeatmap::Heatmap()}.}
}
\value{
A \code{ComplexHeatmap} plot.
}
\description{
This function takes the profiled gene expression data for a single signature
and creates a heatmap based on the expression scores.
}
\examples{
library(SummarizedExperiment)
# Generate some artificial data that shows a difference in Zak_RISK_16
mat_testdata <- rbind(matrix(c(rnorm(80), rnorm(80) + 5), 16, 10,
                             dimnames = list(TBsignatures$Zak_RISK_16,
                                             paste0("sample", seq_len(10)))),
                      matrix(rnorm(1000), 100, 10,
                             dimnames = list(paste0("gene", seq_len(100)),
                                             paste0("sample", seq_len(10)))))

# Create a SummarizedExperiment object that contains the data
testdataSE <- SummarizedExperiment(assays = SimpleList(data = mat_testdata),
                                   colData = DataFrame(sample =
                                                       c(rep("down", 5),
                                                         rep("up", 5))))
# Run profiler using GSVA and ssGSEA on Zak_RISK_16
res <- runTBsigProfiler(testdataSE, useAssay = "data",
                        signatures = TBsignatures["Zak_RISK_16"],
                        algorithm = c("GSVA", "ssGSEA"), parallel.sz = 1,
                        combineSigAndAlgorithm = TRUE)

# Plot a heatmap of signature genes and pathway predictions
signatureGeneHeatmap(res, useAssay = "data",
                     sigGenes = TBsignatures[["Zak_RISK_16"]],
                     signatureColNames = c("GSVA_Zak_RISK_16",
                                           "ssGSEA_Zak_RISK_16"),
                     annotationColNames = c("sample"), showColumnNames = FALSE,
                     name = "Zak_RISK_16")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/OriginalModel.R
\name{cv_glmnet_OriginalModel}
\alias{cv_glmnet_OriginalModel}
\title{Train original model for gene signatures Leong_24, Leong_RISK_29, Zhao_NANO_6 using lasso logistic regression.}
\usage{
cv_glmnet_OriginalModel(dat_list, dat_test_sig)
}
\arguments{
\item{dat_list}{A \code{list} contains training data and disease status
outcomes from the discovery data of corresponding gene signatures.}

\item{dat_test_sig}{A \code{data frame} contains corresponding gene sets
from the \code{input}.}
}
\value{
The predicted score for each sample in the test study.
}
\description{
Train original model for gene signatures Leong_24, Leong_RISK_29, Zhao_NANO_6 using lasso logistic regression.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/profile.R
\name{compareAlgs}
\alias{compareAlgs}
\title{Compare scoring algorithms on a single signature via heatmap or boxplot.}
\usage{
compareAlgs(
  input,
  signatures = NULL,
  annotationColName,
  useAssay = "counts",
  algorithm = c("GSVA", "ssGSEA", "ASSIGN", "PLAGE", "Zscore", "singscore"),
  showColumnNames = TRUE,
  showRowNames = TRUE,
  scale = FALSE,
  colorSets = c("Set1", "Set2", "Set3", "Pastel1", "Pastel2", "Accent", "Dark2",
    "Paired"),
  choose_color = c("blue", "gray95", "red"),
  colList = list(),
  show.pb = FALSE,
  parallel.sz = 0,
  output = "heatmap",
  num.boot = 100,
  column_order = NULL
)
}
\arguments{
\item{input}{an input data object of the class \code{"SummarizedExperiment"}.
Required.}

\item{signatures}{a \code{list} of signatures to run with their associated genes.
This list should be in the same format as \code{TBsignatures}, included in
the TBSignatureProfiler package. If \code{signatures = NULL}, the default set
of signatures \code{TBsignatures} list is used.
For details, run \code{?TBsignatures}.
If <2 genes in a signature are present in the sample, that signature will
not be evaluated and will not be present in the resulting SE object.
The default is \code{NULL}.}

\item{annotationColName}{a character string giving the column name in
\code{colData} that contains the annotation data. Required.}

\item{useAssay}{a character string specifying the assay to use for signature
profiling when \code{input} is a \code{SummarizedExperiment}. Required only for
input data of the class \code{SummarizedExperiment}. If null, the assay
used will be \code{"counts"}. The default is \code{NULL.}}

\item{algorithm}{a vector of algorithms to run, or character string if only
one is desired. The default is \code{c("GSVA", "ssGSEA", "ASSIGN",
"PLAGE", "Zscore", "singscore")}. NOTE: ASSIGN takes a long time to run and
is not recommended for efficient use.}

\item{showColumnNames}{logical. Setting \code{showColumnNames = TRUE} will
show the column names (i.e. sample names) on the heatmap. The default is
\code{TRUE}.}

\item{showRowNames}{logical. Setting \code{showColumnNames = TRUE} will
show the row names (i.e. signature names) on the heatmap. The default is
\code{TRUE}.}

\item{scale}{logical. Setting \code{scale = TRUE} scales the signature data.
The default is \code{FALSE}.}

\item{colorSets}{a vector of names listing the color sets in the order
that they should be used in creating the heatmap. By default, this function
will use the color sets in the order listed in \code{Usage} for annotation
information. You may replace the default with the same collection of sets
in order that you want to use them, or provide custom color sets with the
\code{colList} parameter.}

\item{choose_color}{a vector of color names to be interpolated for the
heatmap gradient, or a \code{colorRamp} function produced by
\code{circlize::colorRamp2}. The default is \code{c("blue", "gray95", "red")}.}

\item{colList}{a named \code{list} of named vectors specifying custom color
information to
pass to \code{ComplexHeatmap::Heatmap()}. The list should have as many
elements as there are annotation columns, and each element name should
correspond exactly with the name of each annotation column.
The colors in the vector elements should be named according to the
levels of the factor in that column's annotation data if the annotation
is discrete, or it should be produced with \code{circlize::colorRamp2}
if the annotation is continuous.
By default, \code{ColorBrewer} color sets will be used.
See the the parameter \code{colorSets} for additional details.}

\item{show.pb}{logical, whether warnings and other output
from the profiling should be suppressed (including progress bar output).
Default is \code{FALSE}.}

\item{parallel.sz}{an integer identifying the number of processors to use
when running the calculations in parallel for the GSVA and ssGSEA algorithms.
If \code{parallel.sz = 0}, all cores are used. The default is \code{0}.}

\item{output}{a character string specifying whether the outputted plot
should be a \code{"heatmap"} or \code{"boxplot"}. The default is
\code{"heatmap"}.}

\item{num.boot}{an integer indicating the number of times to bootstrap the
data.}

\item{column_order}{a vector of character strings indicating the order in
which to manually arrange the heatmap columns. Default is \code{NULL},
such that column order is automatically determined via clustering.}
}
\value{
A heatmap or boxplot for each signature specified comparing
the enumerated algorithms.
}
\description{
It may be useful to compare the results of scoring across several different
scoring algorithms via a method of visualization, such as a heatmap. The
\code{compareSigs} function allows the input of a SummarizedExperiment
data object and conducts
profiling on each signature desired, and outputting a heatmap or boxplot
for each signature.
}
\examples{
compareAlgs(TB_indian,
            signatures = TBsignatures[c("Gliddon_OD_3")],
            annotationColName = "label",
            algorithm = c("ssGSEA", "PLAGE"),
            scale = TRUE, parallel.sz = 1, output = "heatmap")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bootstrap.R
\name{mkAssay}
\alias{mkAssay}
\title{Add SummarizedExperiment assays to the data structure.}
\usage{
mkAssay(
  SE_obj,
  input_name = "counts",
  output_name = NULL,
  log = FALSE,
  counts_to_CPM = TRUE,
  prior_counts = 3
)
}
\arguments{
\item{SE_obj}{a \code{SummarizedExperiment} object containing count or CPM
data. Required.}

\item{input_name}{a character string specifying the name of the assay to
be referenced for creating additional assays. Default is \code{"counts"}.}

\item{output_name}{a character string to use in place of the \code{input_name}.
If \code{NULL}, then \code{input_name} will be substituted.
Default is \code{NULL}. See Return details for how names are altered.}

\item{log}{logical. Indicate whether an assay returned should be the log
of whichever assay is specified in \code{"output_name"}. If
\code{counts_to_CPM = TRUE} as well, then a log CPM assay will also
be created. Default is \code{FALSE}.}

\item{counts_to_CPM}{logical. This argument only applies if the
\code{input_type} is a counts assay. If \code{TRUE}, then the output assays
will include a normalized CPM assay. If \code{log = TRUE} as well,
then a log CPM assay will also be created. Default is \code{TRUE}.}

\item{prior_counts}{a small integer specifying the average count to be added to
each observation to avoid taking the log of zero. Used only if
\code{log = TRUE}. The default is \code{3}.}
}
\value{
This function returns a \code{SummarizedExperiment} object with up
to 3 additional assay types attached to the original inputted object.
\item{\code{output_name}_cpm}{Counts per million}
\item{log_\code{output_name}_cpm}{Log counts per million}
\item{log_\code{output_name}}{Log of original input assay.}
}
\description{
Given a \code{SummarizedExperiment} input with a counts or CPM assay, this
function creates additional assays for by computing the CPM, log, or both
of the input assay to be used in further analysis.
}
\examples{
# Create a log assay of the original assay input
# TB_hiv dataset already has counts data
log_only <- mkAssay(TB_hiv, log = TRUE, counts_to_CPM = FALSE)
log_only

# Create a CPM assay
CPM_only <- mkAssay(TB_hiv)
CPM_only

# Create a logCPM, logcounts, and CPM assay
all_assays <- mkAssay(TB_hiv, log = TRUE)
all_assays

}
\author{
Aubrey Odom-Mabey
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/OriginalModel.R
\name{ref_combat_impute}
\alias{ref_combat_impute}
\title{A function for reference batch correction and imputation.}
\usage{
ref_combat_impute(
  theObject_train,
  useAssay,
  gene_set,
  input,
  SigName,
  adj,
  geneMax = 0.8
)
}
\arguments{
\item{theObject_train}{A SummarizedExperiment object that has been pre-stored in the
data file: OriginalTrainingData.}

\item{useAssay}{A character string or an integer specifying the assay in the \code{input}.
Used for the test SummarizedExperiment object. Default is 1, indicating the first assay
in the test SummarizedExperiment object.}

\item{gene_set}{A character vector that includes gene symbols for selected gene signature.}

\item{input}{A SummarizedExperiment object with gene symbols as the assay row names.}

\item{SigName}{Optional. A character string that indicates the name for \code{gene_set}.
\code{SigName} is used to provide information when gene signatures were missing
in the test data.}

\item{adj}{A small real number used in combat to solve for genes with 0 counts in rare cases.
Not required for most of cases.}

\item{geneMax}{A real number between 0 and 1. This is used to detect the
maximum percent missing genes allowed in the evaluated signatures.
See \code{\link[impute]{impute.knn}} for details. The default value is 0.8.}
}
\value{
Gene set subset
}
\description{
A function used to perform reference batch correction and imputation in the
testing data for gene signatures that require retraining of the model.
We used the k-nearest neighbors to impute the expression values for missing gene(s).
The imputation operation is achieved using \code{\link[impute]{impute.knn}}.
Since the computational time for the imputation step can be excessive for large
number of missing genes. We made some constrains to prevent the overflow of imputation
operation. The evaluation will not run if more than \code{geneMax}*100\\% percent
of the genes are not found for the corresponding gene signature in the input study.
By default \code{geneMax} = 0.8, so the evaluation will not run if more than 80\\%
of the genes are missing when matching the input study to the reference data.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bootstrap.R
\name{signatureROCplot}
\alias{signatureROCplot}
\title{Create an array of ROC plots to compare signatures.}
\usage{
signatureROCplot(
  inputData,
  annotationData,
  signatureColNames,
  annotationColName,
  scale = FALSE,
  choose_colors = c("cornflowerblue", "gray24"),
  name = "Signatures",
  nrow = NULL,
  ncol = NULL
)
}
\arguments{
\item{inputData}{an input data object. It should either be of the class
\code{SummarizedExperiment} and contain the profiled signature data and
annotation data as columns in the \code{colData}, or alternatively be of the
classes \code{data.frame} or \code{matrix} and contain only the gene
expression data. Required.}

\item{annotationData}{a \code{data.frame} or \code{matrix} of annotation data,
with one column. Only required if \code{inputData} is a \code{data.frame} or
\code{matrix} of signature data.}

\item{signatureColNames}{a \code{vector} of the column names of \code{inputData}
that contain the signature data. If \code{inputData} is a
\code{SummarizedExperiment} object, these are the column names of the
object \code{colData}.}

\item{annotationColName}{a character string naming the column name in the
\code{colData} that contains the annotation data to be used in making the
boxplot. Only required if inputData is a \code{SummarizedExperiment} object.}

\item{scale}{logical. Setting \code{scale = TRUE} scales the signature data.
The default is \code{FALSE}.}

\item{choose_colors}{a \code{vector} of length 2 defining the colors to be used
in the ROC plots. The default is \code{c("cornflowerblue", "gray24")}.}

\item{name}{a character string giving the title of the boxplot. The default
is \code{"Signatures"}.}

\item{nrow}{integer giving the number of rows in the resulting array.}

\item{ncol}{integer giving the number of columns in the resulting array.}
}
\value{
An array of ROC plots.
}
\description{
Create an array of ROC plots to compare signatures.
}
\examples{
# Run signature profiling
 choose_sigs <- subset(TBsignatures,
                       !(names(TBsignatures) \%in\% c("Lee_4", "Roe_OD_4")))[c(1,2)]
 prof_indian <- runTBsigProfiler(TB_indian, useAssay = "logcounts",
                                 algorithm = "ssGSEA",
                                 signatures = choose_sigs,
                                 parallel.sz = 1)

# Create ROC plots
signatureROCplot(prof_indian, signatureColNames = names(choose_sigs),
                 annotationColName = "label")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot.R
\name{signatureHeatmap}
\alias{signatureHeatmap}
\title{Plot a heatmap of signature scores.}
\usage{
signatureHeatmap(
  inputData,
  annotationData = NULL,
  name = "Signatures",
  signatureColNames,
  annotationColNames = NULL,
  colList = list(),
  scale = FALSE,
  showColumnNames = TRUE,
  showRowNames = TRUE,
  colorSets = c("Set1", "Set2", "Set3", "Pastel1", "Pastel2", "Accent", "Dark2",
    "Paired"),
  choose_color = c("blue", "gray95", "red"),
  split_heatmap = "none",
  annotationSignature = sigAnnotData,
  column_order = NULL,
  cluster_columns = TRUE,
  ...
)
}
\arguments{
\item{inputData}{an input data object. It should either be of the class
\code{SummarizedExperiment} and contain the profiled signature data and
annotation data as columns in the colData, or alternatively be of the classes
\code{data.frame} or \code{matrix} and contain only the gene expression data.
Required.}

\item{annotationData}{a \code{data.frame} or \code{matrix} of annotation
data, with one column. Only required if \code{inputData} is a
\code{data.frame} or \code{matrix} of signature data.
The row names must equal those of the \code{inputData} column names.
Default is \code{NULL}.}

\item{name}{a character string with the plot title of the heatmap. The
default is \code{"Signatures"}.}

\item{signatureColNames}{a vector of the column names in \code{colData} that
contain the signature data. Only required if \code{inputData} is a
SummarizedExperiment object.}

\item{annotationColNames}{a vector of the column names in \code{colData} that
contain the annotation data. Only required if \code{inputData} is a
\code{SummarizedExperiment}. Default is \code{NULL}.}

\item{colList}{a named \code{list} of named vectors specifying custom color
information to
pass to \code{ComplexHeatmap::Heatmap()}. The list should have as many
elements as there are annotation columns, and each element name should
correspond exactly with the name of each annotation column.
The colors in the vector elements should be named according to the
levels of the factor in that column's annotation data if the annotation
is discrete, or it should be produced with \code{circlize::colorRamp2}
if the annotation is continuous.
By default, \code{ColorBrewer} color sets will be used.
See the the parameter \code{colorSets} for additional details.}

\item{scale}{logical. Setting \code{scale = TRUE} scales the signature data.
The default is \code{FALSE}.}

\item{showColumnNames}{logical. Setting \code{showColumnNames = TRUE} will
show the column names (i.e. sample names) on the heatmap. The default is
\code{TRUE}.}

\item{showRowNames}{logical. Setting \code{showColumnNames = TRUE} will
show the row names (i.e. signature names) on the heatmap. The default is
\code{TRUE}.}

\item{colorSets}{a vector of names listing the color sets in the order
that they should be used in creating the heatmap. By default, this function
will use the color sets in the order listed in \code{Usage} for annotation
information. You may replace the default with the same collection of sets
in order that you want to use them, or provide custom color sets with the
\code{colList} parameter.}

\item{choose_color}{a vector of color names to be interpolated for the
heatmap gradient, or a \code{colorRamp} function produced by
\code{circlize::colorRamp2}. The default is \code{c("blue", "gray95", "red")}.}

\item{split_heatmap}{a character string either giving the column title of
\code{annotationSignature} containing annotation data for which to split
the heatmap rows (i.e., signatures), or \code{"none"} if no split is desired.
To split based on the type of signature, set \code{split_heatmap = "disease"}.
The default is \code{"none"}.}

\item{annotationSignature}{a \code{data.frame} or \code{matrix} with information
to be used
in splitting the heatmap. The first column should signature names. The
column of annotation information should be specified in \code{split_heatmap.}
Other columns will be ignored. The default is \code{sigAnnotData}.}

\item{column_order}{a vector of character strings indicating the order in
which to manually arrange the heatmap columns. Default is \code{NULL},
such that column order is automatically determined via clustering.}

\item{cluster_columns}{A logical indicating whether columns (samples)
should be clustered together. Must be \code{FALSE} if user supplies
\code{column_order}. Default is \code{TRUE}.}

\item{...}{Additional arguments to be passed to
\code{ComplexHeatmap::Heatmap()}.}
}
\value{
A ComplexHeatmap plot.
}
\description{
This function takes a dataset of scored gene expression data as an input
and returns a \code{ComplexHeatmap} plot for for visual comparison of
signature performance. The function takes arguments listed here as well
as any others to be passed on to \code{ComplexHeatmap::Heatmap()}.
}
\details{
If both \code{annotationData = NULL} and \code{annotationColNames = NULL},
no annotation bar will be drawn on the heatmap.
}
\examples{
library(SummarizedExperiment)
# Generate some artificial data that shows a difference in Zak_RISK_16
mat_testdata <- rbind(matrix(c(rnorm(80), rnorm(80) + 5), 16, 10,
                             dimnames = list(TBsignatures$Zak_RISK_16,
                                             paste0("sample", seq_len(10)))),
                      matrix(rnorm(1000), 100, 10,
                             dimnames = list(paste0("gene", seq_len(100)),
                                             paste0("sample", seq_len(10)))))
# Create a SummarizedExperiment object that contains the data
testdataSE <- SummarizedExperiment(assays = SimpleList(data = mat_testdata),
                                     colData = DataFrame(sample =
                                                           c(rep("down", 5),
                                                                rep("up", 5))))
res <- runTBsigProfiler(testdataSE, useAssay = "data",
                        signatures = TBsignatures["Zak_RISK_16"],
                        algorithm = c("GSVA", "ssGSEA"), parallel.sz = 1,
                        combineSigAndAlgorithm = TRUE)
signatureHeatmap(res, signatureColNames = c("GSVA_Zak_RISK_16",
                                            "ssGSEA_Zak_RISK_16"),
                 annotationColNames = "sample", scale = TRUE,
                 showColumnNames = FALSE, split_heatmap = "none")

# Example using custom colors for the annotation information
color2 <- stats::setNames(c("purple", "black"), c("down", "up"))
color.list <- list("sample" = color2)

signatureHeatmap(res, signatureColNames = c("GSVA_Zak_RISK_16",
                                            "ssGSEA_Zak_RISK_16"),
                 annotationColNames = "sample", scale = TRUE,
                 showColumnNames = FALSE,
                 colList = color.list, split_heatmap = "none")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{OriginalTrainingData}
\alias{OriginalTrainingData}
\title{Discovery datasets for corresponding gene signatures.}
\format{
list
}
\source{
See \code{?TBsignatures} for reference information.
}
\usage{
OriginalTrainingData
}
\description{
Discovery datasets for corresponding gene signatures.
}
\examples{
data("OriginalTrainingData")
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot.R
\name{signatureBoxplot}
\alias{signatureBoxplot}
\title{Plot a boxplot of signature genes.}
\usage{
signatureBoxplot(
  inputData,
  annotationData,
  signatureColNames,
  annotationColName,
  name = "Signatures",
  scale = FALSE,
  violinPlot = FALSE,
  includePoints = TRUE,
  notch = FALSE,
  rotateLabels = FALSE,
  nrow = NULL,
  ncol = NULL,
  fill_colors = NULL
)
}
\arguments{
\item{inputData}{an input data object. It should either be of the class
\code{SummarizedExperiment} and contain the profiled signature data and
annotation data as columns in the \code{colData}, or alternatively be of the
classes \code{data.frame} or \code{matrix} and contain only the gene
expression data. Required.}

\item{annotationData}{a \code{data.frame} or \code{matrix} of annotation data,
with one column. Only required if \code{inputData} is a \code{data.frame} or
\code{matrix} of signature data.}

\item{signatureColNames}{a \code{vector} of the column names in \code{colData}
that contain the signature data. Only required if \code{inputData} is a
\code{SummarizedExperiment} object.}

\item{annotationColName}{a character string naming the column name in the
\code{colData} that contains the annotation data to be used in making the
boxplot. Only required if inputData is a \code{SummarizedExperiment} object.}

\item{name}{a character string giving the title of the boxplot. The default
is \code{"Signatures"}.}

\item{scale}{logical. Setting \code{scale = TRUE} scales the signature data.
The default is \code{FALSE}.}

\item{violinPlot}{logical. Setting \code{violinPlot = TRUE} creates violin
plots in place of boxplots. The default is \code{FALSE}.}

\item{includePoints}{logical. If \code{TRUE}, points will be included over
the boxplots. The default is \code{TRUE}.}

\item{notch}{logical. Notches are used to compare groups; if the notches of
two boxes do not overlap, this suggests that the medians are significantly
different. If \code{TRUE}, the boxplot will be notched. The default is
\code{FALSE}.}

\item{rotateLabels}{logical. If \code{TRUE}, the x-axis labels will be
rotated. The default is \code{FALSE}.}

\item{nrow}{integer giving the number of rows in the resulting array.}

\item{ncol}{integer giving the number of columns in the resulting array.}

\item{fill_colors}{a vector of color names to be used as the fill colors for
the boxplot. If \code{NULL}, colors will be supplied via RColorBrewer.
The default is \code{fill_colors = NULL}.}
}
\value{
A \code{ggplot2} boxplot of the signature data using the provided
annotation information.
}
\description{
Plot a boxplot of signature genes.
}
\examples{
library(SummarizedExperiment)

# Generate some artificial data that shows a difference in Zak_RISK_16
mat_testdata <- rbind(matrix(c(rnorm(80), rnorm(80) + 5), 16, 10,
                             dimnames = list(TBsignatures$Zak_RISK_16,
                                             paste0("sample", seq_len(10)))),
                      matrix(rnorm(1000), 100, 10,
                             dimnames = list(paste0("gene", seq_len(100)),
                                             paste0("sample", seq_len(10)))))

# Create a SummarizedExperiment object that contains the data
testdataSE <- SummarizedExperiment(assays = SimpleList(data = mat_testdata),
                                   colData = DataFrame(sample =
                                                         c(rep("down", 5),
                                                           rep("up", 5))))

# Run profiler using GSVA and ssGSEA on Zak_RISK_16 signature
res <- runTBsigProfiler(testdataSE, useAssay = "data",
                        signatures = TBsignatures["Zak_RISK_16"],
                        algorithm = c("GSVA", "ssGSEA"), parallel.sz = 1,
                        combineSigAndAlgorithm = TRUE)
signatureBoxplot(res, signatureColNames = c("GSVA_Zak_RISK_16",
                                            "ssGSEA_Zak_RISK_16"),
                 annotationColName = "sample", name = "Zak_RISK_16 Signature")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/TBSPapp.R
\name{TBSPapp}
\alias{TBSPapp}
\title{Run the TBSignatureProfiler Shiny application.}
\usage{
TBSPapp()
}
\value{
The Shiny application will open.
}
\description{
Use this function to run the TBSignatureProfiler application.
}
\examples{
# Upload data through the app
if (interactive()) {
  TBSPapp()
}

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/addTBsignature.R
\name{addTBsignature}
\alias{addTBsignature}
\title{Introduce a new signature into the TBSignatureProfiler.}
\usage{
addTBsignature(
  sigsymbols,
  authname,
  signame_common = NULL,
  sigtype,
  tissuetype,
  saveobjs = FALSE,
  views = TRUE
)
}
\arguments{
\item{sigsymbols}{a \code{character vector} of the gene symbols that compose
the signature to be added. Required.}

\item{authname}{a \code{character} string containing the last name of the primary
author of the publication where the signature was first identified.
If spaces are present, omit them, and use proper capitalization. Required.}

\item{signame_common}{a \code{character} string of the alternate name of the
signature given by the publication, if it exists. If \code{NULL}, no
assigned name is assumed to exist. Default is \code{null}.}

\item{sigtype}{a \code{character} string that gives the context that the
signature was developed under. Most commonly,
it will distinguish TB from LTBI ("Disease"),
TB from some combination of other diseases and possibly LTBI
("Disease/Other Diseases"), TB from Human Immunodeficiency Virus
("Disease/HIV"), TB from pneumonia ("Disease/Pneumonia"),
or identify risk of progression to TB ("risk"), risk of TB treatment
failure ("failure"), or classify treatment responses
(i.e., failures from cures, "response"). Required.}

\item{tissuetype}{a \code{character} string that denotes whether the
signature was developed using samples of either whole blood/paxgene
("whole blood") or peripheral blood mononuclear cells ("PBMC").
Due to the manipulation of cells inherently required to obtain PBMCs,
many scientists prefer to use only whole blood samples for analysis.
Accepts "whole blood", "PBMC" or "mixed". Required.}

\item{saveobjs}{\code{logical}. If \code{TRUE}, the contents of the data
file (\code{TBsignatures}, \code{TBcommon}, \code{sigAnnotData},
\code{common_sigAnnotData}) will be overwritten and updated to include
the new signature. If \code{FALSE}, no files will be overwritten, but
you can check function output for errors before writing RDS objects
by setting \code{views = TRUE}. Default is \code{saveobjs = FALSE}.}

\item{views}{logical. If \code{TRUE}, all objects will be sent to a
data view in a new window to check for errors. Default is \code{TRUE}.}
}
\value{
Either data objects \code{TBsignatures}, \code{TBcommon},
\code{sigAnnotData}, and \code{common_sigAnnotData} will be updated with the
new signature and overwritten if \code{saveobjs = FALSE}, or no output will
be produced except errors and messages for checking that the function
runs correctly given the inputs.
}
\description{
This function allows users to integrate new signatures into the TBSP
with a function that updates the TBsignatures, TBcommon,
sigAnnotData and common_sigAnnotData objects. Users that wish to use this
function should do so with the downloaded package as a working directory,
and not as a casual package function. This function does not complete all
required updates to the package for a signature to be full added; users
should check the vignette "Submitting Signatures to the TBSP Package"
on the
\href{https://wejlab.github.io/TBSignatureProfiler-docs/.}{TBSP website}
for a walkthrough of this complete process.
Also note that this function only adds one signature at a time,
and must me run multiple times to add subsequent signatures.
}
\examples{
# Mock example signature
TBSignatureProfiler:::addTBsignature(sigsymbols = c("GBP5", "BATF2", "GZMA"),
                            authname = "Odom",
                            signame_common = NULL,
                            sigtype = "Disease/HIV",
                            tissuetype = "PBMC",
                            saveobjs = FALSE,
                            views = FALSE)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{TB_hiv}
\alias{TB_hiv}
\title{An example TB dataset with TB/HIV data.}
\format{
SummarizedExperiment
}
\usage{
TB_hiv
}
\description{
An example dataset containing the gene expression and metadata in a
SummarizedExperiment object for 31 subjects with HIV and/or Tuberculosis
diseases. Information on subject infection status can be accessed with
\code{TB_hiv$Disease}. Samples with both TB and HIV contamination are
marked as \code{tb_hiv}, while samples with HIV and no TB are marked
as \code{hiv_only}.
}
\details{
This dataset was published as part of a study to assess whether gene expression
signatures and cytokine levels would distinguish active TB in advanced HIV
in a cohort residing in Sub-Saharan Africa (Verma et. al 2018).
Participants were severely immunosuppressed TB-HIV patients who had
not yet received TB treatment or anti-retroviral therapy (ART). The dataset included
in this package has been lightly edited from the originally published dataset
due to the removal of one participant who was HIV positive, on ART and developed
TB during follow-up. Whole blood RNA-Seq analysis was performed on all
31 participants.
}
\examples{
data("TB_hiv")
}
\references{
Verma S., Du P., et. al. (2018). Tuberculosis in advanced HIV infection is
associated with increased expression of IFN and its downstream targets.
\emph{BMC Infectious Diseases} \strong{18:220}.
doi: \url{https://doi.org/10.1186/s12879-018-3127-410.1186/s12879-018-3127-4}.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/OriginalModel.R
\name{svm_OriginalModel}
\alias{svm_OriginalModel}
\title{Train original model for gene signatures Bloom_OD_144 and Zak_RISK_16.}
\usage{
svm_OriginalModel(dat_list, dat_test_sig)
}
\arguments{
\item{dat_list}{A \code{list} contains training data and disease status
outcomes from the discovery data of corresponding gene signatures.}

\item{dat_test_sig}{A \code{data frame} contains corresponding gene sets
from the \code{input}.}
}
\value{
The predicted score for each sample in the test study.
}
\description{
Train original model for gene signatures Bloom_OD_144 and Zak_RISK_16.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/OriginalModel.R
\name{subsetGeneSet}
\alias{subsetGeneSet}
\title{Filter gene expression value matrix based on certain gene sets.}
\usage{
subsetGeneSet(
  theObject,
  gene_set,
  useAssay,
  obtainDiagnosis = FALSE,
  annotationColName = NULL
)
}
\arguments{
\item{theObject}{A SummarizedExperiment object that has been pre-stored in
OriginalTrainingData.RDA}

\item{gene_set}{A character vector that includes gene symbols for gene signatures.}

\item{useAssay}{A character string or an integer specifying the assay in the \code{theObject}
that will be selected.}

\item{obtainDiagnosis}{Boolean. Usually used to create training data if TRUE. Default is FALSE}

\item{annotationColName}{A character string specifying the column name of disease status.
Only used when creating training data. Default is NULL.}
}
\value{
A \code{matrix} with selected gene expression value if \code{obtainDiagnosis == FALSE}.
If \code{obtainDiagnosis == TRUE}, return a \code{list} contains the selected
gene expression value and diagnosis results for each sample.
}
\description{
A function used to subset gene expression value matrix based on certain gene sets.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/OriginalModel.R
\name{evaluateOriginalModel}
\alias{evaluateOriginalModel}
\title{A function that implements the original methods for multiple TB signatures.}
\usage{
evaluateOriginalModel(
  input,
  geneSignaturesName,
  useAssay = 1,
  adj = 0.001,
  BPPARAM = BiocParallel::SerialParam(progressbar = TRUE)
)
}
\arguments{
\item{input}{A SummarizedExperiment object with gene symbols as the assay row
names.}

\item{geneSignaturesName}{A character string/vector specifying the signature
of interest. If \code{any(geneSignaturesName == "") == TRUE}, it will run all
available gene signatures' original models.}

\item{useAssay}{A character string or an integer specifying the assay in the
\code{input}. Default is the first assay in the assay list.
Used for the test SummarizedExperiment object. Default is \code{1}, indicating the
first assay in the \code{input}.}

\item{adj}{A small positive real number used in \code{\link[sva]{ComBat}} to solve
for genes with 0 counts(rare cases). Default is \code{1e-3}.}

\item{BPPARAM}{An instance inherited from \code{\link[BiocParallel]{bplapply}}.}
}
\value{
A SummarizedExperiment object with predicted scores for each sample
obtained from the signature's original model.
}
\description{
This function computes prediction for multiple TB signatures based on their training
models/methods. To avoid naming issues, the gene names for both training data and
input gene sets have been updated using the \code{\link[HGNChelper]{checkGeneSymbols}}.
TB signatures with available original models are: Anderson_42,
Anderson_OD_51, Kaforou_27, Kaforou_OD_44, Kaforou_OD_53, Sweeney_OD_3,
Maertzdorf_4, Verhagen_10, Jacobsen_3, Sambarey_HIV_10, Leong_24,
Berry_OD_86, Berry_393, Bloom_OD_144, Suliman_RISK_4, Zak_RISK_16,
Leong_RISK_29, and Zhao_NANO_6.
The predicted score for each signature has been stored in the column data
section of the input SummarizedExperiment study.
}
\examples{
re <- evaluateOriginalModel(input = TB_indian,
                            geneSignaturesName = c("Anderson_42"),
                            useAssay = "counts")
re$Anderson_42_OriginalModel

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/profile.R
\name{runTBsigProfiler}
\alias{runTBsigProfiler}
\title{Run TB gene signature profiling.}
\source{
Profiling for the Z-Score, PLAGE, GSVA, ssGSEA algorithms are all
conducted with the Bioconductor \code{GSVA} package. Profiling for the
singscore algorithm is conducted with the Bioconductor \code{singscore}
package.
}
\usage{
runTBsigProfiler(
  input,
  useAssay = NULL,
  signatures = NULL,
  algorithm = c("GSVA", "ssGSEA", "ASSIGN", "PLAGE", "Zscore", "singscore"),
  combineSigAndAlgorithm = FALSE,
  assignDir = NULL,
  outputFormat = NULL,
  parallel.sz = 0,
  ASSIGNiter = 1e+05,
  ASSIGNburnin = 50000,
  ssgsea_norm = TRUE,
  update_genes = TRUE
)
}
\arguments{
\item{input}{an input data object of the class \code{SummarizedExperiment},
\code{data.frame}, or \code{matrix} containing gene expression data. Required.}

\item{useAssay}{a character string specifying the assay to use for signature
profiling when \code{input} is a \code{SummarizedExperiment}. Required only for
input data of the class \code{SummarizedExperiment}. If null, the assay
used will be \code{"counts"}. The default is \code{NULL.}}

\item{signatures}{a \code{list} of signatures to run with their associated genes.
This list should be in the same format as \code{TBsignatures}, included in
the TBSignatureProfiler package. If \code{signatures = NULL}, the default set
of signatures \code{TBsignatures} list is used.
For details, run \code{?TBsignatures}.
If <2 genes in a signature are present in the sample, that signature will
not be evaluated and will not be present in the resulting SE object.
The default is \code{NULL}.}

\item{algorithm}{a vector of algorithms to run, or character string if only
one is desired. The default is \code{c("GSVA", "ssGSEA", "ASSIGN",
"PLAGE", "Zscore", "singscore")}. NOTE: ASSIGN takes a long time to run and
is not recommended for efficient use.}

\item{combineSigAndAlgorithm}{logical, if \code{TRUE}, output row names will
be of the form \if{html}{\out{<algorithm>}}_\if{html}{\out{<signature>}}. It must be set to \code{TRUE} if the
\code{ouputFormat} will be a SummarizedExperiment and
\code{length(algorithm) > 1}.
It will always be \code{FALSE} if only one algorithm is selected.
If \code{FALSE}, there will be a column named algorithm' that lists which
algorithm is used, and a column named 'pathway' that lists the signature
profiled. If \code{NULL}, and one algorithm was used, the algorithm will not
be listed. The default is \code{FALSE}.}

\item{assignDir}{a character string naming a directory to save intermediate
ASSIGN results if \code{algorithm} specifies \code{"ASSIGN"}. The default is
\code{NULL}, in which case intermediate results will not be saved.}

\item{outputFormat}{a character string specifying the output data format.
Possible values are \code{"SummarizedExperiment"}, \code{"matrix"}, or
\code{"data.frame"}. The default is to return the same type as the
\code{input} object.}

\item{parallel.sz}{an integer identifying the number of processors to use
when running the calculations in parallel for the GSVA and ssGSEA algorithms.
If \code{parallel.sz = 0}, all cores are used. The default is \code{0}.}

\item{ASSIGNiter}{an integer indicating the number of iterations to use in
the MCMC for the ASSIGN algorithm. The default is \code{100,000}.}

\item{ASSIGNburnin}{an integer indicating the number of burn-in iterations
to use in the MCMC for the ASSIGN algorithm. These iterations are discarded
when computing the posterior means of the model parameters. The default is
\code{50,000}.}

\item{ssgsea_norm}{logical, passed to \code{GSVA::gsva()}. When parameter
\code{algorithm = "ssgsea"},the profiler runs the SSGSEA method from
Barbie et al. (2009) normalizing the scores by the absolute difference
between the minimum and the maximum, as described in their paper.
When \code{ssgsea.norm = FALSE}, this last normalization step is skipped.
The default is \code{TRUE}.}

\item{update_genes}{logical, denotes whether gene names from \code{signatures}
and the rownames of \code{input} should be checked for accuracy using
\code{HGNChelper::checkGeneSymbols()}. The mapping assumes
genes are from humans and will keep unmapped genes as the original
input gene name. Default is \code{TRUE}.}
}
\value{
A \code{SummarizedExperiment} object, \code{data.frame}, or
\code{matrix} of signature profiling results. The returned object will be
of the format specified in \code{outputFormat}.
If \code{input} is a \code{SummarizedExperiment} and
\code{outputFormat = "SummarizedExperiment"}, then the output will retain
any input information stored in the input colData. In general, if
\code{outputFormat = "SummarizedExperiment"} then columns in the \code{colData}
will include the scores for each desired signature with samples on the rows.
If \code{input} is a \code{data.frame} or \code{matrix}, then the returned
object will have signatures on the rows and samples on the columns.
}
\description{
Using some subset of the signatures listed in \code{TBsignatures} and
specified scoring algorithms, this function runs gene signature profiling
on an input gene expression dataset. It allows for scores to be computed for
these signatures which can be compared using various visualization tools also
provided in the TBSignatureProfiler package.
}
\examples{
## Using a data.frame input/output
 # Create some toy data to test Zak_RISK_16 signature, using 5 samples with low
 # expression & five samples with high expression of the signatures genes.
df_testdata <- as.data.frame(rbind(matrix(c(rnorm(80), rnorm(80) + 5), 16, 10,
                             dimnames = list(TBsignatures$Zak_RISK_16,
                             paste0("sample", seq_len(10)))),
                      matrix(rnorm(1000), 100, 10,
                             dimnames = list(paste0("gene", seq_len(100)),
                             paste0("sample", seq_len(10))))))
res <- runTBsigProfiler(input = df_testdata,
                        signatures = TBsignatures["Zak_RISK_16"],
                        algorithm = c("GSVA", "ssGSEA"),
                        combineSigAndAlgorithm = FALSE,
                        parallel.sz = 1)
subset(res, res$pathway == "Zak_RISK_16")

## Using a SummarizedExperiment input/output
 # The TB_indian SummarizedExperiment data is included in the package.
GSVA_res <- runTBsigProfiler(input = TB_indian,
                             useAssay = "logcounts",
                             signatures = TBsignatures["Zak_RISK_16"],
                             algorithm = c("GSVA"),
                             combineSigAndAlgorithm = FALSE,
                             parallel.sz = 1)
GSVA_res$Zak_RISK_16
}
\references{
Barbie, D.A., Tamayo, P., Boehm, J.S., Kim, S.Y., Moody, S.E., Dunn, I.F., Schinzel, A.C.,
Sandy, P., Meylan, E., Scholl, C., et al. (2009). Systematic RNA interference reveals
that oncogenic KRAS-driven cancers require TBK1. \emph{Nature} \strong{462}, 108-112.
doi: \href{https://doi.org/10.1038/nature08460}{10.1038/nature08460}.

Foroutan, M. et al. (2018). Single sample scoring of molecular phenotypes.
\emph{BMC Bioinformatics}, \bold{19}. doi:
\href{https://doi.org/10.1186/s12859-018-2435-4}{10.1186/s12859-018-2435-4}.

Lee, E. et al. (2008). Inferring pathway activity toward precise disease
classification. \emph{PLoS Comp Biol}, 4(11):e1000217. doi:
\href{https://doi.org/10.1371/journal.pcbi.1000217}{10.1371/journal.pcbi.1000217}

Shen, Y. et al. (2015). ASSIGN: context-specific genomic profiling of
multiple heterogeneous biological pathways. \emph{Bioinformatics}, \bold{31},
1745-1753. doi:
\href{https://doi.org/10.1093/bioinformatics/btv031}{10.1093/bioinformatics/btv031}.

Subramanian, A. et al. (2005). Gene set enrichment analysis: A knowledge-based
approach for interpreting genome-wide expression profiles. \emph{PNAS},
\strong{102}, 15545-15550. doi:
\href{https://doi.org/10.1073/pnas.0506580102}{10.1073/pnas.0506580102}.

Tomfohr, J. et al. (2005). Pathway level analysis of gene expression using
singular value decomposition. \emph{BMC Bioinformatics}, 6:225. doi:
\href{https://doi.org/10.1186/1471-2105-6-225}{10.1186/1471-2105-6-225}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bootstrap.R
\name{tableAUC}
\alias{tableAUC}
\title{Create a table of results for t-tests and bootstrapped AUCs for multiple scored signatures.}
\usage{
tableAUC(
  SE_scored,
  annotationColName,
  signatureColNames,
  num.boot = 100,
  pb.show = TRUE,
  output = "DataTable"
)
}
\arguments{
\item{SE_scored}{a \code{SummarizedExperiment} object with genes as the
row features and signature scores in the \code{colData}. There should also
be a column of annotation data. Required.}

\item{annotationColName}{a character string giving the column name in
\code{colData} that contains the annotation data. Required.}

\item{signatureColNames}{a vector of column names in the
\code{colData} that contain the signature score data. Required.}

\item{num.boot}{integer. The number of times to bootstrap the data. The
default is \code{100}.}

\item{pb.show}{logical for whether to show a progress bar while running code.
The default is \code{TRUE}.}

\item{output}{a character string indicating the table output format. Possible
values are \code{DataTable} and \code{data.frame}. The default is
\code{DataTable}.}
}
\value{
A JavaScript table with an R interface using the \code{DT} package.
}
\description{
This function collects the results of bootstrapping and t-tests for a scored
gene expression dataset and presents them using a JavaScript table with an
R interface, or as a \code{data.frame}.
}
\examples{
# Run signature profiling
 choose_sigs <- TBsignatures[c(1, 2)]
 prof_indian <- runTBsigProfiler(TB_indian, useAssay = "logcounts",
                                 algorithm = "ssGSEA",
                                 signatures = choose_sigs,
                                 parallel.sz = 1,
                                 update_genes = FALSE)
 # Create table
 tableAUC(SE_scored = prof_indian, annotationColName = "label",
          signatureColNames = names(choose_sigs))

 # Create data.frame object
h <-  tableAUC(SE_scored = prof_indian, annotationColName = "label",
               signatureColNames = names(choose_sigs),
               output = "data.frame",
               num.boot = 5)
head(h)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{common_sigAnnotData}
\alias{common_sigAnnotData}
\title{Annotation information for published TB signatures.}
\format{
data.frame
}
\source{
See \code{?TBcommon} for reference information.
}
\usage{
common_sigAnnotData
}
\description{
A \code{data.frame} of annotation information for published tuberculosis
signatures. This table differs from that of \code{sigAnnotData} as it
refers to signatures via the name given in scientific publications, and
via a consistent naming system otherwise.
Currently, this table includes two variables, \code{disease} and
\code{tissue type}.
}
\details{
The \code{disease} variable indicates whether the signature was developed
to distinguish TB from LTBI ("Disease"), TB from some combination of other
diseases and possibly LTBI ("OD"), TB from Human Immunodeficiency Virus ("HIV"),
TB from pneumonia ("PNA"), or identify risk of progression to TB ("RISK"),
risk of TB treatment failure ("FAIL"), or classify treatment responses
(i.e., failures from cures, "RES").

The \code{tissue type} variable denotes whether the signature was developed
using samples of either whole blood/paxgene or peripheral blood mononuclear
cells (PBMCs). Due to the manipulation of cells inherently required to obtain
PBMCs, many scientists prefer to use only whole blood samples for analysis.
}
\examples{
data("common_sigAnnotData")
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/evaluate.R
\name{LOOAUC_simple_multiple_noplot_one_df}
\alias{LOOAUC_simple_multiple_noplot_one_df}
\title{Perform Leave-one-out CV with Logistic Regression.}
\usage{
LOOAUC_simple_multiple_noplot_one_df(df, targetVec)
}
\arguments{
\item{df}{a \code{data.frame} of gene expression count data. Required.}

\item{targetVec}{a binary vector of the response variable. Should be
the same number of samples as in \code{df}. Required.}
}
\value{
A list of length 3 with elements
\item{auc}{The AUC from the LOOCV procedure.}
\item{byClass}{A vector containing the sensitivity, specificity, positive
predictive value, negative predictive value, precision, recall, F1,
prevalence, detection rate, detection prevalence and balanced accuracy.}
\item{prob}{A vector of the test prediction probabilities.}
}
\description{
Perform Leave-one-out CV with Logistic Regression.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/OriginalModel.R
\name{ObtainSampleScore_OriginalModel}
\alias{ObtainSampleScore_OriginalModel}
\title{Obtain training data, testing data, and train signature's original model.}
\usage{
ObtainSampleScore_OriginalModel(
  theObject_train,
  useAssay,
  gene_set,
  input,
  SigName,
  obtainDiagnosis,
  annotationColName,
  FUN,
  adj
)
}
\arguments{
\item{theObject_train}{A SummarizedExperiment object that has been pre-stored in the
data file: OriginalTrainingData.}

\item{useAssay}{A character string or an integer specifying the assay in the \code{input}.
Used for the test SummarizedExperiment object. Default is 1, indicating the first assay
in the test SummarizedExperiment object.}

\item{gene_set}{A character vector that includes gene symbols for selected gene signature.}

\item{input}{A SummarizedExperiment object with gene symbols as the assay row names.}

\item{SigName}{Optional. A character string that indicates the name for \code{gene_set}.
\code{SigName} is used to provide information when gene signatures were missing
in the test data.}

\item{obtainDiagnosis}{Boolean. Used to create training data if TRUE. Default is FALSE}

\item{annotationColName}{A character string specifying the column name of disease status.
Only used when creating training data. Default is NULL.}

\item{FUN}{A character string specifying the function name of the corresponding signature's original model.}

\item{adj}{A small real number used in combat to solve for genes with 0 counts in rare cases.
Not required for most of cases.}
}
\value{
The predicted score for each sample in the test study using corresponding gene signature's original model.
}
\description{
Obtain training data, testing data, and train signature's original model.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/evaluate.R
\name{SignatureQuantitative}
\alias{SignatureQuantitative}
\title{Use logistic regression and bootstrap LOOCV to evaluate signatures.}
\usage{
SignatureQuantitative(
  df.input,
  targetVec.num,
  signature.list = NULL,
  signature.name.vec = NULL,
  num.boot = 100,
  pb.show = TRUE
)
}
\arguments{
\item{df.input}{a \code{data.frame} of gene expression count data. Required.}

\item{targetVec.num}{a numeric binary vector of the response variable.
The vector should be the same number of rows as \code{df}. Required.}

\item{signature.list}{a \code{list} of signatures to run with their
associated genes. This list should be in the same format as \code{TBsignatures},
included in the TBSignatureProfiler package. If \code{signature.list = NULL},
the default set of signatures \code{TBsignatures} list is used. For details,
run \code{?TBsignatures}.}

\item{signature.name.vec}{A vector specifying the names of the signatures
to be compared. This should be the same length as \code{signature.list}.
If \code{signature.name.vec = NULL}, the default set of signatures
\code{TBsignatures} list is used.}

\item{num.boot}{an integer specifying the number of bootstrap iterations.}

\item{pb.show}{logical. If \code{TRUE} then a progress bar for the
bootstrapping procedure will be displayed as output. The default is
\code{TRUE}.}

\item{name}{a character string giving a name for the outputted boxplot of
bootstrapped AUCs. The default is \code{"Quantitative Evaluation of
Signatures via Bootstrapped AUCs"}.}
}
\value{
the AUC, sensitivity and specificity
}
\description{
This function takes as input a \code{data.frame} with genetic expression
count data, and uses a bootstrapped leave-one-out cross validation procedure
with logistic regression to allow for numeric and graphical comparison
across any number of genetic signatures.
}
\examples{
inputTest <- matrix(rnorm(1000), 100, 20,
                    dimnames = list(paste0("gene", seq.int(1, 100)),
                                    paste0("sample", seq.int(1, 20))))
inputTest <- as.data.frame(inputTest)
targetVec <- sample(c(0,1), replace = TRUE, size = 20)
signature.list <- list(sig1 = c("gene1", "gene2", "gene3"),
                       sig2 = c("gene4", "gene5", "gene6"))
signature.name.vec <- c("sig1", "sig2")
num.boot <- 2
SignatureQuantitative(inputTest, targetVec.num = targetVec,
                      signature.list = signature.list,
                      signature.name.vec = signature.name.vec,
                      num.boot = num.boot)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{TBsignaturesSplit}
\alias{TBsignaturesSplit}
\title{Up/Down-regulated genes information for selected TB signatures.}
\format{
list
}
\source{
See \code{?TBsignatures} for reference information.
}
\usage{
TBsignaturesSplit
}
\description{
Up/Down-regulated genes information for selected TB signatures.
}
\examples{
data("TBsignaturesSplit")
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{TB_indian}
\alias{TB_indian}
\title{An example TB dataset with Indian population data.}
\format{
SummarizedExperiment
}
\usage{
TB_indian
}
\description{
An example dataset containing the gene expression and metadata in a
SummarizedExperiment object for an Indian population. Active TB contamination
of the 44 subjects is denoted for each as a "1"(active) or "0"
(latent/not present), and can be accessed via \code{TB_indian$label}. The
SummarizedExperiment object contains 2 assays (counts and log(counts)),
and the column names give the unique subject identification number along
with the subject's gender.
}
\details{
This dataset was published as part of a study to assess performance of
published TB signatures in a South Indian population (Leong et. al 2018).
RNA sequencing was performed on whole blood PAX gene samples collected
from 28 TB patients and 16 latent TB infected (LTBI) subjects enrolled
as part of an ongoing household contact study. Whole blood RNA-Seq analysis
was performed on all 44 participants.
}
\examples{
data("TB_indian")
}
\references{
Leong S., Zhao Y., et. al. (2018). Existing blood transcriptional classifiers
accurately discriminate active tuberculosis from latent infection in
individuals from south India. \emph{Tuberculosis} \strong{109}, 41-51.
doi: \url{https://doi.org/10.1016/j.tube.2018.01.00210.1016/j.tube.2018.01.002}.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bootstrap.R
\name{compareBoxplots}
\alias{compareBoxplots}
\title{Create a comparison plot of boxplots for bootstrapped AUC values.}
\usage{
compareBoxplots(
  SE_scored,
  annotationColName,
  signatureColNames,
  num.boot = 100,
  name = "Boxplot Comparison of Signature AUCs",
  pb.show = TRUE,
  abline.col = "red",
  fill.col = "gray79",
  outline.col = "black",
  rotateLabels = FALSE,
  violinPlot = FALSE
)
}
\arguments{
\item{SE_scored}{a \code{SummarizedExperiment} object with genes as the
row features and signature scores in the \code{colData}. There should also
be a column of annotation data. Required.}

\item{annotationColName}{a character string giving the column name in
\code{colData} that contains the annotation data. Required.}

\item{signatureColNames}{a vector of column names in the
\code{colData} that contain the signature score data. Required.}

\item{num.boot}{an integer indicating the number of times to bootstrap the
data.}

\item{name}{a character string giving the overall title for the plot.
The default is \code{"Boxplot Comparison of Signature AUCs"}.}

\item{pb.show}{logical for whether to show a progress bar while running code.
Default is \code{TRUE}.}

\item{abline.col}{the color to be used for the dotted line at AUC = 0.5
(the chance line). The default is \code{"red"}.}

\item{fill.col}{the color to be used to fill the boxplots.
The default is \code{"white"}.}

\item{outline.col}{the color to be used for the boxplot outlines.
The default is \code{"black"}.}

\item{rotateLabels}{If \code{TRUE}, rotate labels. Default is \code{FALSE}.}

\item{violinPlot}{logical. Setting \code{violinPlot = TRUE} creates violin
plots in place of boxplots. The mean and +/- 1 standard deviation are added
to the violin plot interior for each signature.
The default is \code{FALSE}.}
}
\value{
A plot with side-by-side boxplots of bootstrapped AUC values for
each specified signature.
}
\description{
Present the results of AUC bootstrapping for a collection of scored
signatures via boxplots.
}
\examples{
# Run signature profiling
 choose_sigs <- TBsignatures[c("Zak_RISK_16", "Zhao_NANO_6")]
 prof_indian <- runTBsigProfiler(TB_indian[seq_len(25), ],
                                 useAssay = "logcounts",
                                 algorithm = "ssGSEA",
                                 signatures = choose_sigs,
                                 parallel.sz = 1)
 # Create boxplots
 compareBoxplots(prof_indian, annotationColName = "label",
                 signatureColNames = names(choose_sigs), rotateLabels = TRUE)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/evaluate.R
\name{deseq2_norm_rle}
\alias{deseq2_norm_rle}
\title{Normalize gene expression count data.}
\usage{
deseq2_norm_rle(inputData)
}
\arguments{
\item{inputData}{a \code{data.frame} or \code{matrix} of gene expression
count data. Required.}
}
\value{
A \code{data.frame} or \code{matrix} of normalized count data.
}
\description{
Normalize gene expression count data.
}
\examples{
## Example using the counts assay from a SummarizedExperiment
data_in <- SummarizedExperiment::assay(TB_indian, "counts")
res <- deseq2_norm_rle(data_in)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bootstrap.R
\name{bootstrapAUC}
\alias{bootstrapAUC}
\title{Bootstrap the AUC and conduct T-Tests for a collection of signatures.}
\usage{
bootstrapAUC(
  SE_scored,
  annotationColName,
  signatureColNames,
  num.boot = 100,
  pb.show = TRUE
)
}
\arguments{
\item{SE_scored}{a \code{SummarizedExperiment} object with genes as the
row features and signature scores in the \code{colData}. There should also
be a column of annotation data. Required.}

\item{annotationColName}{a character string giving the column name in
\code{colData} that contains the annotation data. Required.}

\item{signatureColNames}{a vector of column names in the
\code{colData} that contain the signature score data. Required.}

\item{num.boot}{integer. The number of times to bootstrap the data. The
default is \code{100}.}

\item{pb.show}{logical for whether to show a progress bar while running code.
The default is \code{TRUE}.}
}
\value{
A list of length 5 returning a vector of p-values for a 2-sample
t-test, bootstrapped AUC values, an AUC value for using all scored values
for all signatures specified in \code{signatureColNames},
and values for the lower and upper bounds of a bootstrapped AUC confidence
interval using \code{pROC::roc()}.
}
\description{
Run bootstrapping of the AUC and derive the p-value for a 2-sample t-test
for all signatures tested on a given dataset.
}
\examples{
 # Run signature profiling
 choose_sigs <- list("madeupsig" = c("FCRL3", "OAS2", "IFITM3"))
 prof_indian <- runTBsigProfiler(TB_indian, useAssay = "logcounts",
                                 algorithm = "ssGSEA",
                                 combineSigAndAlgorithm = TRUE,
                                 signatures = choose_sigs,
                                 parallel.sz = 1)
 # Bootstrapping
 booted <- bootstrapAUC(SE_scored = prof_indian, annotationColName = "label",
                        signatureColNames = names(choose_sigs), num.boot = 2)
 booted

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/evaluate.R
\name{Bootstrap_LOOCV_LR_AUC}
\alias{Bootstrap_LOOCV_LR_AUC}
\title{Bootstrap on Leave-one-out CV with Logistic Regression.}
\usage{
Bootstrap_LOOCV_LR_AUC(df, targetVec, nboot)
}
\arguments{
\item{df}{a \code{data.frame} of gene expression count data. Required.}

\item{targetVec}{a binary vector of the response variable. Should be
the same number of rows as \code{df}. Required.}

\item{nboot}{an integer specifying the number of bootstrap iterations.}
}
\value{
A list of length 2 with elements \item{auc}{A vector the length of
\code{nboot} with the AUC from each bootstrap iteration.}
\item{byClass}{A dataframe with number of rows equal to \code{nboot}. Each
row contains the sensitivity, specificity, positive predictive
value, negative predictive value, precision, recall, F1, prevalence,
detection rate, detection prevalence and balanced accuracy for that
bootstrap iteration.}
}
\description{
Bootstrap on Leave-one-out CV with Logistic Regression.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{COVIDsignatures}
\alias{COVIDsignatures}
\title{A list of published/pre-print COVID-19 signatures.}
\format{
list
}
\source{
\itemize{
\item \strong{Wilk_sc_PBMC_monocytes_up}: Wilk, A.J., Rustagi, A., Zhao, N.Q. et al. 2020. "A single-cell atlas of the peripheral immune response in patients with severe COVID-19." Nature Medicine 26 (7): 1070-1076. \url{https://doi.org/10.1038/s41591-020-0944-y}
\item \strong{Wilk_sc_PBMC_monocytes_up}: Wilk, A.J., Rustagi, A., Zhao, N.Q. et al. 2020. "A single-cell atlas of the peripheral immune response in patients with severe COVID-19." Nature Medicine 26 (7): 1070-1076. \url{https://doi.org/10.1038/s41591-020-0944-y}
\item \strong{Wilk_sc_PBMC_monocytes_down}: Wilk, A.J., Rustagi, A., Zhao, N.Q. et al. 2020. "A single-cell atlas of the peripheral immune response in patients with severe COVID-19." Nature Medicine 26 (7): 1070-1076. \url{https://doi.org/10.1038/s41591-020-0944-y}
\item \strong{Wilk_sc_PBMC_NK_cells_up}: Wilk, A.J., Rustagi, A., Zhao, N.Q. et al. 2020. "A single-cell atlas of the peripheral immune response in patients with severe COVID-19." Nature Medicine 26 (7): 1070-1076. \url{https://doi.org/10.1038/s41591-020-0944-y}
\item \strong{Wilk_sc_PBMC_NK_cells_down}: Wilk, A.J., Rustagi, A., Zhao, N.Q. et al. 2020. "A single-cell atlas of the peripheral immune response in patients with severe COVID-19." Nature Medicine 26 (7): 1070-1076. \url{https://doi.org/10.1038/s41591-020-0944-y}
\item \strong{Wilk_sc_PBMCs_ISG_signature}: Wilk, A.J., Rustagi, A., Zhao, N.Q. et al. 2020. "A single-cell atlas of the peripheral immune response in patients with severe COVID-19." Nature Medicine 26 (7): 1070-1076. \url{https://doi.org/10.1038/s41591-020-0944-y}
\item \strong{Wilk_sc_PBMC_activated_granulocytes}: Wilk, A.J., Rustagi, A., Zhao, N.Q. et al. 2020. "A single-cell atlas of the peripheral immune response in patients with severe COVID-19." Nature Medicine 26 (7): 1070-1076. \url{https://doi.org/10.1038/s41591-020-0944-y}
\item \strong{Huang_sc_PBMC_IFN_signature}: Wilk, A.J., Rustagi, A., Zhao, N.Q. et al. 2020. "Blood single cell immune profiling reveals the interferon-MAPK pathway mediated adaptive immune response for COVID-19." medRxiv.org: {https://doi.org/10.1101/2020.03.15.20033472}
\item \strong{Wen_sc_PBMC_monocytes}: Wen, W., Su, W., Tang, H. et al. 2020. "Immune cell profiling of COVID-19 patients in the recovery stage by single-cell sequencing." Cell Discovery 6 (31). \url{https://doi.org/10.1038/s41421-020-0168-9}
\item \strong{Wen_sc_PBMC_NK_cells}: Wen, W., Su, W., Tang, H. et al. 2020. "Immune cell profiling of COVID-19 patients in the recovery stage by single-cell sequencing." Cell Discovery 6 (31). \url{https://doi.org/10.1038/s41421-020-0168-9}
\item \strong{Wen_sc_PBMC_CD4_T_cells}: Wen, W., Su, W., Tang, H. et al. 2020. "Immune cell profiling of COVID-19 patients in the recovery stage by single-cell sequencing." Cell Discovery 6 (31). \url{https://doi.org/10.1038/s41421-020-0168-9}
\item \strong{Wen_sc_PBMC_CD8_T_cells}: Wen, W., Su, W., Tang, H. et al. 2020. "Immune cell profiling of COVID-19 patients in the recovery stage by single-cell sequencing." Cell Discovery 6 (31). \url{https://doi.org/10.1038/s41421-020-0168-9}
\item \strong{Wen_sc_PBMC_B_cells}: Wen, W., Su, W., Tang, H. et al. 2020. "Immune cell profiling of COVID-19 patients in the recovery stage by single-cell sequencing." Cell Discovery 6 (31). \url{https://doi.org/10.1038/s41421-020-0168-9}
\item \strong{Xiong_bulk_PBMC_gene_signature_up}: Xiong Y, Liu Y, Cao L, et al. 2020. "Transcriptomic characteristics of bronchoalveolar lavage fluid and peripheral blood mononuclear cells in COVID-19 patients." Emerging Microbes & Infections 9 (1):761-770. \url{https://doi/org/10.1080/22221751.2020.1747363}
\item \strong{Xiong_bulk_PBMC_gene_signature_down}: Xiong Y, Liu Y, Cao L, et al. 2020. "Transcriptomic characteristics of bronchoalveolar lavage fluid and peripheral blood mononuclear cells in COVID-19 patients." Emerging Microbes & Infections 9 (1):761-770. \url{https://doi/org/10.1080/22221751.2020.1747363}
\item \strong{Xiong_sc_PBMC_cytokines_up}: Xiong Y, Liu Y, Cao L, et al. 2020. "Transcriptomic characteristics of bronchoalveolar lavage fluid and peripheral blood mononuclear cells in COVID-19 patients." Emerging Microbes & Infections 9 (1):761-770. \url{https://doi/org/10.1080/22221751.2020.1747363}
\item \strong{Xiong_sc_PBMC_cytokines_down}: Xiong Y, Liu Y, Cao L, et al. 2020. "Transcriptomic characteristics of bronchoalveolar lavage fluid and peripheral blood mononuclear cells in COVID-19 patients." Emerging Microbes & Infections 9 (1):761-770. \url{https://doi/org/10.1080/22221751.2020.1747363}
\item \strong{Liao_sc_BALF_G1_macrophages}: Liao, M., Liu, Y., Yuan, J. et al. 2020. "Single-cell landscape of bronchoalveolar immune cells in patients with COVID-19." Nature Medicine 26 (6): 842-844. \url{https://doi.org/10.1038/s41591-020-0901-9}
\item \strong{Liao_sc_BALF_G1_2_macrophages}: Liao, M., Liu, Y., Yuan, J. et al. 2020. "Single-cell landscape of bronchoalveolar immune cells in patients with COVID-19." Nature Medicine 26 (6): 842-844. \url{https://doi.org/10.1038/s41591-020-0901-9}
\item \strong{Liao_sc_BALF_G2_macrophages}: Liao, M., Liu, Y., Yuan, J. et al. 2020. "Single-cell landscape of bronchoalveolar immune cells in patients with COVID-19." Nature Medicine 26 (6): 842-844. \url{https://doi.org/10.1038/s41591-020-0901-9}
\item \strong{Liao_sc_BALF_G3_macrophages}: Liao, M., Liu, Y., Yuan, J. et al. 2020. "Single-cell landscape of bronchoalveolar immune cells in patients with COVID-19." Nature Medicine 26 (6): 842-844. \url{https://doi.org/10.1038/s41591-020-0901-9}
\item \strong{Liao_sc_BALF_G4_macrophages}: Liao, M., Liu, Y., Yuan, J. et al. 2020. "Single-cell landscape of bronchoalveolar immune cells in patients with COVID-19." Nature Medicine 26 (6): 842-844. \url{https://doi.org/10.1038/s41591-020-0901-9}
\item \strong{Liao_sc_BALF_CD8_T_cells_up}: Liao, M., Liu, Y., Yuan, J. et al. 2020. "Single-cell landscape of bronchoalveolar immune cells in patients with COVID-19." Nature Medicine 26 (6): 842-844. \url{https://doi.org/10.1038/s41591-020-0901-9}
\item \strong{Liao_sc_BALF_CD8_T_cells_down}: Liao, M., Liu, Y., Yuan, J. et al. 2020. "Single-cell landscape of bronchoalveolar immune cells in patients with COVID-19." Nature Medicine 26 (6): 842-844. \url{https://doi.org/10.1038/s41591-020-0901-9}
\item \strong{Hadjadj_nanostring_WB_gene_signature_up}: Hadjadj J, Yatim N, Barnabei L, et al. 2020. "Impaired type I interferon activity and inflammatory responses in severe COVID-19 patients." Science 369 (6504): 718-724. \url{https://doi.org/10.1126/science.abc6027}
\item \strong{Hadjadj_nanostring_WB_gene_signature_down}: Hadjadj J, Yatim N, Barnabei L, et al. 2020. "Impaired type I interferon activity and inflammatory responses in severe COVID-19 patients." Science 369 (6504): 718-724. \url{https://doi.org/10.1126/science.abc6027}
\item \strong{Hadjadj_nanostring_WB_ISG_signature}: Hadjadj J, Yatim N, Barnabei L, et al. 2020. "Impaired type I interferon activity and inflammatory responses in severe COVID-19 patients." Science 369 (6504): 718-724. \url{https://doi.org/10.1126/science.abc6027}
\item \strong{Hadjadj_nanostring_WB_mild_moderate_up}: Hadjadj J, Yatim N, Barnabei L, et al. 2020. "Impaired type I interferon activity and inflammatory responses in severe COVID-19 patients." Science 369 (6504): 718-724. \url{https://doi.org/10.1126/science.abc6027}
\item \strong{Hadjadj_nanostring_WB_mild_moderate_down}: Hadjadj J, Yatim N, Barnabei L, et al. 2020. "Impaired type I interferon activity and inflammatory responses in severe COVID-19 patients." Science 369 (6504): 718-724. \url{https://doi.org/10.1126/science.abc6027}
\item \strong{Hadjadj_nanostring_WB_severe_up}: Hadjadj J, Yatim N, Barnabei L, et al. 2020. "Impaired type I interferon activity and inflammatory responses in severe COVID-19 patients." Science 369 (6504): 718-724. \url{https://doi.org/10.1126/science.abc6027}
\item \strong{Hadjadj_nanostring_WB_severe_down}: Hadjadj J, Yatim N, Barnabei L, et al. 2020. "Impaired type I interferon activity and inflammatory responses in severe COVID-19 patients." Science 369 (6504): 718-724. \url{https://doi.org/10.1126/science.abc6027}
\item \strong{Hadjadj_nanostring_critical_up}: Hadjadj J, Yatim N, Barnabei L, et al. 2020. "Impaired type I interferon activity and inflammatory responses in severe COVID-19 patients." Science 369 (6504): 718-724. \url{https://doi.org/10.1126/science.abc6027}
\item \strong{Hadjadj_nanostring_critical_down}: Hadjadj J, Yatim N, Barnabei L, et al. 2020. "Impaired type I interferon activity and inflammatory responses in severe COVID-19 patients." Science 369 (6504): 718-724. \url{https://doi.org/10.1126/science.abc6027}
\item \strong{Wei_sc_PBMC_inactivated_monocytes}: Wei et al. 2020. "Viral Invasion and Type I Interferon Response Characterize the Immunophenotypes during COVID-19 Infection." SSRN: \url{https://dx.doi.org/10.2139/ssrn.3555695}
\item \strong{Wei_sc_PBMC_classical_monocytes}: Wei et al. 2020. "Viral Invasion and Type I Interferon Response Characterize the Immunophenotypes during COVID-19 Infection." SSRN: \url{https://dx.doi.org/10.2139/ssrn.3555695}
\item \strong{Wei_sc_PBMCs_T_cells}: Wei et al. 2020. "Viral Invasion and Type I Interferon Response Characterize the Immunophenotypes during COVID-19 Infection." SSRN: \url{https://dx.doi.org/10.2139/ssrn.3555695}
\item \strong{Wei_sc_PBMC_B_cells}: Wei et al. 2020. "Viral Invasion and Type I Interferon Response Characterize the Immunophenotypes during COVID-19 Infection." SSRN: \url{https://dx.doi.org/10.2139/ssrn.3555695}
\item \strong{Silvin_sc_WB_combined_signature}: Silvin A, Chapuis N, Dunsmore G, et al. 2020. "Elevated Calprotectin and Abnormal Myeloid Cell Subsets Discriminate Severe from Mild COVID-19." Cell 182 (6): 1401-1418.E18. \url{https://doi.org/10.1016/j.cell.2020.08.002}
\item \strong{Silvin_sc_WB_monocytes_up}: Silvin A, Chapuis N, Dunsmore G, et al. 2020. "Elevated Calprotectin and Abnormal Myeloid Cell Subsets Discriminate Severe from Mild COVID-19." Cell 182 (6): 1401-1418.E18. \url{https://doi.org/10.1016/j.cell.2020.08.002}
\item \strong{Silvin_sc_WB_monocytes_down}: Silvin A, Chapuis N, Dunsmore G, et al. 2020. "Elevated Calprotectin and Abnormal Myeloid Cell Subsets Discriminate Severe from Mild COVID-19." Cell 182 (6): 1401-1418.E18. \url{https://doi.org/10.1016/j.cell.2020.08.002}
\item \strong{Silvin_sc_WB_neutrophils_up}: Silvin A, Chapuis N, Dunsmore G, et al. "Elevated Calprotectin and Abnormal Myeloid Cell Subsets Discriminate Severe from Mild COVID-19." Cell 182 (6): 1401-1418.E18. \url{https://doi.org/10.1016/j.cell.2020.08.002}
\item \strong{Silvin_sc_WB_neutrophils_down}: Silvin A, Chapuis N, Dunsmore G, et al. "Elevated Calprotectin and Abnormal Myeloid Cell Subsets Discriminate Severe from Mild COVID-19." Cell 182 (6): 1401-1418.E18. \url{https://doi.org/10.1016/j.cell.2020.08.002}
\item \strong{Arunachalam_bulk_PBMC_blood_modules}: Arunachalam PS, Wimmers F, Mok CKP, et al. 2020. "Systems biological assessment of immunity to mild versus severe COVID-19 infection in humans." Science 369 (6508): 1210-1220. \url{https://doi.org/10.1126/science.abc6261}
\item \strong{Arunachalam_bulk_PBMC_covid_combined}: Arunachalam PS, Wimmers F, Mok CKP, et al. 2020. "Systems biological assessment of immunity to mild versus severe COVID-19 infection in humans." Science 369 (6508): 1210-1220. \url{https://doi.org/10.1126/science.abc6261}
\item \strong{Arunachalam_bulk_PBMC_moderate}: Arunachalam PS, Wimmers F, Mok CKP, et al. 2020. "Systems biological assessment of immunity to mild versus severe COVID-19 infection in humans." Science 369 (6508): 1210-1220. \url{https://doi.org/10.1126/science.abc6261}
\item \strong{Arunachalam_bulk_PBMC_severe}: Arunachalam PS, Wimmers F, Mok CKP, et al. 2020. "Systems biological assessment of immunity to mild versus severe COVID-19 infection in humans." Science 369 (6508): 1210-1220. \url{https://doi.org/10.1126/science.abc6261}
\item \strong{Arunachalam_bulk_PBMC_intensive_care}: Arunachalam PS, Wimmers F, Mok CKP, et al. 2020. "Systems biological assessment of immunity to mild versus severe COVID-19 infection in humans." Science 369 (6508): 1210-1220. \url{https://doi.org/10.1126/science.abc6261}
\item \strong{Dunning_bulk_WB_flu}: Dunning J, Blankley S, Hoang LT, et al. 2018. "Progression of whole-blood transcriptional signatures from interferon-induced to neutrophil-associated patterns in severe influenza." Nature Immunology 19 (6): 625-635. \url{https://doi.org/10.1038/s41590-018-0111-5}
}
}
\usage{
COVIDsignatures
}
\description{
A set of 47 COVID-19 gene signatures from various single-cell and bulk
RNA-seq publications and preprint manuscripts from early- to mid-2020.
This set of signatures uses gene symbols.
}
\details{
Signature names are composed of the last name of the primary author, followed
by the type of sequencing data from which the signature was derived, the
tissue from which the signature was derived, and ending with a reference to
the cell type, infection status, or disease to which the signature belongs,
as defined in the original publication.

Note that in some cases signatures will be positive identifiers of COVID-19
as positive markers of immune cell clusters are often provided for
single-cell RNA-seq data; this should be taken into account when creating
ROC curves and computing any AUC or disease risk estimates.
}
\examples{
data("COVIDsignatures")
}
\keyword{datasets}
